{$A+,B-,F+,G+,N+,P+,Q-,R-,T-,V+,X+}
{****************************************************************************
 * GX2 beta version - copyright (c) 1998-2000 by Stefan Goehler             *
 * Any bug reports and suggestions are welcome                              *
 * License agreement in gx2.txt - illegal copy without this file!           *
 * Complete package and new version always available here:                  *
 * http://sourcenet.home.pages.de                                           *
 ****************************************************************************}

{ Undefine here someting if you don't need it. The more you undefine, the
  less the resulting exe-file with GX2 sucks up... }
{$DEFINE hicolor}      { Around 7K }
{$DEFINE truecolor}    { Around 8K }
{-$DEFINE acceleration} { Hardware acceleration support }
{$DEFINE verbose}      { Put out some info at start           }
{$DEFINE asmtext}      { Use assembler font routines - faster }
{$IFNDEF hicolor}
{$IFNDEF truecolor}
  You need to enable at least one color mode support
{$ENDIF}
{$ENDIF}

{-$DEFINE noscreen} { If you don't require screen output, only memory interface }

{$IFNDEF DPMI}
  !Real mode not supported!
  This unit is fully 32 bit oriented, so forget about real mode.
  You need BP7 to use protected mode. If you have it, please
  switch at compiler/platform to PM (start bp.exe!)
{$ENDIF}

{

 Versions history now in history.txt

 Sooncoming changes:
 - MNG support (animated PNG images)
 - Font output extension
   - CHN8-Support
   - Italic scripting
 - faster polygon clipping
 - readln-like procedure
 - better and complete driver support
   - GetDeviceList (choose between drivers and/or GFX cards)

 Known bugs
 - PCX saver doesn't save correct with 24/32 bits in some cases
 - Doublesize_image doesn't calculate one pixel at the right and the bottom
 - Font rotation with vector-fonts works, but the position of the fonts
   gets more and more wrong the larger the angle
 - setcpuext in gx_glob doesn't work due a bug in the linked list - wasn't
   able to encounter it yet
 - png loader/saver don't support bpp < 4 and save greyscale files incorrect
 - color problems with bmp-fonts at size 2 in 32 bpp (probably already fixed)
 - Linestyle not supported in banked modes
 - TTF loader doesn't release 2K (Freetype bug, not mine!)

}
unit grafx2;
interface
uses newfrontier,gx_glob,gx_col,gx_image

     { Color mode drivers }
     {$IFDEF hicolor},drv_1516{$ENDIF}
     {$IFDEF truecolor},drv_2432{$ENDIF}

     { Video drivers      }
{$IFDEF acceleration}
     ,drv_s3
{$ENDIF}
{$IFNDEF NOSCREEN}
     ,drv_vesa
{$ENDIF}
     ;

const
  gx_versionstr = 'GX2 b2.0910.BP';
  gx_versionnum = $0200;
  gx_versionsubnum = $0910;

type
  tfailproc = procedure(code : word);

  pgrafx =^tgrafx;
  tgrafx = object
     { It's preferable that you DON'T access the mode-variable. If _really_
       required, then read-only                                             }
     mode      : tmode;
     onclose   : procedure;  { will be called with tgrafx.close  - use like }
                             { exitproc, but call old procedure if <> nil!  }
     maxx,maxy       : longint; { Maximum X/Y of used viewport         }
     centerx,centery : longint; { Center of the used viewport          }
     rgb       : function(r,g,b : byte) : longint;
     dergb     : procedure(col : longint;var rgb : trgb);
     function    getversionstring : string;
     function    gray(val : byte) : longint;
     procedure   clear;
     procedure   poly(num : word;var polypoints : array of tpoint;col,flags : longint);
     procedure   putpixel(x,y,col : longint);
     function    getpixel(x,y : longint) : longint;
     procedure   addpixel(x,y,col : longint);
     procedure   subpixel(x,y,col : longint);
     procedure   line(x1,y1,x2,y2,col,flags : longint);
     procedure   fillrect(x1,y1,x2,y2,col,flags : longint);
     procedure   fillpoly(num : word;var polypoints : array of tpoint;col,flags : longint);
     procedure   hline(x,y,width,col : longint);
     procedure   vline(x,y,height,col : longint);
     procedure   patternline(x,y,width,col,flags : longint);
     procedure   rect(x1,y1,x2,y2,col,flags : longint);
     procedure   fillcircle(x,y,r,col,flags : longint);
     procedure   fillellipse(x,y : longint;rx,ry : word;col,flags : longint);
     procedure   circle(px,py,r,col,flags : longint);
     procedure   ellipse(px,py,rx,ry,col,flags : longint);

     function    textheight(s : string) : word;
     function    textwidth(s : string) : word;
     procedure   write(x,y : longint;s : string;col : longint);
     function    getmaxcharheight : longint;
     function    getmaxcharwidth : longint;
     procedure   setfont(var font : tfont);
     function    getfont : pfont;
     procedure   setfontattributes(xalign,yalign,flags : longint);
     procedure   getfontattributes(var xalign,yalign,flags : longint);
     procedure   setfontsize(size : double);
     function    getfontsize : double;
     procedure   setfontangle(angle : double);
     function    getfontangle : double;

     procedure   setpattern(pattern : tpattern);
     procedure   getpattern(var pattern : tpattern);
     procedure   setlinestyle(style : longint);
     function    getlinestyle : longint;
     procedure   get(x1,y1,x2,y2 : longint;var image : timage);
     procedure   draw(x,y : longint;var image : timage;flags : longint);
     procedure   scale(px,py,sx,sy : longint;image : timage;flags : longint);
     procedure   bitblit(x1,y1,x2,y2,px,py : longint);
     procedure   drawline(x1,y1,sizex : longint;data : pointer48;bpp,flags : longint);
     procedure   getline(x1,y1,sizex : longint;data : pointer48;bpp : word);
     procedure   flood(x,y,col : longint);

     { Pixel procedures - don't access directly! }
     public
       proc_ap   : procedure(x,y,col : longint;alpha : byte;var mode : tmode);
       proc_pp   : procedure(x,y,col : longint;var mode : tmode);
       proc_gp   : function(x,y : longint;var mode : tmode) : longint;
       proc_addp   : procedure(x,y,col : longint;var mode : tmode);
       proc_subp   : procedure(x,y,col : longint;var mode : tmode);

     private
     { Primitive procedures }
     proc_line      : procedure(x1,y1,x2,y2,col : longint;var mode : tmode);
     proc_fillrect  : procedure(x1,y1,sizex,sizey,col,flags : longint);
     proc_hline     : procedure(x,y,width,col : longint;var mode : tmode);
     proc_vline     : procedure(x,y,height : integer;col : longint;var mode : tmode);
     proc_patternln : procedure(x,y,width  : integer;col,flags : longint;var mode : tmode);
     { Imaging procedures }
     proc_dr_curr : procedure(x,y : longint;image : timage;flags : longint;var mode : tmode);
     proc_dr_conv : procedure(x,y : longint;image : timage;flags : longint;var mode : tmode);
{     proc_dr_rle  : procedure(x,y : longint;image : timage;flags : longint;var mode : tmode);}
     proc_gt_curr : procedure(x1,y1,x2,y2 : longint;image : timage;var mode : tmode);
     proc_bitblit : procedure(x1,y1,x2,y2,dx,dy : longint);
     proc_scale   : procedure(image : timage;px,py,sx,sy,flags : longint;var mode : tmode);
     proc_clear   : procedure;
     procedure   aaline(x1,y1,x2,y2 : longint;col : longint);
     constructor init;
     destructor  close;
  end;

  {$IFNDEF NOSCREEN}
  pgxscreen = ^tgxscreen;
  tgxscreen = object(tgrafx)
     pagewait  : boolean; { Call pageretrace after setvisiblepage }
     constructor init(xres,yres,bpp : longint;flags : longint);
     function    setdrawpage(page : longint) : word;
     function    setvisiblepage(page : longint) : word;
     function    setdisplaystart(x,y : longint) : word;
     function    setvirtualscreenwidth(width : longint) : word;
     function    resetscreenwidth : word;
     function    setfullviewport : word;
     function    resetviewport : word;
     procedure   copypage(srcpage,destpage : longint);
     destructor  close;
     private
     mode_open : boolean;
  end;
  {$ENDIF}

  pgxmem    = ^tgxmem;
  tgxmem    = object(tgrafx)
     imgptr    : ^timage;    { Pointer to the used image }
     constructor init(var image : timage);
     destructor  close;
  end;

  pgxwindow = ^tgxwindow;
  tgxwindow = object(tgrafx)
     father : pgrafx;
     constructor init(x1,y1,x2,y2 : longint;var screen : tgrafx);
     destructor  close;
     procedure   clear;
     function    move(x,y : longint) : word;
     function    resize(xsize,ysize : longint) : word;
     procedure   setclipping(x1,y1,x2,y2 : longint);
     procedure   getclipping(var viewport : tviewport);
  end;

  function    openimage(var image : timage;sx,sy,bipp,images : word;flags : longint) : word;
  function    setsubimage(var image : timage;subimage : word) : word;
  function    convertimage(source : timage;var dest : timage;destbpp : word) : word;
  function    duplicateimage(source : timage;var dest : timage) : word;
  function    flipimage(source : timage;var dest : timage) : word;
{  function    copy_image(source : timage;dest : timage) : word;}
  function    imageopen(image : timage) : boolean;
  procedure   clearimage(image : timage;col : longint);
  function    closeimage(var image : timage) : word;
  function    pointertoimage(p : pointer;var image : timage) : word;
  { Error Handling procedures }
  function    geterrorstring(code : word) : string;
  procedure   setfailproc(proc : tfailproc);
  procedure   check4fail_std(code : word);
var
  check4fail : tfailproc;


implementation

function tgrafx.gray(val : byte) : longint;
begin
  gray := rgb(val,val,val);
end;

procedure tgrafx.putpixel(x,y,col : longint);assembler;
asm
  db 66h;push   x.word
  db 66h;push   y.word
  db 66h;push   col.word
  les           di,self
  push          es
  push          di
  call          es:[di].proc_pp
end;

function tgrafx.getpixel(x,y : longint) : longint;assembler;
asm
  db 66h;push   x.word
  db 66h;push   y.word
  les           di,self
  push          es
  push          di
  call          es:[di].proc_gp
end;

procedure tgrafx.addpixel(x,y,col : longint);assembler;
asm
  db 66h;push   x.word
  db 66h;push   y.word
  db 66h;push   col.word
  les           di,self
  push          es
  push          di
  call          es:[di].proc_addp
end;

procedure tgrafx.subpixel(x,y,col : longint);assembler;
asm
  db 66h;push   x.word
  db 66h;push   y.word
  db 66h;push   col.word
  les           di,self
  push          es
  push          di
  call          es:[di].proc_subp
end;

procedure tgrafx.hline(x,y,width,col : longint);assembler;
asm
  db 66h;push   x.word
  db 66h;push   y.word
  db 66h;push   width.word
  db 66h;push   col.word
  les    di,self
  push   es
  push   di
  call   es:[di].proc_hline
end;

procedure tgrafx.patternline(x,y,width,col,flags : longint);assembler;
asm
  push   x.word
  push   y.word
  push   width.word
  db 66h;push   col.word
  db 66h;push   flags.word
  les    di,self
  push   es
  push   di
  call   es:[di].proc_patternln
end;

procedure tgrafx.vline(x,y,height,col : longint);assembler;
asm
  push   x.word
  push   y.word
  push   height.word
  db 66h;push   col.word
  les    di,self
  push   es
  push   di
  call   es:[di].proc_vline
end;

procedure tgrafx.rect(x1,y1,x2,y2,col,flags : longint);
begin
  if (mode.linestyle = $FFFFFFFF)and(flags = 0) then begin
    proc_hline(x1,y1,x2-x1+1,col,mode);
    proc_vline(x1,y1,y2-y1,col,mode);
    proc_vline(x2,y1,y2-y1,col,mode);
    proc_hline(x1,y2,x2-x1+1,col,mode);
  end else begin
    proc_line(x1,y1,x2,y1,col,mode);
    proc_line(x1,y1,x1,y2,col,mode);
    proc_line(x2,y1,x2,y2,col,mode);
    proc_line(x1,y2,x2,y2,col,mode);
  end;
end;

procedure calcellipse(buffer : pointer;rx,ry : longint);assembler;
var
  dx1,dy1 : longint;
asm
         les   di,buffer
         mov   ax,rx.word
         mov   si,ax
  db 66h;xor   di,di
  db 66h;mov   ax,rx.word
  db 66h;mul   ax
  db 66h;add   ax,ax
  db 66h;mov   dx1.word,ax
  db 66h;mov   ax,ry.word
  db 66h;mul   ax
  db 66h;mov   cx,ax
  db 66h;add   ax,ax
  db 66h;mov   dy1.word,ax
  db 66h;mov   ax,rx.word
  db 66h;mul   cx
  db 66h;mov   cx,ax
  db 66h;add   ax,ax
  db 66h;mov   dx,ax
         mov   bx,ry.word
         add   bx,bx
         mov   ax,si
         neg   ax
@lx:
  db 66h;cmp   cx,0
         jle   @l1
  db 66h;add   di,dx1.word
  db 66h;sub   cx,di
         sub   bx,2
         mov   es:[bx].word,ax
         jmp   @lx
@l1:
  db 66h;sub   dx,dy1.word
  db 66h;add   cx,dx
         inc   ax
         mov   es:[bx].word,ax
         dec   si
         jnz   @lx
end;

procedure tgrafx.fillcircle(x,y,r,col,flags : longint);
var
  i     : longint;
  point : longint;
begin
  if (r > gfxbufsize shr 1)or(r = 0) then exit;
  dec(y,r);
  calc_circle(gfxbufptr,r);
  for i := 0 to r-1 do begin
    point := readmem32w(ptr48(gfxbufsel,i shl 1));
    patternline(x-point,y,point shl 1,col,flags);
    inc(y);
  end;
  for i := r-1 downto 0 do begin
    point := readmem32w(ptr48(gfxbufsel,i shl 1));
    patternline(x-point,y,point shl 1,col,flags);
    inc(y);
  end;
end;

procedure tgrafx.fillellipse(x,y : longint;rx,ry : word;col,flags : longint);
{draws a filled circle}
var
  i     : longint;
  point : longint;
begin
  if (ry > 32768)or(rx = 0)or(ry = 0) then exit;
  dec(y,ry);
  calcellipse(gfxbufptr32,rx,ry);
{  calc_ellipse(gfxbufptr,rx,ry);}
  for i := 0 to ry-1 do begin
    point := readmem32w(ptr48(gfxbufsel,i shl 1));
    patternline(x-point,y,point shl 1,col,flags);
    inc(y);
  end;
  for i := ry-1 downto 0 do begin
    point := readmem32w(ptr48(gfxbufsel,i shl 1));
    patternline(x-point,y,point shl 1,col,flags);
    inc(y);
  end;
end;

function fixedDiv(d1,d2:longint):longint;
inline(
  $66/$59/               {pop ecx}
  $58/                   {pop ax}
  $5A/                   {pop dx}
  $66/$0F/$BF/$D2/       {movsx edx,dx}
  $66/$C1/$E0/$10/       {shl eax,16}
  $66/$F7/$F9/           {idiv ecx}
  $66/$0F/$A4/$C2/$10);  {shld edx,eax,16}   {no rounding}

procedure tgrafx.fillpoly(num : word;var polypoints : array of tpoint;col,flags : longint);
type
  fixed=record case byte of
    0:(f:word;i:integer);
    1:(l:longint);
  end;
var
  i,l,r,lv,rv,top,bottom,topVert : integer;
  lstep,lpos,rstep,rpos          : fixed;
  ldest,rdest                    : tpoint;
begin
  if (num < 3) or (num > 8191) then exit;
  topVert := num-1;
  top     := polypoints[topVert].y;
  bottom  := top;
  for i := num-2 downto 0 do if (polypoints[i].y < top) then
  begin
    top     := polypoints[i].y;
    topVert := i;
  end else if (polypoints[i].y > bottom) then bottom := polypoints[i].y;

  if bottom > mode.maxy then bottom := mode.maxy;

  if top > bottom then exit;
  lv    := topVert;
  rv    := topVert;
  ldest := polypoints[topVert];
  rdest := ldest;
  i     := top;
  repeat
    if i >= ldest.y then begin
      lpos.f := 0;
      lpos.i := ldest.x;
      dec(lv);
      if lv < 0 then lv := num-1;
      ldest := polypoints[lv];
      if ldest.y = i then begin
        if ldest.x < lpos.i then lpos.i := ldest.x;
        lstep.l := 0;
      end
      else lstep.l := fixedDiv(ldest.x-lpos.i,ldest.y-i);
    end;
    if i >= rdest.y then begin
      rpos.f := 0;
      rpos.i := rdest.x;
      inc(rv);
      if rv >= num then rv := 0;
      rdest := polypoints[rv];
      if rdest.y = i then begin
        if rdest.x > rpos.i then rpos.i := rdest.x;
        rstep.l := 0;
      end
      else rstep.l := fixedDiv(rdest.x-rpos.i,rdest.y-i);
    end;
    proc_patternln(lpos.i,i,rpos.i-lpos.i+1,col,flags,mode);
    inc(lpos.l,lstep.l);
    inc(rpos.l,rstep.l);
    inc(i);
  until i > bottom;
end;

(*procedure tgrafx.fillpoly(num : word;var polypoints : array of tpoint;col,flags : longint);
type
	pedge = ^edge;
	edge = packed record  { an edge structure }
		next : pedge;       { linked list pointer }
		mempos : longint;   { position of this edge in AET memory table }
		x,				          { current x-coordinate on the edge }
		dx : double;        { deltax of the edge }
		i : longint;        { index to which points this edge belongs to
		                      always [i] and [i+1] }
	end;

	{ used for typecasting because TP/BP is more strict here than FPC }
	pedgearray = ^edgearray;
	edgearray = array[0..0] of edge;

	pint = ^longint;

	pintarray = ^intarray;
	intarray = array[0..0] of longint;

	pboolarray = ^boolarray;
	boolarray = array[0..0] of boolean;

	ppointtype = ^tpoint;
	ppointarray = ^pointarray;
	pointarray = array[0..0] of tpoint;

{ definition of the called compare routine for the sort process. Returns -1 if
 the two parameters should be swapped }
{type
	compareproc = function (a, b : pointer) : longint;

{ simple bubblesort, since it is expected that the edges themselves are not
  too mixed, it is fastest (?). Rather than sorting the active edge table
  this way, it is recommened to implement this using a linked list (not
  nearly as much memory is transfered then) }
{ needed for the compare functions; should NOT be used for anything else }
var
	ptable : ppointarray; { pointer to points list }

function compare_ind(a, b : pointer) : longint; far;
begin
	if (ptable^[pint(a)^].y <= ptable^[pint(b)^].y) then compare_ind := -1
	else compare_ind := 1;
end;

procedure bsort(p : pointer; number : integer; sizeelem : integer);
var i : longint;
	swap : boolean;
	temp : pointer48;

	curp, nextp : pointer;
begin
	{getmem(temp, sizeelem);}
  temp := ptr48(gfxbufsel,65536);
	repeat
		curp := p;
		nextp := pointer(longint(p) + sizeelem);
		swap := false;
		for i := 0 to (number-2) do begin
			if (compare_ind(curp, nextp)=1) then begin
				{ swap elements, you can't do it slower ;( }
				move2(farptr(curp),temp,sizeelem);
				move2(farptr(nextp),farptr(curp), sizeelem);
				move2(temp,farptr(nextp), sizeelem);
				swap := true;
			end;
			inc(longint(curp), sizeelem);
			inc(longint(nextp), sizeelem);
		end;
		dec(number);
	until (swap = false) or (number = 0);
	{freemem(temp, sizeelem);}
end;

{ guess what this does }
function ceil(x : double) : longint;
var t : longint;
begin
	t:=Trunc(x);
	If frac(x)>0 then inc(t);
	ceil := t;
end;

{ guess what this does too }
function floor(x : double) : longint;
var t : longint;
begin
	t:=Trunc(x);
	If frac(x)<0 then dec(t);
	floor := t;
end;

{ simple descriptive name }
function max(a, b : longint) : longint;
begin
	if (a > b) then max := a
	else max := b;
end;

{ here too }
function min(a, b : longint) : longint;
begin
	if (a < b) then min := a
	else min := b;
end;

{ variables needed within the helper procedures too }
var
	activetable : pedgearray; { active edge table, e.g. edges crossing current scanline }
	activepoints : longint; { number of points in active edge table }

	AEThead : pedge; { pointer to the first active edge in the AET memory }
	AETmemtable : pboolarray; { AET used memory table; each 'true' means that
								the i-th edge record in the active table is
								currently in use. Hence a 'false' denotes that
								it can be overwritten }

{ remove edge i from active edge table }
procedure cdelete(index : longint);
var
	j : longint;
	curedge, prevedge : pedge;
begin
	prevedge := nil;
	curedge := AEThead;
	{ check for wrong input values (may happen in the case when a segment is
	  at the clipping border) }
	if (curedge = nil) or (activepoints = 0) then exit;

	while (curedge^.i <> index) and (curedge^.next <> nil) do begin
		prevedge := curedge;
		curedge := curedge^.next;
	end;
	{ again, check if the edge wasn't found at all }
	if (curedge^.i <> index) then exit;
	{ link into AET memory }
	if (curedge = AEThead) then begin
		AEThead := curedge^.next;
	end else begin
		prevedge^.next := curedge^.next;
	end;
	AETmemtable^[curedge^.mempos] := false;
	{ for debugging purposes (it's easier to work with that) }
	dec(activepoints);
end;

{ insert edge index into active edge table (already sorted !) }
procedure cinsert(index, y : longint);
var
	j : longint;
	deltax : double;
	p, q : ppointtype;

	curedge, prevedge : pedge;
	newpos : longint;
begin
	newpos := 0;
	{ search for free memory in active table memory space (activetable) }
	while (AETmemtable^[newpos]) do inc(newpos);
	{ calculate the record vars used for drawing and fill them in }
	if (index < (num-1)) then j := index + 1 else j := 0;

	if (polypoints[index].y < polypoints[j].y) then begin
		p := @polypoints[index];
		q := @polypoints[j];
	end else begin
		p := @polypoints[j];
		q := @polypoints[index];
	end;
	deltax := (q^.x-p^.x)/(q^.y-p^.y);

	with activetable^[newpos] do begin
		dx := deltax;
		x := dx * (y { + 0.5 } - p^.y) + p^.x;
		i := index;
		mempos := newpos;
	end;
	{ link into list of edges }
	prevedge := nil;
	curedge := AEThead;
	if (curedge = nil) then begin
		AEThead := @activetable^[newpos];
		activetable^[newpos].next := nil;
	end else begin
		while (curedge <> nil) and (curedge^.x <= activetable^[newpos].x) do begin
			prevedge := curedge;
			curedge := curedge^.next;
		end;
		if (prevedge = nil) then begin
			activetable^[newpos].next := AEThead;
			AEThead := @activetable^[newpos];
		end else begin
			activetable^[newpos].next := prevedge^.next;
			prevedge^.next := @activetable^[newpos];
		end;
	end;
	{ reserve memory }
	AETmemtable^[newpos] := true;
	inc(activepoints);
end;

{ variables for the main procedure }
var
	k, i, j : longint;
	starty, endy, y, xl, xr : longint;
	curedge : pedge;
var
	indextable : pintarray; { list of vertex indices, sorted by y }

begin
	ptable := @polypoints;
	if (num<=0) then exit;

  if sizeof(longint)*num+sizeof(edge)*num+sizeof(boolean)*num > 65535 then exit;
{	getmem(indextable, sizeof(longint) * num);
	getmem(activetable, sizeof(edge) * num);
	getmem(AETmemtable, sizeof(boolean) * num);}
  indextable  := ptr(gfxbufsel,0);
  activetable := ptr(gfxbufsel,sizeof(longint)*num);
  AETmemtable := ptr(gfxbufsel,sizeof(longint)*num+sizeof(edge)*num);
	{ initialize AET memory table to all clear }
	{ create y-sorted array of indices indextable[k] into vertex list }
	for k := 0 to (num-1) do begin
		AETmemtable^[k] := false;
		indextable^[k] := k;
	end;
	AEThead := nil;

	{ sort the indextable by points[indextable[k]].y }
	bsort(indextable, num, sizeof(longint));
	{ start with empty active edge table }
	activepoints := 0;
	{ indextable[k] is the next vertex to process }
	k := 0;
	{ ymin of polygon }
	starty := max(mode.actviewport.y1, ceil(polypoints[indextable^[0]].y-0.5));
	{ ymax of polygon }
	endy := min(mode.actviewport.y2, floor(polypoints[indextable^[num-1]].y-0.5));

	{ step through scanlines }
	j := random(16);
	for y := starty to endy do begin
		{ check vertices between previous scanline and current one, if any }
		while (k < num) and (polypoints[indextable^[k]].y<=(y+0.5)) do begin
			i := indextable^[k];
			{ insert or delete edges before and after points[i] ((i-1) to i and
			  i to (i+1)) from active edge table if they cross scanline y }
			{ point previous to i }
			if (i > 0) then j := i-1 else j := num-1;
			{ old edge, remove from list }
			if (polypoints[j].y <= (y-0.5)) then cdelete(j)
			{ new edge, add to active edges }
			else if (polypoints[j].y > (y + 0.5)) then cinsert(j, y);

			{ point next after i }
			if (i < (num-1)) then j := i+1 else j := 0;
			{ old edge, remove from active edge table }
			if (polypoints[j].y <= (y - 0.5)) then cdelete(i)
			{ new edge, add to active edges }
			else if (polypoints[j].y > (y + 0.5)) then cinsert(i, y);
			inc(k);
		end;
		curedge := AEThead;
		{ draw horizontal segments for scanline y }
		while (curedge <> nil) do begin
			xl := trunc(curedge^.x-0.5);
			if frac(curedge^.x-0.5)>0 then inc(xl);
			if (xl < mode.actviewport.x1) then xl := mode.actviewport.x1;

			xr := trunc((curedge^.next)^.x-0.5);
			if frac((curedge^.next)^.x-0.5)<0 then dec(xr);
			if (xr > mode.actviewport.x2) then xr := mode.actviewport.x2;

			if (xl <= xr) then
        hline(xl, y, abs(xr-xl)+1,col);
			{ increment both edges' coordinates }
			with curedge^ do begin
				x := x + dx;
			end;
			curedge := curedge^.next;
			with curedge^ do begin
				x := x + dx;
			end;
			curedge := curedge^.next;
		end;
	end;
{	freemem(AETmemtable, sizeof(boolean) * num);
	freemem(activetable, sizeof(edge) * num);
	freemem(indextable, sizeof(longint) * num);}
end;*)


procedure tgrafx.line(x1,y1,x2,y2,col,flags : longint);
type
  edge = (left,right,bottom,top);
  outcode = set of edge;
var
  accept,done                  : boolean;
  outcode0,outcode1,outcodeout : outcode;
  x,y                          : longint;

  procedure compoutcode(x,y : single;var code : outcode);
  begin
    code := [];
    if y > mode.maxy then code := [top]
    else if y < 0 then code := [bottom];
    if x > mode.maxx then code := code+[right]
    else if x < 0 then code := code+[left];
  end;
begin
  accept := false;
  done   := false;
  compoutcode(x1,y1,outcode0);
  compoutcode(x2,y2,outcode1);
  repeat
    if (outcode0 = [])and(outcode1 = []) then begin
      accept := true;
      done   := true;
    end else if outcode0*outcode1 <> [] then
    done := true else
    begin
      if outcode0 <> [] then
      outcodeout := outcode0 else outcodeout := outcode1;

      if top in outcodeout then begin
        x := x1+(x2-x1)*(mode.maxy-y1) div (y2-y1);
        y := mode.maxy;
      end else if bottom in outcodeout then begin
        x := x1+(x2-x1)*(-y1) div (y2-y1);
        y := 0;
      end else if right in outcodeout then begin
        x := mode.maxx;
        y := y1+(y2-y1)*(mode.maxx-x1) div (x2-x1);
      end else if left in outcodeout then begin
        x := 0;
        y := y1+(y2-y1)*(-x1) div (x2-x1);
      end;
      if (outcodeout = outcode0) then begin
        x1 := x;
        y1 := y;
        compoutcode(x1,y1,outcode0);
      end else begin
        x2 := x;
        y2 := y;
        compoutcode(x2,y2,outcode1);
      end;
    end;
  until done;
  if accept then begin
  if (flags and lnantialias = 0) then
   proc_line(x1+mode.actviewport.x1,y1+mode.actviewport.y1,
             x2+mode.actviewport.x1,y2+mode.actviewport.y1,col,mode)
   else
   aaline(x1+mode.actviewport.x1,y1+mode.actviewport.y1,
          x2+mode.actviewport.x1,y2+mode.actviewport.y1,col);
  end;
end;

procedure tgrafx.aaline(x1,y1,x2,y2 : longint;col : longint);
var
  x,y,xd,yd     : longint;
  val           : byte;
  csplit        : trgb;
  grad,xf,yf    : longint;
  stylecounter  : longint;

function backshift(val : longint) : word;assembler;
asm
  db 66h;mov   ax,val.word
  db 66h;dec   ax
  db 66h;shr   ax,16
  db 66h;adc   ax,0;dw 0
end;

begin
  dergb(col,csplit);
  xd := (x2-x1);
  yd := (y2-y1);
  stylecounter := 1;
  if abs(xd) > abs(yd) then begin
    if x1 > x2 then begin
      swaplong(x1,x2);
      swaplong(y1,y2);
      xd := (x2-x1);
      yd := (y2-y1);
    end;
    if (xd <> 0) then grad := yd shl 16 div xd else grad := 0;
    yf   := longint(y1) shl 16-32767;
    for x := x1 to x2 do begin
      val := (32767+yf and $FFFF) shr 8;
      if (stylecounter and mode.linestyle <> 0) then begin
        proc_ap(x,backshift(yf),csplit.l,255-val,mode);
        proc_ap(x,backshift(yf)+1,csplit.l,val,mode);
      end;
      asm
        db 66h;mov   ax,stylecounter.word
        db 66h;add   ax,ax
        db 66h;adc   ax,0;db 00h,00h
        db 66h;mov   stylecounter.word,ax
        db 66h;mov   ax,grad.word
        db 66h;add   yf.word,ax
      end;
    end;
  end else begin
    if y1 > y2 then begin
      swaplong(x1,x2);
      swaplong(y1,y2);
      xd := (x2-x1);
      yd := (y2-y1);
    end;
    if (yd <> 0) then grad := xd shl 16 div yd else grad := 0;
    xf   := longint(x1) shl 16+32767;
    for y := y1 to y2 do begin
      val := (32767+xf and $FFFF) shr 8;
      if (stylecounter and mode.linestyle <> 0) then begin
        proc_ap(backshift(xf)-1,y,csplit.l,255-val,mode);
        proc_ap(backshift(xf),y,csplit.l,val,mode);
      end;
      asm
        db 66h;mov   ax,stylecounter.word
        db 66h;add   ax,ax
        db 66h;adc   ax,0;db 00h,00h
        db 66h;mov   stylecounter.word,ax
        db 66h;mov   ax,grad.word
        db 66h;add   xf.word,ax
      end;
    end;
  end;
end;

procedure tgrafx.fillrect(x1,y1,x2,y2,col,flags : longint);
var
  i,i3,y       : word;
  mempos       : longint;
  memptr       : pointer48;
  fill         : procedure(dest : pointer48;count,vaule : longint);
  fillpatt     : procedure(dest : pointer48;count,value : longint;xpos : byte;pattern : byte);
  sizex,sizey  : longint;
label
  endofproc;
begin
  asm
           les   di,self
    db 66h;xor   si,si
    db 66h;mov   ax,x1.word
    db 66h;mov   si,x2.word
    db 66h;mov   cx,es:[di].mode.actviewport.x1.word
    db 66h;mov   dx,es:[di].mode.actviewport.x2.word
    db 66h;cmp   ax,si
           jng   @na_x1x2
    db 66h;xchg  ax,si
    @na_x1x2:
    db 66h;add   ax,cx
    db 66h;add   si,cx
    db 66h;cmp   ax,dx
           jg    endofproc
    db 66h;cmp   si,cx
           jl    endofproc
    db 66h;cmp   ax,cx
           jnl   @nb_x1
    db 66h;mov   ax,cx
    @nb_x1:
    db 66h;cmp   si,dx
           jng   @nb_x2
    db 66h;mov   si,dx
    @nb_x2:
    db 66h;sub   si,ax
    db 66h;inc   si
{    db 66h;push  ax}
    db 66h;mov   x1.word,ax

    db 66h;xor   ax,ax
    db 66h;mov   ax,y1.word
    db 66h;mov   bx,y2.word
    db 66h;mov   cx,es:[di].mode.actviewport.y1.word
    db 66h;mov   dx,es:[di].mode.actviewport.y2.word
    db 66h;cmp   ax,bx
           jng   @na_y1y2
    db 66h;xchg  ax,bx
    @na_y1y2:
    db 66h;add   ax,cx
    db 66h;add   bx,cx
    db 66h;cmp   ax,dx
           jg    endofproc
    db 66h;cmp   bx,cx
           jl    endofproc
    db 66h;cmp   ax,cx
           jnb   @nb_y1
    db 66h;mov   ax,cx
           @nb_y1:
    db 66h;cmp   bx,dx
           jng   @nb_y2
    db 66h;mov   bx,dx
           @nb_y2:
    db 66h;sub   bx,ax

    db 66h;mov   y1.word,ax
    db 66h;mov   sizex.word,si
    db 66h;mov   sizey.word,bx

{    db 66h;push  ax
    db 66h;push  si
    db 66h;push  bx
    db 66h;push col.word
    db 66h;push flags.word
           push  es
           push  di
           call  es:[di].proc_fillrect}
{  @end:}
  end;

  if @proc_fillrect <> nil then
   if ((flags = 0)or(flags and fillxor <> 0))and(mode.pattern[0] = 1)
   then
   begin
     proc_fillrect(x1,y1+mode.pageadd,sizex,sizey,col,flags);
     exit;
   end;

  sizex := sizex*mode.pixel;
  if (mode.flags and mdlinear = 0) then
   mempos := mode.calcofs(x1,y1+mode.pageadd,mode)
   else memptr := ptr48(mode.writeptr,mode.calcofs(x1,y1,mode)+mode.displayofs);
  if mode.pattern[0] = 1 then begin
    case flags shr 24 of
      $00 : case mode.bpp of
              15 : fill := fill16screen;
              16 : fill := fill16screen;
              24 : fill := fill24screen;
              32 : fill := fill32screen;
            end;
      $01 : case mode.bpp of
              15 : fill := subfill_15;
              16 : fill := subfill_16;
              24 : fill := subfill_24_386;
              32 : fill := subfill_32;
            end;
      $02 : case mode.bpp of
              15 : fill := addfill_15;
              16 : fill := addfill_16;
              24 : fill := addfill_24_386;
              32 : fill := addfill_32;
            end;
      $04 : case mode.bpp of
              15 : fill := fillxor_1516;
              16 : fill := fillxor_1516;
              24 : fill := fillxor_24_386;
              32 : fill := fillxor_32;
            end;
      else exit;
    end;

    if (mode.flags and mdlinear <> 0) then
    for y := y1 to y1+sizey do begin
       fill(memptr,sizex,col);
       inc(tselofs32(memptr).offset32,mode.bpl);
    end
    else
    for i := y1 to y1+sizey do begin
      if word(mempos) < word(mempos)+word(sizex) then begin
        fill(ptr48(mode.writeptr,word(mempos)),sizex,col);
        asm
          les   di,self
          mov   ax,es:[di].tmode.bpl.word
          add   mempos.word,ax
          jnc   @next
            call   incbank
          @next:
        end;
      end
      else begin
        i3 := -word(mempos);
        fill(ptr48(mode.writeptr,word(mempos)),i3,col);
        incbank;
        fill(ptr48(mode.writeptr,0),(sizex-i3),col);
        inc(word(mempos),mode.bpl);
      end;
    end
  end else begin
    case flags shr 24 of
      $00 : case mode.bpp of
              15 : fillpatt := fillpatt_1516;
              16 : fillpatt := fillpatt_1516;
              24 : fillpatt := fillpatt_24;
              32 : fillpatt := fillpatt_32;
            end;
      $01 : case mode.bpp of
              15 : fillpatt := pattsub_15;
              16 : fillpatt := pattsub_16;
              24 : fillpatt := pattsub_24_386;
              32 : fillpatt := pattsub_32;
            end;
      $02 : case mode.bpp of
              15 : fillpatt := pattadd_15;
              16 : fillpatt := pattadd_16;
              24 : fillpatt := pattadd_24_386;
              32 : fillpatt := pattadd_32;
            end;
      $04 : case mode.bpp of
              15 : fillpatt := pattxor_1516;
              16 : fillpatt := pattxor_1516;
              24 : fillpatt := pattxor_24_386;
              32 : fillpatt := pattxor_32;
            end;
      else exit;
    end;
    if (mode.flags and mdlinear <> 0) then
    for y := y1 to y1+sizey do begin
       fillpatt(memptr,sizex,col,x1,mode.pattern[y and 7+1]);
       inc(tselofs32(memptr).offset32,mode.bpl);
    end
    else
    for i := y1 to y1+sizey do begin
      if word(mempos) < word(mempos)+word(sizex) then begin
        fillpatt(ptr48(mode.writeptr,word(mempos)),sizex,col,x1,mode.pattern[i and 7+1]);
        asm
          les   di,self
          mov   ax,es:[di].tmode.bpl.word
          add   mempos.word,ax
          jnc   @next
            call   incbank
          @next:
        end;
      end
      else begin
        i3 := -word(mempos);
        fillpatt(ptr48(mode.writeptr,word(mempos)),i3,col,x1,mode.pattern[i and 7+1]);
        incbank;
        fillpatt(ptr48(mode.writeptr,0),sizex-i3,col,word(mempos)-i3,mode.pattern[i and 7+1]);
        inc(word(mempos),mode.bpl);
      end;
    end;
  end;
  endofproc:
end;
{var
  sizex,sizey : longint;
begin
  if y1 > y2 then swaplong(y1,y2);
  if x1 > x2 then swaplong(x1,x2);

  if (y1 > maxy)or(y2 < 0) then exit;
  if (x1 > maxx)or(x2 < 0) then exit;
  if x1 < 0 then x1 := 0;
  if x2 > maxx then x2 := maxx;
  if y1 < 0 then y1 := 0;
  if y2 > maxy then y2 := maxy;

  sizex := succ(abs(x2-x1));
  if sizex = 0 then exit;
  sizey := abs(y2-y1);
  proc_fillrect(x1+mode.actviewport.x1,y1+mode.actviewport.y1,
                sizex,sizey,col,flags,mode);
end;}

procedure tgrafx.circle(px,py,r,col,flags : longint);
var
  { Normal circle variables      }
  a,b,d           : longint;
  stylecounter    : longint;
  mx,my           : array[0..3] of longint;
  { Antialiased circle variables }
  csplit       : trgb;
  count         : word;
  val           : word;
const
  smoothing = 4;
  remain    = 8-smoothing;
  mask      = (1 shl smoothing)-1;

begin
  inc(px,mode.actviewport.x1);
  inc(py,mode.actviewport.y1);
  stylecounter := 1;
  if r > 1 then begin
    if (flags and lnantialias = 0) then begin { Normal circle }
      a := 0;
      b := r;
      d := 1-r;

      if stylecounter and mode.linestyle <> 0 then begin
        proc_pp(px,py-r,col,mode);
        proc_pp(px-r,py,col,mode);
        proc_pp(px+r,py,col,mode);
        proc_pp(px,py+r,col,mode);
      end;
      while b >= a do begin
        if d < 0 then begin
          inc(d,a shl 1 + 3);
          inc(a);
        end else begin
          inc(d,(a - b) shl 1 + 5);
          inc(a);
          dec(b);
        end;
        asm
          db 66h;mov   ax,stylecounter.word
          db 66h;add   ax,ax
          db 66h;adc   ax,0;db 00h,00h
          db 66h;mov   stylecounter.word,ax
        end;
        if stylecounter and mode.linestyle <> 0 then begin
          proc_pp(px+b,py-a,col,mode);
          proc_pp(px-b,py-a,col,mode);
          proc_pp(px+a,py-b,col,mode);
          proc_pp(px-a,py-b,col,mode);
          proc_pp(px+a,py+b,col,mode);
          proc_pp(px-a,py+b,col,mode);
          proc_pp(px+b,py+a,col,mode);
          proc_pp(px-b,py+a,col,mode);
        end;
      end;
    end else begin { Antialiased circle }
      dergb(col,csplit);
      if stylecounter and mode.linestyle <> 0 then begin
        proc_pp(px,py-r,col,mode);
        proc_pp(px-r,py,col,mode);
        proc_pp(px+r,py,col,mode);
        proc_pp(px,py+r,col,mode);
      end;
      r := r shl smoothing;
      a := 0;
      b := r;
      d := 1-r;
      count := 0;
      while b >= a do begin
        for count := mask downto 0 do
        if d < 0 then begin
          inc(d,a shl 1 + 3);
          inc(a);
        end else begin
          inc(d,(a - b) shl 1 + 5);
          inc(a);
          dec(b);
        end;
        asm
          db 66h;mov   ax,stylecounter.word
          db 66h;add   ax,ax
          db 66h;adc   ax,0;db 00h,00h
          db 66h;mov   stylecounter.word,ax
        end;
        if stylecounter and mode.linestyle <> 0 then begin
          val := (b and mask) shl remain;
          mx[0] := px+a shr smoothing;
          mx[1] := px-a shr smoothing;
          mx[2] := px+b shr smoothing;
          mx[3] := px-b shr smoothing;

          my[0] := py+a shr smoothing;
          my[1] := py-a shr smoothing;
          my[2] := py+b shr smoothing;
          my[3] := py-b shr smoothing;

          proc_ap(mx[0],pred(my[3]),csplit.l,val,mode);
          proc_ap(mx[0],my[3],csplit.l,255-val,mode);
          proc_ap(mx[1],pred(my[3]),csplit.l,val,mode);
          proc_ap(mx[1],my[3],csplit.l,255-val,mode);
          proc_ap(pred(mx[3]),my[1],csplit.l,val,mode);
          proc_ap(mx[3],my[1],csplit.l,255-val,mode);
          proc_ap(mx[2],my[1],csplit.l,255-val,mode);
          proc_ap(succ(mx[2]),my[1],csplit.l,val,mode);
          proc_ap(mx[2],my[0],csplit.l,255-val,mode);
          proc_ap(succ(mx[2]),my[0],csplit.l,val,mode);
          proc_ap(mx[3],my[0],csplit.l,255-val,mode);
          proc_ap(pred(mx[3]),my[0],csplit.l,val,mode);
          proc_ap(mx[0],succ(my[2]),csplit.l,val,mode);
          proc_ap(mx[0],my[2],csplit.l,255-val,mode);
          proc_ap(mx[1],succ(my[2]),csplit.l,val,mode);
          proc_ap(mx[1],my[2],csplit.l,255-val,mode);
        end;
      end;
    end;
  end else if r = 1 then proc_pp(px,py,col,mode);
end;


procedure tgrafx.ellipse(px,py,rx,ry,col,flags : longint);
var
  x,mx1,mx2,my1,my2 : longint;
  aq,bq,dx,dy,r,a,b : longint;
  stylecounter      : longint;
  csplit            : trgb;

const
  smoothing = 4;
  remain    = 8-smoothing;
  mask      = (1 shl smoothing)-1;
  smoothmul = 1 shl smoothing;

procedure drawaa;
var
  mx1,mx2,my1,my2 : comp;
  aq,bq,dx,dy,r,a,b : comp;
  x               : longint;
  count             : word;
  val               : word;
begin
  dergb(col,csplit);
  proc_pp(px+rx,py,col,mode);
  proc_pp(px-rx,py,col,mode);

  mx1 := (px-rx) shl smoothing;
  my1 := py shl smoothing;
  mx2 := (px+rx) shl smoothing;
  my2 := py shl smoothing;

  rx := rx shl smoothing;
  ry := ry shl smoothing;

  aq := rx*rx;
  bq := ry*ry;
  dx := aq*2;
  dy := bq*2;
  r  := rx * bq;
  a  := r*2;
  b  := 0;
  x  := rx;
  while x > 0 do begin
    for count := mask downto 0 do
    if r > 0 then begin
      my1 := my1+1;
      my2 := my2-1;
      b   := b+dx;
      r   := r-b;
    end else begin
      x := x-1;
      mx1 := mx1+1;
      mx2 := mx2-1;
      a   := a-dy;
      r   := r+a;
    end;
    asm
      db 66h;mov   ax,stylecounter.word
      db 66h;add   ax,ax
      db 66h;adc   ax,0;db 00h,00h
      db 66h;mov   stylecounter.word,ax
    end;
    if stylecounter and mode.linestyle <> 0 then
    if my1 / smoothmul-px > ry shr (smoothing+1)  then begin
      val := (x and mask) shl remain;
      proc_ap(trunc(mx1 / smoothmul),trunc(my1 / smoothmul)-1,csplit.l,255-val,mode);
      proc_ap(trunc(mx1 / smoothmul),trunc(my1 / smoothmul),csplit.l,val,mode);

      proc_ap(trunc(mx2 / smoothmul),trunc(my1 / smoothmul)-1,csplit.l,255-val,mode);
      proc_ap(trunc(mx2 / smoothmul),trunc(my1 / smoothmul),csplit.l,val,mode);

      val := (round(mx1) and mask) shl remain;
      proc_ap(trunc(mx1 / smoothmul),trunc(my2 / smoothmul),csplit.l,255-val,mode);
      proc_ap(trunc(mx1 / smoothmul),trunc(my2 / smoothmul)+1,csplit.l,val,mode);

      proc_ap(trunc(mx2 / smoothmul),trunc(my2 / smoothmul),csplit.l,255-val,mode);
      proc_ap(trunc(mx2 / smoothmul),trunc(my2 / smoothmul)+1,csplit.l,val,mode);
    end else begin
      val := (round(mx1) and mask) shl remain;
      proc_ap(trunc(mx1 / smoothmul)+1,trunc(my1 / smoothmul),csplit.l,val,mode);
      proc_ap(trunc(mx1 / smoothmul),trunc(my1 / smoothmul),csplit.l,255-val,mode);

      proc_ap(trunc(mx1 / smoothmul)+1,trunc(my2 / smoothmul),csplit.l,val,mode);
      proc_ap(trunc(mx1 / smoothmul),trunc(my2 / smoothmul),csplit.l,255-val,mode);

      val := (x and mask) shl remain;
      proc_ap(trunc(mx2 / smoothmul)+1,trunc(my1 / smoothmul),csplit.l,val,mode);
      proc_ap(trunc(mx2 / smoothmul),trunc(my1 / smoothmul),csplit.l,255-val,mode);

      proc_ap(trunc(mx2 / smoothmul)+1,trunc(my2 / smoothmul),csplit.l,val,mode);
      proc_ap(trunc(mx2 / smoothmul),trunc(my2 / smoothmul),csplit.l,255-val,mode);
    end;
  end;
end;

begin
  inc(px,mode.actviewport.x1);
  inc(py,mode.actviewport.y1);
  stylecounter := 1;
  if (flags and lnantialias = 0) then begin
    mx1 := px - rx;
    my1 := py;
    mx2 := px + rx;
    my2 := py;

    proc_pp(mx2,py,col,mode);
    proc_pp(mx1,py,col,mode);

    aq := longint(rx) * rx;
    bq := longint(ry) * ry;
    dx := aq shl 1;
    dy := bq shl 1;
    r  := rx * bq;
    a  := r shl 1;
    b  := 0;
    x  := rx;
    while x > 0 do begin
      if r > 0 then begin
        inc(my1);
        dec(my2);
        inc(b,dx);
        dec(r,b);
      end else begin
        dec(x);
        inc(mx1);
        dec(mx2);
        dec(a,dy);
        inc(r,a);
      end;
      asm
        db 66h;mov   ax,stylecounter.word
        db 66h;add   ax,ax
        db 66h;adc   ax,0;db 00h,00h
        db 66h;mov   stylecounter.word,ax
      end;
      if stylecounter and mode.linestyle <> 0 then begin
        proc_pp(mx1,my1,col,mode);
        proc_pp(mx2,my1,col,mode);
        proc_pp(mx1,my2,col,mode);
        proc_pp(mx2,my2,col,mode);
      end;
    end;
  end else drawaa;
end;

procedure tgrafx.poly(num : word;var polypoints : array of tpoint;col,flags : longint);
{draw a traced polygon}
var
  i      : word;
begin
  if (num = 0)or(num > 16383) then exit;
  for i := 0 to num-1 do
  line(polypoints[i].x,polypoints[i].y,polypoints[(i+1) mod num].x,polypoints[(i+1) mod num].y,col,flags);
end;

function tgrafx.textheight(s : string) : word;
var
  i           : integer;
  ysize       : longint;
  mempos      : longint;
  sizey       : longint;
  subfont     : longint;
  arraystart  : longint;
  oldangle    : double;
begin
  ysize := 0;
  if (mode.font.font = nil)or(length(s) = 0) then begin
    textheight := 0;
    exit;
  end;
  if (mode.font.angle <> 0) then begin
    oldangle        := mode.font.angle;
    mode.font.angle := 0;
    textheight      := textwidth(s);
    mode.font.angle := oldangle;
    exit;
  end;
  if (mode.font.font^.id <> idfont)or(mode.font.font^.data = 0)or(length(s) = 0) then exit; { no font loaded }
  if (mode.font.font^.flags and fnfixed <> 0) then
  begin
    ysize := mode.font.font^.sizey;
  end else begin
    if (mode.font.font^.flags and fnvector = 0) then
    case mode.font.font^.bpp of
      1    : begin
               subfont := trunc(mode.font.sizex);
               if subfont > mode.font.font^.numofsubfonts then
                subfont := mode.font.font^.numofsubfonts;
               arraystart := (mode.font.font^.endchar-mode.font.font^.startchar+1)*4
                             *subfont;
               for i := 1 to length(s) do begin
                 if (ord(s[i]) < mode.font.font^.startchar)or
                    (ord(s[i]) > mode.font.font^.endchar) then continue;

                 mempos := readmem32l(ptr48(mode.font.font^.data,
                                     longint(ord(s[i])-mode.font.font^.startchar) shl 2+
                                     arraystart));
                 sizey  := readmem32b(ptr48(mode.font.font^.data,mempos+1));
                 if (sizey > ysize) then ysize := sizey;
               end;
             end;
      2..32: begin
               subfont := trunc(mode.font.sizex);
               if subfont > mode.font.font^.numofsubfonts then
                subfont := mode.font.font^.numofsubfonts;
               if (mode.font.font^.flags and fnanimate) <> 0 then subfont := 0;

               arraystart := (mode.font.font^.endchar-mode.font.font^.startchar+1)*4
                             *subfont;
               for i := 1 to length(s) do begin
                 if (ord(s[i]) < mode.font.font^.startchar)or
                    (ord(s[i]) > mode.font.font^.endchar) then continue;
                 mempos := readmem32l(ptr48(mode.font.font^.data,
                                     longint(ord(s[i])-mode.font.font^.startchar) shl 2+
                                     arraystart));
                 sizey  := readmem32l(ptr48(mode.font.font^.data,mempos+12))+
                           readmem32l(ptr48(mode.font.font^.data,mempos+4));
                 if (sizey > ysize) then ysize := sizey;
               end;
             end;
    end else { We have a vector font}
    begin
      subfont := trunc(mode.font.sizex);
      if subfont > mode.font.font^.numofsubfonts then
       subfont := mode.font.font^.numofsubfonts;
      arraystart := (mode.font.font^.endchar-mode.font.font^.startchar+1)*4
                    *subfont;
      for i := 1 to length(s) do begin
        if (ord(s[i]) < mode.font.font^.startchar)or
           (ord(s[i]) > mode.font.font^.endchar) then continue;

        mempos := readmem32l(ptr48(mode.font.font^.data,
                            longint(ord(s[i])-mode.font.font^.startchar) shl 2+
                            arraystart));
        sizey  := readmem32b(ptr48(mode.font.font^.data,mempos+1));
        if (sizey > ysize) then ysize := sizey;
      end;
      ysize := round(ysize*(mode.font.sizex));
    end;
  end;
  if (mode.font.font^.flags and fnanipos <> 0) then
   inc(ysize,mode.font.font^.randomy);
  textheight := ysize;
end;

function tgrafx.textwidth(s : string) : word;
type
 pvecchar = ^tvecchar;
 tvecchar = record
   sizex,sizey : byte;
   numoflines  : word;
   coordinates : array[0..0] of record
     code,x,y : byte;
   end;
 end;

var
  i           : integer;
  xsize,size  : word;
  mempos      : longint;
  subfont     : longint;
  arraystart  : longint;
  oldangle    : double;
  vec         : pvecchar;

begin
  xsize := 0;
  if (mode.font.font = nil)or(length(s) = 0) then
  begin
    textwidth := 0;
    exit;
  end;
  if (mode.font.angle <> 0) then
  begin
    oldangle        := mode.font.angle;
    mode.font.angle := 0;
    textwidth       := textheight(s);
    mode.font.angle := oldangle;
    exit;
  end;
  if (mode.font.font^.id <> idfont)or(mode.font.font^.data = 0)or
     (length(s) = 0) then exit; { no font loaded }
  if (mode.font.font^.flags and fnfixed <> 0) then
  begin
    xsize := length(s)*(mode.font.font^.sizex+mode.font.font^.distance);
  end else
  begin
    if (mode.font.font^.flags and fnvector = 0) then
    case mode.font.font^.bpp of
      1    : begin
               subfont := trunc(mode.font.sizex);
               if subfont > mode.font.font^.numofsubfonts then
                subfont := mode.font.font^.numofsubfonts;
               arraystart := (mode.font.font^.endchar-mode.font.font^.startchar+1)*4
                             *subfont;
               for i := 1 to length(s) do begin
                 if (ord(s[i]) < mode.font.font^.startchar)or
                    (ord(s[i]) > mode.font.font^.endchar) then
                    begin
                      inc(xsize,mode.font.font^.spacer+mode.font.font^.distance);
                      continue;
                    end;
                 mempos := readmem32l(ptr48(mode.font.font^.data,
                                     longint(ord(s[i])-mode.font.font^.startchar) shl 2+
                                     arraystart));
                 inc(xsize,readmem32b(ptr48(mode.font.font^.data,mempos))+
                           mode.font.font^.distance);
               end;
             end;
      2..32: begin
               subfont := trunc(mode.font.sizex);
               if subfont > mode.font.font^.numofsubfonts then
                subfont := mode.font.font^.numofsubfonts;
               if (mode.font.font^.flags and fnanimate) <> 0 then subfont := 0;

               arraystart := (mode.font.font^.endchar-mode.font.font^.startchar+1)*4
                             *subfont;
               for i := 1 to length(s) do begin
                 if (ord(s[i]) < mode.font.font^.startchar)or
                    (ord(s[i]) > mode.font.font^.endchar) then
                    begin
                      inc(xsize,mode.font.font^.spacer+mode.font.font^.distance);
                      continue;
                    end;
                 mempos := readmem32l(ptr48(mode.font.font^.data,
                                     longint(ord(s[i])-mode.font.font^.startchar) shl 2+
                                     arraystart));
                 inc(xsize,readmem32l(ptr48(mode.font.font^.data,mempos))+
                           readmem32l(ptr48(mode.font.font^.data,mempos+8))+
                           mode.font.font^.distance);
               end;
             end;
    end else { We have a vector font}
    begin
{      arraystart := (mode.font.font^.endchar-mode.font.font^.startchar+1)*4;
      for i := 1 to length(s) do begin
        if (ord(s[i]) < mode.font.font^.startchar)or
           (ord(s[i]) > mode.font.font^.endchar) then
           begin
             inc(xsize,(mode.font.font^.spacer*trunc(mode.font.sizex)) shr 1+mode.font.font^.distance);
             continue;
           end;
        mempos := readmem32l(ptr48(mode.font.font^.data,
                            longint(ord(s[i])-mode.font.font^.startchar) shl 2));
        inc(xsize,readmem32b(ptr48(mode.font.font^.data,mempos)));

      end;
      xsize := round(xsize*(mode.font.sizex+1));
      xsize := xsize+mode.font.font^.distance*length(s);
    end;}

    for i := 1 to length(s) do begin
    if (mode.font.font^.startchar > ord(s[i]))or
       (mode.font.font^.endchar < ord(s[i])) then
      begin
        size := mode.font.font^.spacer;
      end else
      begin
        mempos := readmem32l(ptr48(mode.font.font^.data,(ord(s[i])-
                             mode.font.font^.startchar) shl 2));
        vec := ptr(mode.font.font^.data,mempos);
        size := round((vec^.sizex*(mode.font.sizex)));
      end;
      inc(xsize,size+mode.font.font^.distance);
    end;

  end;
  end;
  if (mode.font.font^.flags and fnanipos <> 0) then
   inc(xsize,mode.font.font^.randomx);
  textwidth := xsize-mode.font.font^.distance;
end;

procedure tgrafx.write(x,y : longint;s : string;col : longint);
var
  i,cx,cy     : integer;
  data        : longint;
  xpos        : longint;
  mempos      : longint;
  datapos     : longint;
  sizex,sizey : longint;
  addx,addy   : longint;
  crgb        : trgb;
  subfont     : longint;
  arraystart  : longint;
  datainc     : longint;
  scrpos      : longint;
  bpl         : longint;
  startchar,endchar : longint;
  distance    : longint;
  spacer      : longint;
  ymax,ystart : longint;
  posx,posy   : longint;
  cn,sn       : double;
  lnflags     : longint;

  drawpixel   : procedure(x,y,col : longint;var mode : tmode);

function outsymbol(x1,y1 : longint;c : char) : word;
type
 pvecchar = ^tvecchar;
 tvecchar = record
   sizex,sizey : byte;
   numoflines  : word;
   coordinates : array[0..0] of record
     code,x,y : byte;
   end;
 end;

var
  i,j         : word;
  xx,yy,mx,my : longint;
  vec         : pvecchar;
  x2,y2       : double;

begin
  if (mode.font.font^.startchar > ord(c))or
     (mode.font.font^.endchar < ord(c)) then
  begin
    outsymbol := mode.font.font^.spacer;
    exit;
  end;
  mempos := readmem32l(ptr48(mode.font.font^.data,(ord(c)-
                             mode.font.font^.startchar) shl 2));

  posx := round(cn*x1+sn*y1);
  posy := round(-sn*x1+cn*y1);

  vec := ptr(mode.font.font^.data,mempos);
  for j := 0 to Vec^.numoflines-1 do
   with vec^.coordinates[j] do begin
     if mode.font.angle = 0 then
     begin
       mx := x1+round((x*(mode.font.sizex)));
       my := y1+round((y*(mode.font.sizey)));
     end else
     begin
       x2 := (x1+x*(mode.font.sizex));
       y2 := (y1+y*(mode.font.sizey));
       mx := round(cn*x2+sn*y2);
       my := round(-sn*x2+cn*y2);
     end;
     if (code = 1) then
     begin
       posx := mx;
       posy := my;
     end else
     begin
       line(posx,posy,mx,my,col,lnflags);
       posx := mx;
       posy := my;
     end;
   end;
  outsymbol := round((vec^.sizex*(mode.font.sizex)));
end;

begin
  if mode.font.font = nil then exit;
  if (mode.font.font^.id <> idfont)or(mode.font.font^.data = 0)or(length(s) = 0) then exit; { no font loaded }
  case mode.font.align.x of
    textcentered : x := x-textwidth(s) shr 1;
    textright    : x := x-textwidth(s);
  end;
  case mode.font.align.y of
    textcentered : y := y-textheight(s) shr 1;
    textbottom   : y := y-textheight(s);
  end;

  if (y > maxy)or(x > maxx) then exit;

  case (mode.font.flags and (textadd or textsub)) of
    textdefault : drawpixel := proc_pp;
    textadd     : drawpixel := proc_addp;
    textsub     : drawpixel := proc_subp;
  end;

  if (mode.font.font^.flags and fnvector = 0) then
  case mode.font.font^.bpp of
    1    : begin
             {$IFDEF ASMTEXT}
             if (y >= 0)and(x >= 0)and(x+textwidth(s) <= maxx)and
             (mode.font.angle = 0)and
             (mode.font.flags and (textadd or textsub) = 0)and
             (mode.font.font^.sizex <= 32) then
             begin
               subfont := trunc(mode.font.sizex);
               if subfont > mode.font.font^.numofsubfonts then
                subfont := mode.font.font^.numofsubfonts;
               arraystart := (mode.font.font^.endchar-mode.font.font^.startchar+1)*4
                             *subfont;

               ymax      := maxy-y+1;
               datainc   := mode.font.font^.bpl;
               bpl       := mode.bpl;
               startchar := mode.font.font^.startchar;
               endchar   := mode.font.font^.endchar;
               distance  := mode.font.font^.distance;
               if (mode.font.font^.flags and fnfixed = 0)  then
                spacer := mode.font.font^.spacer*mode.pixel+mode.font.font^.distance*mode.pixel
                else spacer := mode.font.font^.sizex*mode.pixel+mode.font.font^.distance*mode.pixel;
               inc(x,mode.actviewport.x1);
               inc(y,mode.actviewport.y1);
               if (mode.flags and mdlinear <> 0) then
               case mode.bpp of
                 15,16:
                 asm
                          mov   i,1
                          les   di,self
                   db 66h;mov   bx,x.word
                   db 66h;mov   ax,es:[di].mode.bpl.word
                   db 66h;add   bx,bx
                   db 66h;mul   y.word
                   db 66h;add   ax,bx
                   db 66h;add   ax,es:[di].mode.displayofs.word
                   db 66h;mov   si,ax
                          mov   ax,es:[di].mode.writeptr
                   db 8Eh,0E8h {mov   gs,ax}
                          les   di,es:[di].mode.font.font
                          mov   ax,es:[di].tfont.data
                          mov   es,ax
                          jmp   @charloop
                   @notavailable:
                     db 66h;pop   si
                     db 66h;add   si,spacer.word
                            jmp   @loopend
                   @charloop:
                     db 66h;push  si

                            mov   di,i
                     db 66h;xor   ax,ax
                            mov   al,s[di].byte
                     db 66h;cmp   ax,endchar.word
                            jnbe  @notavailable
                     db 66h;sub   ax,startchar.word
                            jc    @notavailable

                     db 66h;shl   ax,2
                     db 66h;add   ax,arraystart.word
                     db 26h,67h,66h,8Bh,38h {mov   edi,es:[eax]}

                     db 66h;xor   dx,dx
                     db 66h;xor   cx,cx
                     db 26h,67h,8Ah,0Fh     {mov   cl,es:[edi]}
                     db 26h,67h,8Ah,57h,01h {mov   dl,es:[edi+1]}

                     db 66h;add   di,2
                     db 66h;mov   bx,col.word
                     db 66h;or    dx,dx
                            jz    @notavailable
                     db 66h;cmp   dx,ymax.word {check if y+charheight > maxy}
                            jbe   @ylp

                     db 66h;mov   dx,ymax.word
                     @ylp:

                       db 66h;push   cx
                       db 26h,67h,66h,8Bh,07h {mov   eax,es:[edi]}
                       @xlp:
                         db 66h;test  ax,1;dw 0000
                                jz    @nopix
                         db 65h,67h,89h,1Eh   {mov   gs:[esi],bx}
                                @nopix:
                         db 66h;shr   ax,1
                         db 66h;add   si,2
                         db 66h;dec   cx
                                jnz   @xlp

                       db 66h;pop   cx
                       db 66h;add   di,datainc.word
                       db 66h;add   si,bpl.word
                       db 66h;sub   si,cx
                       db 66h;sub   si,cx

                       db 66h;dec   dx
                              jnz   @ylp

                       db 66h;pop   si
                       db 66h;add   cx,distance.word
                       db 66h;add   cx,cx
                       db 66h;add   si,cx
                       @loopend:
                              mov   ax,i
                              inc   ax
                              mov   i,ax
                              cmp   al,s[0].byte
                              jna   @charloop
                   end;
                 24:
                 asm
                          mov   i,1
                          les   di,self
                   db 66h;mov   bx,x.word
                   db 66h;mov   ax,es:[di].mode.bpl.word
                   db 66h;mul   y.word
                   db 66h;add   ax,bx
                   db 66h;add   bx,bx
                   db 66h;add   ax,bx
                   db 66h;add   ax,es:[di].mode.displayofs.word
                   db 66h;mov   si,ax
                          mov   ax,es:[di].mode.writeptr
                   db 8Eh,0E8h {mov   gs,ax}
                          les   di,es:[di].mode.font.font
                          mov   ax,es:[di].tfont.data
                          mov   es,ax
                          jmp   @charloop
                   @notavailable:
                     db 66h;pop   si
                     db 66h;add   si,spacer.word
                            jmp   @loopend
                   @charloop:
                     db 66h;push  si

                            mov   di,i
                     db 66h;xor   ax,ax
                            mov   al,s[di].byte
                     db 66h;cmp   ax,endchar.word
                            jnbe  @notavailable
                     db 66h;sub   ax,startchar.word
                            jc    @notavailable

                     db 66h;shl   ax,2
                     db 66h;add   ax,arraystart.word
                     db 26h,67h,66h,8Bh,38h {mov   edi,es:[eax]}

                     db 66h;xor   dx,dx
                     db 66h;xor   cx,cx
                     db 26h,67h,8Ah,0Fh     {mov   cl,es:[edi]}
                     db 26h,67h,8Ah,57h,01h {mov   dl,es:[edi+1]}
                     db 66h;add   di,2
                     db 66h;mov   bx,col.word

                     db 66h;or    dx,dx
                            jz    @notavailable
                     db 66h;cmp   dx,ymax.word {check if y+charheight > maxy}
                            jbe   @ylp
                     db 66h;mov   dx,ymax.word
                     @ylp:

                       db 66h;push   cx
                       db 26h,67h,66h,8Bh,07h {mov   eax,es:[edi]}
                       @xlp:
                         db 66h;test  ax,1;dw 0
                                jz    @nopix
                         db 65h,67h,89h,1Eh     {mov   gs:[esi],bx}
                         db 66h;ror   ax,16
                         db 65h,67h,88h,5Eh,02h {mov   gs:[esi+2],bl}
                         db 66h;rol   ax,16
                                @nopix:
                         db 66h;shr   ax,1
                         db 66h;add   si,3
                         db 66h;dec   cx
                                jnz   @xlp

                       db 66h;pop   cx
                       db 66h;add   di,datainc.word
                       db 66h;add   si,bpl.word
                       db 66h;sub   si,cx
                       db 66h;sub   si,cx
                       db 66h;sub   si,cx

                       db 66h;dec   dx
                              jnz   @ylp

                       db 66h;pop   si
                       db 66h;add   cx,distance.word
                       db 66h;add   si,cx
                       db 66h;add   cx,cx
                       db 66h;add   si,cx
                       @loopend:
                              mov   ax,i
                              inc   ax
                              mov   i,ax
                              cmp   al,s[0].byte
                              jna   @charloop
                   end;
                 32:
                 asm
                          mov   i,1
                          les   di,self
                   db 66h;mov   bx,x.word
                   db 66h;mov   ax,es:[di].mode.bpl.word
                   db 66h;shl   bx,2
                   db 66h;mul   y.word
                   db 66h;add   ax,bx
                   db 66h;add   ax,es:[di].mode.displayofs.word
                   db 66h;mov   si,ax
                          mov   ax,es:[di].mode.writeptr
                   db 8Eh,0E8h {mov   gs,ax}
                          les   di,es:[di].mode.font.font
                          mov   ax,es:[di].tfont.data
                          mov   es,ax
                          jmp   @charloop
                   @notavailable:
                     db 66h;pop   si
                     db 66h;add   si,spacer.word
                            jmp   @loopend
                   @charloop:
                     db 66h;push  si

                            mov   di,i
                     db 66h;xor   ax,ax
                            mov   al,s[di].byte
                     db 66h;cmp   ax,endchar.word
                            jnbe  @notavailable
                     db 66h;sub   ax,startchar.word
                            jc    @notavailable

                     db 66h;shl   ax,2
                     db 66h;add   ax,arraystart.word
                     db 26h,67h,66h,8Bh,38h {mov   edi,es:[eax]}

                     db 66h;xor   dx,dx
                     db 66h;xor   cx,cx
                     db 26h,67h,8Ah,0Fh     {mov   cl,es:[edi]}
                     db 26h,67h,8Ah,57h,01h {mov   dl,es:[edi+1]}
                     db 66h;add   di,2
                     db 66h;mov   bx,col.word

                     db 66h;or    dx,dx
                            jz    @notavailable
                     db 66h;cmp   dx,ymax.word {check if y+charheight > maxy}
                            jbe   @ylp
                     db 66h;mov   dx,ymax.word
                     @ylp:

                       db 66h;push   cx
                       db 26h,67h,66h,8Bh,07h {mov   eax,es:[edi]}
                       @xlp:
                         db 66h;test  ax,1;dw 0
                                jz    @nopix
                         db 65h,67h,66h,89h,1Eh   {mov   gs:[esi],ebx}
                                @nopix:
                         db 66h;shr   ax,1
                         db 66h;add   si,4
                         db 66h;dec   cx
                                jnz   @xlp

                       db 66h;pop   cx
                       db 66h;add   di,datainc.word
                       db 66h;shl   cx,2
                       db 66h;add   si,bpl.word
                       db 66h;sub   si,cx
                       db 66h;shr   cx,2

                       db 66h;dec   dx
                              jnz   @ylp

                       db 66h;pop   si
                       db 66h;add   cx,distance.word
                       db 66h;shl   cx,2
                       db 66h;add   si,cx
                       @loopend:
                              mov   ax,i
                              inc   ax
                              mov   i,ax
                              cmp   al,s[0].byte
                              jna   @charloop
                   end;
                 end else
               case mode.bpp of
                 15,16:
                 asm
                          mov   i,1
                          les   di,self
                   db 66h;mov   bx,x.word
                   db 66h;mov   ax,es:[di].mode.bpl.word
                   db 66h;mov   cx,y.word
                   db 66h;add   cx,es:[di].mode.pageadd.word
                   db 66h;add   bx,bx
                   db 66h;mul   cx
                   db 66h;add   ax,bx
                   db 66h;mov   si,ax
                   db 66h;shr   ax,16
                          cmp   ax,lastbank
                          je    @noswitch
                          push  ax
                          call  setbank
                   @noswitch:
                          mov   ax,es:[di].mode.writeptr
                   db 8Eh,0E8h {mov   gs,ax}
                          les   di,es:[di].mode.font.font
                          mov   ax,es:[di].tfont.data
                          mov   es,ax
                          jmp   @charloop
                   @notavailable:
                     db 66h;pop   si
                     db 66h;add   si,spacer.word
                            jmp   @loopend
                   @charloop:
                     db 66h;push  si

                            mov   di,i
                     db 66h;xor   ax,ax
                            mov   al,s[di].byte
                     db 66h;cmp   ax,endchar.word
                            jnbe  @notavailable
                     db 66h;sub   ax,startchar.word
                            jc    @notavailable

                     db 66h;shl   ax,2
                     db 66h;add   ax,arraystart.word
                     db 26h,67h,66h,8Bh,38h {mov   edi,es:[eax]}

                     db 66h;xor   dx,dx
                     db 66h;xor   cx,cx
                     db 26h,67h,8Ah,0Fh     {mov   cl,es:[edi]}
                     db 26h,67h,8Ah,57h,01h {mov   dl,es:[edi+1]}
                     db 66h;add   di,2
                     db 66h;mov   bx,col.word

                     db 66h;or    dx,dx
                            jz    @notavailable
                     db 66h;cmp   dx,ymax.word {check if y+charheight > maxy}
                            jbe   @ylp
                     db 66h;mov   dx,ymax.word
                     @ylp:

                       db 66h;push   cx
                       db 26h,67h,66h,8Bh,07h {mov   eax,es:[edi]}
                       @xlp:
                         db 66h;test  ax,1;dw 0
                                jz    @nopix
                         db 65h,89h,1Ch   {mov   gs:[si],bx}
                                @nopix:
                         db 66h;shr   ax,1
                                add   si,2
                                jc    @switch
                                @continue:
                         db 66h;dec   cx
                                jnz   @xlp

                       db 66h;pop   cx
                       db 66h;add   di,datainc.word

                       db 66h;mov   ax,bpl.word
                       db 66h;sub   ax,cx
                       db 66h;sub   ax,cx
                              add   si,ax
                              jnc   @noswitch2
                       db 66h,81h,0C6h,00h,00h,01h,00h {add  esi,10000h}
                              call  incbank
                       @noswitch2:

                       db 66h;dec   dx
                              jnz   @ylp

                       db 66h;pop   si
                       db 66h;add   cx,distance.word
                       db 66h;add   cx,cx
                       db 66h;add   si,cx
                       db 66h;mov   ax,si
                       db 66h;shr   ax,16
                              cmp   ax,lastbank
                              je    @loopend
                              push  ax
                              call  setbank
                       @loopend:
                              mov   ax,i
                              inc   ax
                              mov   i,ax
                              cmp   al,s[0].byte
                              jna   @charloop
                              jmp   @end
                     @switch:
                     db 66h,81h,0C6h,00h,00h,01h,00h {add  esi,10000h}
                            call  incbank
                            jmp   @continue
                     @end:
                 end;
                 32:
                 asm
                          mov   i,1
                          les   di,self
                   db 66h;mov   bx,x.word
                   db 66h;mov   ax,es:[di].mode.bpl.word
                   db 66h;mov   cx,y.word
                   db 66h;add   cx,es:[di].mode.pageadd.word
                   db 66h;shl   bx,2
                   db 66h;mul   cx
                   db 66h;add   ax,bx
                   db 66h;mov   si,ax
                   db 66h;shr   ax,16
                          cmp   ax,lastbank
                          je    @noswitch
                          push  ax
                          call  setbank
                   @noswitch:
                          mov   ax,es:[di].mode.writeptr
                   db 8Eh,0E8h {mov   gs,ax}
                          les   di,es:[di].mode.font.font
                          mov   ax,es:[di].tfont.data
                          mov   es,ax
                          jmp   @charloop
                   @notavailable:
                     db 66h;pop   si
                     db 66h;add   si,spacer.word
                            jmp   @loopend
                   @charloop:
                     db 66h;push  si

                            mov   di,i
                     db 66h;xor   ax,ax
                            mov   al,s[di].byte
                     db 66h;cmp   ax,endchar.word
                            jnbe  @notavailable
                     db 66h;sub   ax,startchar.word
                            jc    @notavailable

                     db 66h;shl   ax,2
                     db 66h;add   ax,arraystart.word
                     db 26h,67h,66h,8Bh,38h {mov   edi,es:[eax]}

                     db 66h;xor   dx,dx
                     db 66h;xor   cx,cx
                     db 26h,67h,8Ah,0Fh     {mov   cl,es:[edi]}
                     db 26h,67h,8Ah,57h,01h {mov   dl,es:[edi+1]}
                     db 66h;add   di,2
                     db 66h;mov   bx,col.word

                     db 66h;or    dx,dx
                            jz    @notavailable
                     db 66h;cmp   dx,ymax.word {check if y+charheight > maxy}
                            jbe   @ylp
                     db 66h;mov   dx,ymax.word
                     @ylp:

                       db 66h;push   cx
                       db 26h,67h,66h,8Bh,07h {mov   eax,es:[edi]}
                       @xlp:
                         db 66h;test  ax,1;dw 0
                                jz    @nopix
                         db 65h,66h,89h,1Ch   {mov   gs:[si],ebx}
                                @nopix:
                         db 66h;shr   ax,1
                                add   si,4
                                jc    @switch
                                @continue:
                         db 66h;dec   cx
                                jnz   @xlp

                       db 66h;pop   cx
                       db 66h;add   di,datainc.word

                       db 66h;shl   cx,2
                       db 66h;mov   ax,bpl.word
                       db 66h;sub   ax,cx
                       db 66h;shr   cx,2
                              add   si,ax
                              jnc   @noswitch2
                       db 66h,81h,0C6h,00h,00h,01h,00h {add  esi,10000h}
                              call  incbank
                       @noswitch2:

                       db 66h;dec   dx
                              jnz   @ylp

                       db 66h;pop   si
                       db 66h;add   cx,distance.word
                       db 66h;shl   cx,2
                       db 66h;add   si,cx
                       db 66h;mov   ax,si
                       db 66h;shr   ax,16
                              cmp   ax,lastbank
                              je    @loopend
                              push  ax
                              call  setbank
                       @loopend:
                              mov   ax,i
                              inc   ax
                              mov   i,ax
                              cmp   al,s[0].byte
                              jna   @charloop
                              jmp   @end
                     @switch:
                     db 66h,81h,0C6h,00h,00h,01h,00h {add  esi,10000h}
                            call  incbank
                            jmp   @continue
                     @end:
                 end;
               end;
             end else
             {$ENDIF}
             begin
               if (mode.font.angle = 90) then begin
                 xpos := y;
                 subfont := trunc(mode.font.sizex);
                 if subfont > mode.font.font^.numofsubfonts then
                  subfont := mode.font.font^.numofsubfonts;
                 arraystart := (mode.font.font^.endchar-mode.font.font^.startchar+1)*4
                               *subfont;

                 for i := length(s) downto 1 do begin
                   if (ord(s[i]) < mode.font.font^.startchar)or
                      (ord(s[i]) > mode.font.font^.endchar) then
                      begin
                        if (mode.font.font^.flags and fnfixed = 0)  then
                        inc(xpos,mode.font.font^.spacer+mode.font.font^.distance)
                        else inc(xpos,mode.font.font^.sizex+mode.font.font^.distance);
                        continue;
                      end;
                   mempos := readmem32l(ptr48(mode.font.font^.data,
                                       longint(ord(s[i])-mode.font.font^.startchar) shl 2+
                                       arraystart));
                   sizex  := readmem32b(ptr48(mode.font.font^.data,mempos));
                   sizey  := readmem32b(ptr48(mode.font.font^.data,mempos+1));
                   inc(mempos,2);
                   for cy := 0 to sizey-1 do begin
                     datapos := 0;
                     data := readmem32l(ptr48(mode.font.font^.data,mempos));
                     for cx := 0 to sizex-1 do begin
                       if (cx > 31)and(cx and 31 = 0) then
                       begin { load new pixels }
                         inc(datapos,4);
                         data := readmem32l(ptr48(mode.font.font^.data,mempos+datapos));
                       end;
                       if data and (longint(1) shl (cx and 31)) <> 0 then
                         drawpixel(x+cy,xpos+sizex-cx,col,mode);
                     end;
                     inc(mempos,mode.font.font^.bpl);
                   end;
                   inc(xpos,sizex+mode.font.font^.distance);
                 end;
               end else
               if (mode.font.angle = 270) then begin
                 xpos := y;
                 subfont := trunc(mode.font.sizex);
                 if subfont > mode.font.font^.numofsubfonts then
                  subfont := mode.font.font^.numofsubfonts;
                 arraystart := (mode.font.font^.endchar-mode.font.font^.startchar+1)*4
                               *subfont;

                 for i := 1 to length(s) do begin
                   if (ord(s[i]) < mode.font.font^.startchar)or
                      (ord(s[i]) > mode.font.font^.endchar) then
                      begin
                        if (mode.font.font^.flags and fnfixed = 0)  then
                        inc(xpos,mode.font.font^.spacer+mode.font.font^.distance)
                        else inc(xpos,mode.font.font^.sizex+mode.font.font^.distance);
                        continue;
                      end;
                   mempos := readmem32l(ptr48(mode.font.font^.data,
                                       longint(ord(s[i])-mode.font.font^.startchar) shl 2+
                                       arraystart));
                   sizex  := readmem32b(ptr48(mode.font.font^.data,mempos));
                   sizey  := readmem32b(ptr48(mode.font.font^.data,mempos+1));
                   inc(mempos,2);
                   for cy := 0 to sizey-1 do begin
                     datapos := 0;
                     data := readmem32l(ptr48(mode.font.font^.data,mempos));
                     for cx := 0 to sizex-1 do begin
                       if (cx > 31)and(cx and 31 = 0) then
                       begin { load new pixels }
                         inc(datapos,4);
                         data := readmem32l(ptr48(mode.font.font^.data,mempos+datapos));
                       end;
                       if data and (longint(1) shl (cx and 31)) <> 0 then
                         drawpixel(x+sizey-cy,xpos+cx,col,mode);
                     end;
                     inc(mempos,mode.font.font^.bpl);
                   end;
                   inc(xpos,sizex+mode.font.font^.distance);
                 end;
               end else
               begin
                 xpos := x;
                 subfont := trunc(mode.font.sizex);
                 if subfont > mode.font.font^.numofsubfonts then
                  subfont := mode.font.font^.numofsubfonts;
                 arraystart := (mode.font.font^.endchar-mode.font.font^.startchar+1)*4
                               *subfont;

                 for i := 1 to length(s) do begin
                   if (ord(s[i]) < mode.font.font^.startchar)or
                      (ord(s[i]) > mode.font.font^.endchar) then
                      begin
                        if (mode.font.font^.flags and fnfixed = 0)  then
                        inc(xpos,mode.font.font^.spacer+mode.font.font^.distance)
                        else inc(xpos,mode.font.font^.sizex+mode.font.font^.distance);
                        continue;
                      end;
                   mempos := readmem32l(ptr48(mode.font.font^.data,
                                       longint(ord(s[i])-mode.font.font^.startchar) shl 2+
                                       arraystart));
                   sizex  := readmem32b(ptr48(mode.font.font^.data,mempos));
                   sizey  := readmem32b(ptr48(mode.font.font^.data,mempos+1));
                   inc(mempos,2);
                   for cy := 0 to sizey-1 do begin
                     datapos := 0;
                     data := readmem32l(ptr48(mode.font.font^.data,mempos));
                     for cx := 0 to sizex-1 do begin
                       if (cx > 31)and(cx and 31 = 0) then
                       begin { load new pixels }
                         inc(datapos,4);
                         data := readmem32l(ptr48(mode.font.font^.data,mempos+datapos));
                       end;
                       if data and (longint(1) shl (cx and 31)) <> 0 then
                         drawpixel(xpos+cx,y+cy,col,mode);
                     end;
                     inc(mempos,mode.font.font^.bpl);
                   end;
                   inc(xpos,sizex+mode.font.font^.distance);
                 end;
               end;
             end;
           end;
    2..7 : begin
             if col <> $FFFFFFFF then begin
               dergb(col,crgb);
               for i := 1 to mode.font.font^.usedcolors do
                 writemem32l(ptr48(mode.font.bmp8data,i shl 2),
                             rgb(longint(crgb.r)*i div pred(mode.font.font^.usedcolors),
                             longint(crgb.g)*i div pred(mode.font.font^.usedcolors),
                             longint(crgb.b)*i div pred(mode.font.font^.usedcolors)));
             end;
             if (mode.font.font^.flags and fnanipos) <> 0 then begin
               randarray_word(gfxbufptr,length(s)+1,mode.font.font^.randomx);
               randarray_word(ptr48(gfxbufsel,512),length(s)+1,mode.font.font^.randomy);
             end;
             xpos := x;
             subfont := trunc(mode.font.sizex);
             if subfont > mode.font.font^.numofsubfonts then
              subfont := mode.font.font^.numofsubfonts;
             if (mode.font.font^.flags and fnanimate) <> 0 then subfont := 0;

             arraystart := (mode.font.font^.endchar-mode.font.font^.startchar+1)*4
                           *subfont;
             for i := 1 to length(s) do begin
               if (ord(s[i]) < mode.font.font^.startchar)or
                  (ord(s[i]) > mode.font.font^.endchar) then
                  begin
                    if (mode.font.font^.flags and fnfixed = 0)  then
                    inc(xpos,mode.font.font^.spacer+mode.font.font^.distance)
                    else inc(xpos,mode.font.font^.sizex+mode.font.font^.distance);
                    continue;
                  end;
               mempos := readmem32l(ptr48(mode.font.font^.data,
                                   longint(ord(s[i])-mode.font.font^.startchar) shl 2+
                                   arraystart));
               addx   := readmem32l(ptr48(mode.font.font^.data,mempos));
               addy   := readmem32l(ptr48(mode.font.font^.data,mempos+4));
               if (mode.font.font^.flags and fnanipos <> 0) then begin
                 inc(addx,memw[gfxbufsel:i shl 1]);
                 inc(addy,memw[gfxbufsel:i shl 1+512]);
               end;
               sizex  := readmem32l(ptr48(mode.font.font^.data,mempos+8));
               sizey  := readmem32l(ptr48(mode.font.font^.data,mempos+12));
               inc(mempos,16);
               inc(xpos,addx);
               for cy := 0 to sizey-1 do
               for cx := 0 to sizex-1 do begin
                 data := readmem32b(ptr48(mode.font.font^.data,mempos));
                 inc(mempos);
                 if data and $80 = 0 then
                 drawpixel(xpos+cx,y+addy+cy,readmem32l(ptr48(mode.font.bmp8data,data shl 2)),mode);
               end;
               if (mode.font.font^.flags and fnanipos <> 0) then
                 dec(xpos,memw[gfxbufsel:i shl 1]);
               if (mode.font.font^.flags and fnfixed <> 0) then
                 inc(xpos,mode.font.font^.sizex+mode.font.font^.distance)
                 else inc(xpos,sizex+mode.font.font^.distance);
             end;
           end;
  end else {font is a vector font}
  begin
    sn:=sin(pi*mode.font.angle/180);
    cn:=cos(pi*mode.font.angle/180);
    xpos := x;
    if (mode.font.flags and textantialias <> 0) then
      lnflags := lnantialias else lnflags := lndefault;
    for i := 1 to length(s) do begin
       inc(xpos,outsymbol(xpos,y,{fill,}s[i])+mode.font.font^.distance);
    end;
  end;
  if (mode.font.flags and textunderline <> 0) then begin
    case round(mode.font.angle) of
      0   : hline(x-1,y+mode.font.font^.baseline+2,textwidth(s)+2,col);
      90  : vline(x+mode.font.font^.baseline+2,y-1,textheight(s)+2,col);
      270 : vline(x-2,y-1,textheight(s)+2,col);
    end;
  end;
  if (mode.font.flags and textstrikeout <> 0) then begin
    case round(mode.font.angle) of
      0   : hline(x-1,y+textheight('abcde') shr 1,textwidth(s)+2,col);
      90  : vline(x+textwidth('abcde') shr 1,y-1,textheight(s)+2,col);
      270 : vline(x+textwidth('abcde')-textwidth('abcde') shr 1,y,textheight(s)+2,col);
    end;
  end;
end;

function tgrafx.getmaxcharheight : longint;
var
  height : longint;
begin
  if (mode.font.font = nil) then exit;
  if (mode.font.font^.flags and fnvector = 0) then
    height := mode.font.font^.sizey else
    height := round(mode.font.font^.sizey*mode.font.sizey);

  if (mode.font.font^.flags and fnanipos <> 0) then
   inc(height,mode.font.font^.randomy);
   getmaxcharheight := height;
end;

function tgrafx.getmaxcharwidth : longint;
var
  width : longint;
begin
  if (mode.font.font = nil) then exit;
  if (mode.font.font^.flags and fnvector = 0) then
    width := mode.font.font^.sizex else
    width := round(mode.font.font^.sizex*mode.font.sizex);

  if (mode.font.font^.flags and fnanipos <> 0) then
   inc(width,mode.font.font^.randomx);
   getmaxcharwidth := width;
end;

procedure tgrafx.setfont(var font : tfont);
begin
  if (@font = nil)or(font.data = 0)or(font.id <> idfont) then exit;
  { If old font multifont, restore header }
  if (mode.font.font^.flags and fnmulti <> 0) then setfontsize(0);
  mode.font.font  := @font;
  if (mode.font.font^.flags and fnvector <> 0) then
  begin
    mode.font.sizex := 1;
    mode.font.sizey := 1;
  end else
  begin
    mode.font.sizex := 0;
    mode.font.sizey := 0;
  end;
end;

function tgrafx.getfont : pfont;
begin
  getfont := @mode.font.font^;
end;

procedure tgrafx.setfontattributes(xalign,yalign,flags : longint);
begin
  mode.font.align.x := xalign;
  mode.font.align.y := yalign;
  mode.font.flags   := flags;
end;

procedure tgrafx.getfontattributes(var xalign,yalign,flags : longint);
begin
  xalign := mode.font.align.x;
  yalign := mode.font.align.y;
  flags  := mode.font.flags;
end;

procedure tgrafx.setfontsize(size : double);
begin
  if (mode.font.font^.numofsubfonts <> 0) then begin
    if (size > mode.font.font^.numofsubfonts) then
      size := mode.font.font^.numofsubfonts;
      move2(ptr48(mode.font.font^.data,(mode.font.font^.endchar-
                  mode.font.font^.startchar+1)*4*
                  succ(mode.font.font^.numofsubfonts)+trunc(size)*sizeof(tsubfont)),
            farptr(@mode.font.font^.fontstart),
            sizeof(tsubfont));
  end;
  mode.font.sizex := size;
  mode.font.sizey := size;
end;

function tgrafx.getfontsize : double;
begin
  getfontsize := mode.font.sizex;
end;

procedure tgrafx.setfontangle(angle : double);
begin
  mode.font.angle := angle;
end;

function  tgrafx.getfontangle : double;
begin
  getfontangle := mode.font.angle;
end;

procedure tgrafx.setpattern(pattern : tpattern);
begin
  mode.pattern := pattern;
end;

procedure tgrafx.getpattern(var pattern : tpattern);
begin
  pattern := mode.pattern;
end;

procedure tgrafx.setlinestyle(style : longint);
begin
  mode.linestyle := style;
end;

function tgrafx.getlinestyle : longint;
begin
  getlinestyle := mode.linestyle;
end;

procedure tgrafx.clear;
var
  w       : word    ;
  l       : longint ;
begin
  if @proc_clear <> nil then begin
    proc_clear;
    exit;
  end;
  if ((mode.flags and mdlinear) <> 0) then begin
    l := (mode.bpl*mode.resy);
    {fillbyte(ptr48(mode.writeptr,longint(mode.pageadd)*mode.bpl),l,0);}
    {uses mmx - fillbyte doesn't have this suuport}
    fillword(ptr48(mode.writeptr,longint(mode.pageadd)*mode.bpl),l,0);
  end else begin
    w := mode.calcofs(0,mode.pageadd,mode);
    l := longint(mode.bpl)*mode.resy;
    if w > 0 then
    fillbyte(ptr48(mode.writeptr,w),65536-w,0) else
    filldword(ptr48(mode.writeptr,0),65536,0);
    dec(l,65536-w);
    repeat
      incbank;
      if l >= longint(65536) then
      filldword(ptr48(mode.writeptr,0),65536,0) else
      fillbyte(ptr48(mode.writeptr,0),l,0);
      dec(l,65536);
    until l <= 0;
  end;
end;

procedure setviewport(var screen : tgrafx;x1,y1,x2,y2 : integer);
{ Internal usage only! }
begin
  with screen.mode do begin
    actviewport.x1  := x1;
    actviewport.y1  := y1;
    actviewport.x2  := x2;
    actviewport.y2  := y2;
  end;
  with screen do begin
     maxx      := x2-x1;
     maxy      := y2-y1;
     mode.maxx := maxx;
     mode.maxy := maxy;
     centerx   := maxx shr 1;
     centery   := maxy shr 1;
  end;
end;


procedure set4lin(var scrobj : tgrafx);
begin
  with scrobj do begin
    proc_dr_curr := dr_lin_gen;
    proc_gt_curr := gt_lin_gen;
    proc_dr_conv := dr_lin_cnv;
    {proc_dr_rle  := dr_lin_rle;}
    proc_scale   := scale_lin_gen;
    case mode.bpp of
{$IFDEF hicolor}
      15 : begin
             proc_pp        := pp_1516_lin;
             proc_ap        := ap_15_lin;
             proc_gp        := gp_1516_lin;
             proc_addp      := addp_15_lin;
             proc_subp      := subp_15_lin;
             proc_hline     := hline_1516_lin;
             proc_patternln := pline_1516_lin;
             proc_vline     := vline_1516_lin;
             proc_line      := line_1516_lin;
             mode.calcofs   := calcofs_1516_lin;
           end;
      16 : begin
             proc_pp        := pp_1516_lin;
             proc_ap        := ap_16_lin;
             proc_gp        := gp_1516_lin;
             proc_addp      := addp_16_lin;
             proc_subp      := subp_16_lin;
             proc_hline     := hline_1516_lin;
             proc_patternln := pline_1516_lin;
             proc_vline     := vline_1516_lin;
             proc_line      := line_1516_lin;
             mode.calcofs   := calcofs_1516_lin;
           end;
{$ENDIF}
{$IFDEF truecolor}
      24 : begin
             proc_pp        := pp_24_lin;
             proc_ap        := ap_24_lin;
             proc_gp        := gp_24_lin;
             proc_addp      := addp_24_lin;
             proc_subp      := subp_24_lin;
             proc_hline     := hline_24_lin;
             proc_patternln := pline_24_lin;
             proc_vline     := vline_24_lin;
             proc_line      := line_24_lin;
             mode.calcofs   := calcofs_24_lin;
           end;
      32 : begin
             proc_pp        := pp_32_lin;
             proc_ap        := ap_32_lin;
             proc_gp        := gp_32_lin;
             proc_addp      := addp_32_lin;
             proc_subp      := subp_32_lin;
             proc_hline     := hline_32_lin;
             proc_patternln := pline_32_lin;
             proc_vline     := vline_32_lin;
             proc_line      := line_32_lin;
             mode.calcofs   := calcofs_32_lin;
           end;
{$ENDIF}
    end;
  end;
end;

procedure set4bnk(var scrobj : tgrafx);
begin
  with scrobj do begin
    proc_dr_curr := dr_bnk_gen;
    proc_gt_curr := gt_bnk_gen;
    proc_dr_conv := dr_bnk_cnv;
    proc_scale   := scale_bnk_gen;
    case mode.bpp of
{$IFDEF hicolor}
      15 : begin
             proc_pp        := pp_1516_bnk;
             proc_ap        := ap_15_bnk;
             proc_gp        := gp_1516_bnk;
             proc_addp      := addp_15_bnk;
             proc_subp      := subp_15_bnk;
             proc_hline     := hline_1516_bnk;
             proc_patternln := pline_1516_bnk;
             proc_vline     := vline_1516_bnk;
             proc_line      := line_1516_bnk;
             mode.calcofs   := calcofs_1516_bnk;
           end;
      16 : begin
             proc_pp        := pp_1516_bnk;
             proc_ap        := ap_16_bnk;
             proc_gp        := gp_1516_bnk;
             proc_addp      := addp_16_bnk;
             proc_subp      := subp_16_bnk;
             proc_hline     := hline_1516_bnk;
             proc_patternln := pline_1516_bnk;
             proc_vline     := vline_1516_bnk;
             proc_line      := line_1516_bnk;
             mode.calcofs   := calcofs_1516_bnk;
           end;
{$ENDIF}
{$IFDEF truecolor}
{      24 : begin
             proc_pp        := pp_24_bnk;
             proc_gp        := gp_24_bnk;
             mode.calcofs   := calcofs_24_bnk;
           end;}
      32 : begin
             proc_pp        := pp_32_bnk;
             proc_ap        := ap_32_bnk;
             proc_gp        := gp_32_bnk;
             proc_addp      := addp_32_bnk;
             proc_subp      := subp_32_bnk;
             proc_hline     := hline_32_bnk;
             proc_patternln := pline_32_bnk;
             proc_vline     := vline_32_bnk;
             proc_line      := line_32_bnk;
             mode.calcofs   := calcofs_32_bnk;
           end;
{$ENDIF}
    end;
  end;
end;

constructor tgrafx.init;
begin
  onclose        := nil;
  with mode do begin
    visx       := resx;
    visy       := resy;
    linestyle  := lnsdefault;
    pattern    := ptdefault;
    font.font  := @fnsystem;
    pagesize   := resy*bpl;
    displayofs := 0;
    pageadd    := 0;
    getmem32(font.bmp8data,128*4);
  end;
  centerx   := maxx shr 1;
  centery   := maxy shr 1;
  case mode.bpp of
    8  : begin
           getmem32(mode.virtpal,1024);
           filldword(ptr48(mode.virtpal,0),1024,0);
           getmem32(mode.rgbdata,4096);
           filldword(ptr48(mode.rgbdata,0),4096,0);
           mode.palchanged := true;
         end;
    15 : begin
           rgb   := rgb_15;
           dergb := dergb_15;
         end;
    16 : begin
           rgb   := rgb_16;
           dergb := dergb_16;
         end;
 24,32 : begin
           rgb   := rgb_2432;
           dergb := dergb_2432;
         end;
  end;
end;

destructor tgrafx.close;
begin
  if @onclose <> nil then onclose;
  freemem32(mode.font.bmp8data);
end;

{$IFNDEF NOSCREEN}
constructor tgxscreen.init(xres,yres,bpp : longint;flags : longint);
var
  p       : pointer;
  modenum : longint;
  getmode : function(resx,resy : word;bpp : word;table : pmodetable) : longint;
begin
  if (workinggfxdrivers = 0) then fail;
  if (bpp = 8) then fail;
  if mode_open then close;
  fillbyte(farptr(@self),sizeof(tgrafx),0);
  mode.device := dvscreen;
  mode.flags  := 0;
  textscreen_get;
  if (bpp = 24)and(actdrv^.info.capabilities.cinterface and gdlinear = 0) then fail;
  if bpp in [
  {$IFDEF HICOLOR}15,16,clhi,{$ENDIF}
  {$IFDEF HICOLOR}{$IFDEF TRUECOLOR}clhitrue,clhitrueno24{$ENDIF}{$ENDIF}
  {$IFDEF TRUECOLOR},24,32,cltrue{$ENDIF}] then else fail;
  if (flags and mdbestfit <> 0) then
   getmode := modetable_mdbestfit else
   getmode := modetable_mdauto;
  modenum := getmode(xres,yres,bpp,@restab);
  if (modenum = 0) then fail; {Mode not available}
  if actdrv^.proc.setupvideo(modenum,mode,flags) <> denoerror
  then begin
    textscreen_discard;
    fail; { Error while initializing graphic mode }
  end;
  setviewport(self,0,0,mode.resx-1,mode.resy-1);
  if ((mode.flags and mdlinear) <> 0) then
    set4lin(self) else
  begin
    set4bnk(self);
    setbank := actdrv^.proc.setbank;
    decbank := actdrv^.proc.decbank;
    incbank := actdrv^.proc.incbank;
  end;
  if (flags and mdnoaccel = 0) then with actdrv^.info do
  begin { let's set accelerated procedures... }
    if capabilities.cbitmapping and gdblit <> 0 then proc_bitblit := actdrv^.proc.bitblit;
    if capabilities.cprimitives and gdfrect <> 0 then proc_fillrect := actdrv^.proc.fillrect;
    if capabilities.cinterface  and gdclear <> 0 then proc_clear := actdrv^.proc.clear;
  end;
  pagewait  := true;
  mode_open := true;
  inherited init;
end;

destructor tgxscreen.close;
begin
  inherited close;
  mode_open := false;
  actdrv^.proc.closevideo(mode);
  textscreen_put;
end;
{$ENDIF}

constructor tgxmem.init(var image : timage);
begin
  fillbyte(farptr(@self),sizeof(tgrafx)-2,0);
  if (image.id <> idimage)or(image.data = 0) then fail;
  if image.bpp in [
  {$IFDEF HICOLOR}15,16{$ENDIF}
  {$IFDEF HICOLOR}{$IFDEF TRUECOLOR},{$ENDIF}{$ENDIF}
  {$IFDEF TRUECOLOR}24,32{$ENDIF}] then else fail;
  fillbyte(farptr(@mode),sizeof(tmode),0);
  image.flags := image.flags or imlocked;
  with mode do begin
    flags   := 0;
    resx    := image.sizex;
    resy    := image.sizey;
    lasty   := maxy;
    bpp     := image.bpp;
    pixel   := image.pixel;
    bpl     := image.bpl;
    flags   := flags or mdlinear;
    writeptr   := image.data;
    readptr    := writeptr;
    memsize    := image.size;
    device     := dvmemory;
    numofpages := image.numofimages;
    imgptr     := @image;
  end;
  setviewport(self,0,0,mode.resx-1,mode.resy-1);
  set4lin(self);
  inherited init;
  mode.displayofs := image.imagestart;
end;

destructor tgxmem.close;
begin
  inherited close;
  imgptr^.flags := imgptr^.flags and not imlocked;
end;

constructor tgxwindow.init(x1,y1,x2,y2 : longint;var screen : tgrafx);
begin
  { Get all settings... }
  move2(farptr(@screen),farptr(@self),sizeof(tgrafx));
  father := @screen;
  if (x1 > x2) then swaplong(x1,x2);
  if (y1 > y2) then swaplong(y1,y2);
  if (x1 < screen.mode.actviewport.x1) then x1 := screen.mode.actviewport.x1;
  if (y1 < screen.mode.actviewport.y1) then y1 := screen.mode.actviewport.y1;
  if (x2 > screen.mode.actviewport.x2) then x2 := screen.mode.actviewport.x2;
  if (y2 > screen.mode.actviewport.y2) then y2 := screen.mode.actviewport.y2;
  setviewport(self,x1,y1,x2,y2);
  mode.device := mode.device or dvwindow;
  mode.numofpages := 1;
  inherited init;
end;

destructor tgxwindow.close;
begin
  inherited close;
end;

procedure tgxwindow.clear;
var
  oldfill : tpattern;
begin
  oldfill := mode.pattern;
  mode.pattern := ptdefault;
  fillrect(0,0,mode.maxx,mode.maxy,0,filldefault);
  mode.pattern := oldfill;
end;

function tgxwindow.move(x,y : longint) : word;
begin
  move := errrangeerror;
  if (x < 0)or(y < 0)or(x+mode.maxx > father^.maxx)or
     (y+mode.maxy > father^.maxy) then exit;
  setviewport(self,x,y,x+maxx,y+maxy);
  move := errnoerror;
end;

function tgxwindow.resize(xsize,ysize : longint) : word;
begin
  with mode.actviewport do
  if (xsize+x1 > father^.mode.actviewport.x2) then
    xsize := father^.mode.actviewport.x2-x1;
  with mode.actviewport do
  if (ysize+y1 > father^.mode.actviewport.y2) then
    ysize := father^.mode.actviewport.y2-y1;
  with mode.actviewport do
  setviewport(self,x1,y1,x1+xsize-1,y1+ysize-1);
  resize := errnoerror;
end;

procedure tgxwindow.setclipping(x1,y1,x2,y2 : longint);
begin
  if (x1 > x2) then swaplong(x1,x2);
  if (y1 > y2) then swaplong(y1,y2);
  if (x1 < father^.mode.actviewport.x1) then x1 := father^.mode.actviewport.x1;
  if (y1 < father^.mode.actviewport.y1) then y1 := father^.mode.actviewport.y1;
  if (x2 > father^.mode.actviewport.x2) then x2 := father^.mode.actviewport.x2;
  if (y2 > father^.mode.actviewport.y2) then y2 := father^.mode.actviewport.y2;
  setviewport(self,x1,y1,x2,y2);
end;

procedure tgxwindow.getclipping(var viewport : tviewport);
begin
  viewport := mode.actviewport;
end;

procedure tgrafx.bitblit(x1,y1,x2,y2,px,py : longint);
var
  pos1,pos2,sizey : longint;
  count,y,x3,y3   : longint;
  grablines,sizex : word;
  blocks          : word;
begin
  if (x1 > x2) then swaplong(x1,x2);
  if (y1 > y2) then swaplong(y1,y2);

  inc(x1,mode.actviewport.x1);
  inc(y1,mode.actviewport.y1);
  inc(x2,mode.actviewport.x1);
  inc(y2,mode.actviewport.y1);

  if (y1 > mode.actviewport.y2)or(y2 < mode.actviewport.y1) then exit;
  if (x1 > mode.actviewport.x2)or(x2 < mode.actviewport.x1) then exit;
  if x1 < mode.actviewport.x1 then begin
    inc(px,mode.actviewport.x1-x1);
    x1      := mode.actviewport.x1;
  end;
  if x2 > mode.actviewport.x2 then x2 := mode.actviewport.x2;
  if y1 < mode.actviewport.y1 then begin
    inc(py,mode.actviewport.y1-y1);
    y1 := mode.actviewport.y1;
  end;
  if y2 > mode.actviewport.y2 then y2 := mode.actviewport.y2;

  x3 := px+x2-x1;
  y3 := py+y2-y1;
  inc(px,mode.actviewport.x1);
  inc(py,mode.actviewport.y1);
  inc(x3,mode.actviewport.x1);
  inc(y3,mode.actviewport.y1);

  if (py > mode.actviewport.y2)or(y3 < mode.actviewport.y1) then exit;
  if (px > mode.actviewport.x2)or(x3 < mode.actviewport.x1) then exit;
  if px < mode.actviewport.x1 then begin
    inc(x1,mode.actviewport.x1-px);
    px      := mode.actviewport.x1;
  end;
  if x3 > mode.actviewport.x2 then
  begin
    Dec(x2,x3-mode.actviewport.x2);
    x3 := mode.actviewport.x2;
  end;
  if py < mode.actviewport.y1 then begin
    inc(y1,mode.actviewport.y1-py);
    py := mode.actviewport.y1;
  end;
  if y3 > mode.actviewport.y2 then
  begin
    Dec(y2,y3-mode.actviewport.y2);
    y3 := mode.actviewport.y2;
  end;

  sizex := (x2-x1+1);
  if (sizex > x3-px+1) then sizex := x3-px+1;
  count := sizex*mode.pixel;
  sizey := (y2-y1);
  if (sizey > y3-py) then sizey := y3-py;

  if @proc_bitblit <> nil then begin
    proc_bitblit(x1,y1,x1+sizex-1,y1+sizey,px,py);
  end else begin
    if (mode.flags and mdlinear = 0) then
    begin
      if (count > gfxbufsize) then begin
        sizex := gfxbufsize div mode.pixel;
        count := sizex*mode.pixel;
        grablines := 1;
        blocks    := sizey;
      end
      else begin
        count     := (count+7) and not 7;
        grablines := gfxbufsize div count-1;
        blocks    := sizey div grablines;
        if sizey mod grablines <> 0 then inc(grablines);
      end;
      if (y1 > py) then begin
        y := 0;
        for y2 := 0 to blocks do begin
          pos1 := 0;
          y3   := 0;
          while (y3 < grablines)and(y <= sizey) do begin
            getline(x1,y+y1,sizex,ptr48(gfxbufsel,pos1),mode.bpp);
            inc(pos1,count);
            inc(y);
            inc(y3);
          end;
          pos1 := 0;
          for grablines := 1 to y3 do begin
            drawline(px,y+py-y3+grablines-1,sizex,ptr48(gfxbufsel,pos1),mode.bpp,drdefault);
            inc(pos1,count);
          end;
        end;
      end else
      begin
        y := sizey;
        for y2 := 0 to blocks do begin
          pos1 := 0;
          y3   := 0;
          while (y3 < grablines)and(y >= 0) do begin
            getline(x1,y1+y,sizex,ptr48(gfxbufsel,pos1),mode.bpp);
            inc(pos1,count);
            dec(y);
            inc(y3);
          end;
          pos1 := 0;
          for grablines := 1 to y3 do begin
            drawline(px,py+y+y3-grablines+1,sizex,ptr48(gfxbufsel,pos1),mode.bpp,drdefault);
            inc(pos1,count);
          end;
        end;
      end;
    end else
    begin
      if (mode.device and dvmemory <> 0) then
      begin
        if (px <=x1) then
          if (y1 > py) then begin
            pos1 := mode.calcofs(x1,y1,mode)+mode.displayofs;
            pos2 := mode.calcofs(px,py,mode)+mode.displayofs;
            for y := 0 to sizey do begin
              move2(ptr48(mode.readptr,pos1),ptr48(mode.writeptr,pos2),count);
              inc(pos1,mode.bpl);
              inc(pos2,mode.bpl);
            end;
          end else
          begin
            pos1 := mode.calcofs(x1,y2,mode)+mode.displayofs;
            pos2 := mode.calcofs(px,y3,mode)+mode.displayofs;
            for y := 0 to sizey do begin
              move2(ptr48(mode.readptr,pos1),ptr48(mode.writeptr,pos2),count);
              dec(pos1,mode.bpl);
              dec(pos2,mode.bpl);
            end;
          end
        else
          if (y1 > py) then begin
            pos1 := mode.calcofs(x1,y1,mode)+mode.displayofs;
            pos2 := mode.calcofs(px,py,mode)+mode.displayofs;
            for y := 0 to sizey do begin
              backmove2(ptr48(mode.readptr,pos1),ptr48(mode.writeptr,pos2),count);
              inc(pos1,mode.bpl);
              inc(pos2,mode.bpl);
            end;
          end else
          begin
            pos1 := mode.calcofs(x1,y2,mode)+mode.displayofs;
            pos2 := mode.calcofs(px,y3,mode)+mode.displayofs;
            for y := 0 to sizey do begin
              backmove2(ptr48(mode.readptr,pos1),ptr48(mode.writeptr,pos2),count);
              dec(pos1,mode.bpl);
              dec(pos2,mode.bpl);
            end;
          end;
      end else begin
        if (count > gfxbufsize) then count := gfxbufsize;
        if (y1 > py) then begin
          pos1 := mode.calcofs(x1,y1,mode)+mode.displayofs;
          pos2 := mode.calcofs(px,py,mode)+mode.displayofs;
          for y := 0 to sizey do begin
            movefromscreen(ptr48(mode.readptr,pos1),gfxbufptr,count);
            move2screen(gfxbufptr,ptr48(mode.writeptr,pos2),count);
            inc(pos1,mode.bpl);
            inc(pos2,mode.bpl);
          end;
        end else
        begin
          pos1 := mode.calcofs(x1,y2,mode)+mode.displayofs;
          pos2 := mode.calcofs(px,y3,mode)+mode.displayofs;
          for y := 0 to sizey do begin
            movefromscreen(ptr48(mode.readptr,pos1),gfxbufptr,count);
            move2screen(gfxbufptr,ptr48(mode.writeptr,pos2),count);
            dec(pos1,mode.bpl);
            dec(pos2,mode.bpl);
          end;
        end;
      end;
    end;
  end;
end;

procedure tgrafx.draw(x,y: longint;var image : timage;flags : longint);
begin
  if (image.id <> idimage)or(image.data = 0) then exit;
{  if image.flags and imrle = 0 then begin}
    if (image.bpp = mode.bpp)and(image.flags and imalpha = 0)and
       (flags and (drsub or dradd) = 0)
    then proc_dr_curr(x,y,image,flags,mode) else
     proc_dr_conv(x,y,image,flags,mode);
(*  end else begin { RLE compressed image }
    if image.bpp <> mode.bpp then exit;
    proc_dr_rle(x,y,image,flags,mode);
  end;*)
end;

procedure tgrafx.scale(px,py,sx,sy : longint;image : timage;flags : longint);
begin
  proc_scale(image,px,py,sx,sy,flags,mode);
end;

procedure tgrafx.drawline(x1,y1,sizex : longint;data : pointer48;bpp,flags : longint);
var
  i3,mempos   : word;
  olx1        : longint;
  scrpos      : longint;
  convertdata : tcnvproc;
  cnvtmp      : pcnvproc;
  pixel       : word;
  putx        : longint;
label
  endofproc;
begin
  if tselofs32(data).selector = 0 then exit;
  if bpp < 8 then exit;
  if (bpp <> mode.bpp) then begin
    cnvtmp := getcnvproc(bpp,mode.bpp,cnvdrwmd);
    if cnvtmp = nil then exit;
    convertdata := tcnvproc(cnvtmp);
  end else
  begin
    case flags and (drand+drxor+dror+dradd+drsub) of
      drdefault : convertdata := move2screen;
      dradd     :
        case mode.bpp of
          15 : convertdata := add_15;
          16 : convertdata := add_16;
          24 : convertdata := add_24;
          32 : convertdata := add_32;
          else exit;
        end;
      drsub     :
        case mode.bpp of
          15 : convertdata := sub_15;
          16 : convertdata := sub_16;
          24 : convertdata := sub_24;
          32 : convertdata := sub_32;
          else exit;
        end;
      drxor     : convertdata := xor2screen;
      drand     : convertdata := and2screen;
      dror      : convertdata := or2screen;
      else exit;
    end;
  end;
  case bpp of
    1,2,4,8 : pixel := 1;
    15,16   : pixel := 2;
    24      : pixel := 3;
    32      : pixel := 4;
  end;

  asm
    db 66h;mov   cx,sizex.word
    db 66h;mov   ax,x1.word
    db 66h;or    cx,cx
           jz    endofproc
           jns   @next
    db 66h;neg   cx
    db 66h;sub   ax,cx
    @next:
           les   di,self
    db 66h;add   ax,es:[di].tmode.actviewport.x1.word
    db 66h;mov   olx1.word,ax
    db 66h;mov   bx,ax
    db 66h;add   bx,cx
    db 66h;mov   si,y1.word
    db 66h;add   si,es:[di].tmode.actviewport.y1.word
    db 66h;cmp   si,es:[di].tmode.actviewport.y1.word
           jl    endofproc
    db 66h;cmp   si,es:[di].tmode.actviewport.y2.word
           jg    endofproc
    db 66h;mov   cx,es:[di].tmode.actviewport.x1.word
    db 66h;mov   dx,es:[di].tmode.actviewport.x2.word
    db 66h;cmp   ax,dx
           jge   endofproc
    db 66h;cmp   bx,cx
           jle   endofproc
    db 66h;cmp   ax,cx
           jnl   @next1
    db 66h;mov   ax,cx
    @next1:
    db 66h;inc   dx
    db 66h;cmp   bx,dx
           jng   @next2
    db 66h;mov   bx,dx
    @next2:
    db 66h;sub   bx,ax
    db 66h;mov   sizex.word,bx
    db 66h;sub   ax,es:[di].tmode.actviewport.x1.word
    db 66h;sub   si,es:[di].tmode.actviewport.y1.word
    db 66h;add   si,es:[di].tmode.pageadd.word
    db 66h;mov   bx,ax
    db 66h;sub   bx,olx1.word
    db 66h;mov   x1.word,ax
    db 66h;mov   y1.word,si
           mov   ax,bx
           mul   pixel
           mov   mempos,ax
  end;
  putx  := sizex*mode.pixel;
  sizex := sizex*pixel;
  cnvxpos := x1;
  cnvypos := y1;
  if (mode.flags and mdlinear = 0) then begin
    scrpos := mode.calcofs(x1,y1+mode.pageadd,mode);
    if word(scrpos) < word(scrpos)+word(putx) then
    convertdata(ptr48(seg48(data),ofs48(data)+mempos),ptr48(mode.writeptr,scrpos),sizex)
    else begin
      i3 := 0-word(scrpos);
      convertdata(ptr48(seg48(data),ofs48(data)+mempos),ptr48(mode.writeptr,scrpos),i3 div mode.pixel*pixel);
      incbank;
      convertdata(ptr48(seg48(data),ofs48(data)+i3 div mode.pixel*pixel+mempos),
                  ptr48(mode.writeptr,0),sizex-i3 div mode.pixel*pixel);
    end;
  end else begin
    scrpos := mode.calcofs(x1,y1,mode)+mode.displayofs;
    convertdata(ptr48(seg48(data),ofs48(data)+mempos),ptr48(mode.writeptr,scrpos),sizex);
  end;
  endofproc:
end;

procedure tgrafx.getline(x1,y1,sizex : longint;data : pointer48;bpp : word);
var
  i3,mempos   : word;
  olx1        : integer;
  scrpos      : longint;
  convertdata : tcnvproc;
  cnvtmp      : pcnvproc;
label
  endofproc;
begin
  if tselofs32(data).selector = 0 then exit;
  if bpp < 8 then exit;
  convertdata := movefromscreen;
  if bpp <> mode.bpp then begin
    cnvtmp := getcnvproc(bpp,mode.bpp,cnvdefault);
    if cnvtmp = nil then exit;
    convertdata := tcnvproc(cnvtmp);
  end;
  asm
    db 66h;mov   cx,sizex.word
    db 66h;mov   ax,x1.word
    db 66h;or    cx,cx
           jz    endofproc
           jns   @next
    db 66h;neg   cx
    db 66h;sub   ax,cx
    @next:
           les   di,self
    db 66h;add   ax,es:[di].tmode.actviewport.x1.word
    db 66h;mov   olx1.word,ax
    db 66h;mov   bx,ax
    db 66h;add   bx,cx
    db 66h;mov   si,y1.word
    db 66h;add   si,es:[di].tmode.actviewport.y1.word
    db 66h;cmp   si,es:[di].tmode.actviewport.y1.word
           jl    endofproc
    db 66h;cmp   si,es:[di].tmode.actviewport.y2.word
           jg    endofproc
    db 66h;mov   cx,es:[di].tmode.actviewport.x1.word
    db 66h;mov   dx,es:[di].tmode.actviewport.x2.word
    db 66h;cmp   ax,dx
           jge   endofproc
    db 66h;cmp   bx,cx
           jle   endofproc
    db 66h;cmp   ax,cx
           jnl   @next1
    db 66h;mov   ax,cx
    @next1:
    db 66h;inc   dx
    db 66h;cmp   bx,dx
           jng   @next2
    db 66h;mov   bx,dx
    @next2:
    db 66h;sub   bx,ax
    db 66h;mov   sizex.word,bx
    db 66h;sub   ax,es:[di].tmode.actviewport.x1.word
    db 66h;sub   si,es:[di].tmode.actviewport.y1.word
    db 66h;add   si,es:[di].tmode.pageadd.word
    db 66h;mov   bx,ax
    db 66h;sub   bx,olx1.word
           mov   mempos,bx
    db 66h;mov   x1.word,ax
    db 66h;mov   y1.word,si
  end;
  sizex := sizex * mode.pixel;
  if (mode.flags and mdlinear = 0) then begin
    scrpos := mode.calcofs(x1,y1+mode.pageadd,mode);
    if word(scrpos) < word(scrpos)+word(sizex) then
    convertdata(ptr48(mode.writeptr,scrpos),ptr48(seg48(data),ofs48(data)+mempos),sizex)
    else begin
      i3 := 0-word(scrpos);
      convertdata(ptr48(mode.writeptr,scrpos),ptr48(seg48(data),ofs48(data)+mempos),i3);
      incbank;
      convertdata(ptr48(mode.writeptr,0),ptr48(seg48(data),ofs48(data)+mempos+i3),sizex-i3);
    end;
  end else begin
    scrpos := mode.calcofs(x1,y1,mode)+mode.displayofs;
    convertdata(ptr48(mode.writeptr,scrpos),ptr48(seg48(data),ofs48(data)+mempos),sizex);
  end;
  endofproc:
end;

procedure tgrafx.flood(x,y,col : longint);

Type Ptfile=^fil;              { We use Pointer Typed Structures to }
     Fil=Record                { save in memory where and what to fill }
               x:longint;      { it's not very quick, it is VERY SLOW, but }
               y:longint;      { it's fun and it works !!!!! }
               suivant:ptfile; { THIS STUPID PC COMPUTER have no Blitter !! }
         End;

var
  tete,queue : ptfile;       { head & queue of the list }
  fillcol    : longint;       { The color's where we click }
  x2,y2      : longint;

procedure initfile;{(var tete,queue:ptfile);{}
begin
     tete :=nil;  { Head at NIL }
     new(tete);   { New Head }
     queue:=tete; { Queue = Head }
end;

function filevide:boolean; { Test if the file is empty }
begin
     filevide:=(tete=nil); { tete = Nil ? Yes -> FileVide:=True }
end;

procedure defiler(var x,y : longint);
var
  adetruire : ptfile;
begin
  adetruire:=tete;     { To kill -> the first element of the list }
  tete:=tete^.suivant; { The new head is the next }
  x:=adetruire^.x;     { get x }
  y:=adetruire^.y;     { get y }
  dispose(adetruire);  { kill old head }
end;

Procedure enfiler(x,y:integer);
begin
     queue^.x:=x;           { save x }
     queue^.y:=y;           { save y }
     new(queue^.suivant);   { new allocation for the next one }
     queue:=queue^.suivant; { queue is now the next new allocated }
     queue^.suivant:=nil;   { and it's on nil }
end;

begin
  fillcol := proc_gp(x,y,mode);{ Color to Fill }
  if (col <> fillcol) then  { Need FIll ?? }
  begin
    initfile;  { Initialise the list }
    { Routines that follow are here for the fun of the }
    { filling method ... :) }
    x2 := x;
    y2 := y; { Save x and y }
    while ((x2+1) < maxx) and (proc_gp(x2+1,y,mode) = fillcol) do inc(x2);
    enfiler(x2,y2); { max possible right of the center x,y }

    { between center and max right }
    enfiler(abs((x2+x) div 2),abs((y2+y) div 2));

    x2 := x;
    y2 := y;
    while ((x2-1) > 0) and (proc_gp(x2-1,y,mode) = fillcol) do dec(x2);
    enfiler(x2,y2); { max possible left of the center x,y }

    { between center and max left }
    enfiler(abs((x2+x) div 2),abs((y2+y) div 2));

    x2 := x;
    y2 := y;
    while ((y2+1) < maxy) and (proc_gp(x,y2+1,mode) = fillcol) do inc(y2);
    enfiler(x2,y2); { max possible bottom of the center x,y }

    { between center and max bottom }
    enfiler(abs((x2+x) div 2),abs((y2+y) div 2));

    x2 := x;
    y2 := y;
    while ((y2-1) > 0) and (proc_gp(x,y2-1,mode) = fillcol) do dec(y2);
    enfiler(x2,y2); { max possible top of the center x,y }

    { between center and max top }
    enfiler(abs((x2+x) div 2),abs((y2+y) div 2));

    { here's the filling routine... }
    repeat
      if ((x+1) < maxx) and (proc_gp(x+1,y,mode) = fillcol) then
      begin                              {...}
        enfiler(x+1,y); {.*+}
        proc_pp(x+1,y,col,mode);         {...}
      end;
      if ((y+1) < maxy) and (proc_gp(x,y+1,mode) = fillcol) then
      begin                              {...}
        enfiler(x,y+1); {.*.}
        proc_pp(x,y+1,col,mode);         {.+.}
      end;
      if ((y-1) >= 0) and (proc_gp(x,y-1,mode) = fillcol) then
      begin                              {.+.}
        enfiler(x,y-1); {.*.}
        proc_pp(x,y-1,col,mode);         {...}
      end;
      if ((x-1) >= 0) and (proc_gp(x-1,y,mode) = fillcol) then
      begin                              {...}
        enfiler(x-1,y); {+*.}
        proc_pp(x-1,y,col,mode);         {...}
      end;
      defiler(x,y);
    until filevide;
  end;
end;

{procedure tgrafx.setclipping(x1,y1,x2,y2 : longint);
begin
  if (x1 > x2) then swapint(x1,x2);
  if (y1 > y2) then swapint(y1,y2);
  if (x1 < 0) then x1 := 0;
  if (y1 < 0) then y1 := 0;
  if (x2 > mode.resx-1) then x2 := mode.resx-1;
  if (y2 > mode.lasty) then y2 := mode.lasty;
  setviewport(self,x1,y1,x2,y2);
end;

procedure tgrafx.getclipping(var viewport : tviewport);
begin
  viewport := mode.actviewport;
end;}

{$IFNDEF NOSCREEN}
function tgxscreen.setdrawpage(page : longint) : word;
begin
  setdrawpage := errnodvsupport;
  if (page > mode.numofpages-1) then exit;
  mode.displayofs := page*mode.pagesize;
  mode.pageadd    := page*mode.resy;
  mode.actpage    := page;
  setdrawpage := errnoerror;
end;

function tgxscreen.setvisiblepage(page : longint) : word;
begin
  setvisiblepage := errnodvsupport;
  if (page > mode.numofpages-1)or
     (actdrv^.info.capabilities.cinterface and gdsetoffset = 0) then exit;
  actdrv^.proc.setdisplaypos(0,longint(mode.resy)*page);
  mode.vispage := page;
  setvisiblepage := errnoerror;
  if pagewait then pageretrace;
end;

function tgxscreen.setdisplaystart(x,y : longint) : word;
begin
  setdisplaystart := errnodvsupport;
  if (actdrv^.info.capabilities.cinterface and gdsetoffset = 0) then exit;
  actdrv^.proc.setdisplaypos(x,y);
  setdisplaystart := errnoerror;
end;

function tgxscreen.setvirtualscreenwidth(width : longint) : word;
var
  return : word;
begin
  setvirtualscreenwidth := errnodvsupport;
  if (actdrv^.info.capabilities.cinterface and gdvwidth = 0) then exit;
  if (width < maxx+1) then exit;
  return := actdrv^.proc.setvirtualscreenwidth(width);

  if (return = 0) then exit;

  setvisiblepage(0);
  setdrawpage(0);
  mode.resx  := return;
  mode.bpl   := return*mode.pixel;
  mode.lasty := mode.memsize div mode.bpl-mode.requiredlines-1;
  mode.pagesize := mode.bpl*mode.resy;
  mode.numofpages := mode.lasty div mode.resy;

  setvirtualscreenwidth := errnoerror;
end;

function tgxscreen.resetscreenwidth : word;
var
  err : word;
begin
  err := setvirtualscreenwidth(mode.visx);
  if err <> errnoerror then exit;
  resetviewport;
  setvisiblepage(0);
  setdrawpage(0);
  resetscreenwidth := errnoerror;
end;

function tgxscreen.setfullviewport : word;
begin
  setviewport(self,0,0,mode.resx-1,mode.lasty);
  mode.pagesize   := (mode.lasty)*mode.bpl;
  mode.numofpages := 1;
  setvisiblepage(0);
  setdrawpage(0);
  setfullviewport := errnoerror;
end;

function tgxscreen.resetviewport : word;
begin
  setviewport(self,0,0,mode.visx-1,mode.visy-1);
  mode.pagesize := (mode.visy)*mode.bpl;
  mode.numofpages := mode.memsize div mode.pagesize;
  setvisiblepage(0);
  setdrawpage(0);
  resetviewport := errnoerror;
end;

procedure tgxscreen.copypage(srcpage,destpage : longint);
var
  image : timage;
  vp    : tviewport;
  lpage : word;
begin
  if (srcpage > mode.numofpages-1)or(destpage > mode.numofpages-1)or
  (srcpage = destpage) then exit;
  lpage := mode.actpage;
  vp    := mode.actviewport;
  mode.actviewport.y2 := mode.lasty;
  setdrawpage(0);
  bitblit(0,srcpage*mode.resy,mode.maxx,srcpage*mode.resy+mode.maxy,
          0,destpage*mode.resy);
  mode.actviewport := vp;

{  setdrawpage(srcpage);
  get(0,0,mode.maxx,mode.maxy,image);
  setdrawpage(destpage);
  draw(0,0,image,imdefault);
  closeimage(image); }
  setdrawpage(lpage);
end;
{$ENDIF}

procedure tgrafx.get(x1,y1,x2,y2 : longint;var image : timage);
begin
  if (image.id <> idimage)or(image.data = 0)or
     (image.flags and imrle <> 0)or
     (abs(x2-x1)+1 <> image.sizex)or(abs(y2-y1)+1 <> image.sizey)or
     (image.bpp <> mode.bpp)
     then begin
    if closeimage(image) <> errnoerror then exit;
    if openimage(image,abs(x2-x1)+1,abs(y2-y1)+1,mode.bpp,1,imdefault) <> errnoerror
    then exit;
  end;
  if image.bpp = mode.bpp then proc_gt_curr(x1,y1,x2,y2,image,mode) else
  exit;
end;

function tgrafx.getversionstring : string;
begin
  getversionstring := gx_versionstr;
end;

procedure clearimage(image : timage;col : longint);
var
  imgpos     : longint;
  y,c        : word;
begin
  if (image.id <> idimage)or(image.data = 0) then exit;
  imgpos := image.imagestart;
  case image.bpp of
    8     : fillbyte(ptr48(image.data,image.imagestart),longint(image.bpl)*image.sizey,col);
    15,16 : for y := 0 to image.sizey-1 do begin
              fillword(ptr48(image.data,imgpos),image.sizex shl 1,col);
              inc(imgpos,image.bpl);
            end;
    24    : for y := 0 to image.sizey-1 do begin
              fill24(ptr48(image.data,imgpos),image.sizex*3,col);
              inc(imgpos,image.bpl);
            end;
    32    : for y := 0 to image.sizey-1 do begin
              filldword(ptr48(image.data,imgpos),image.sizex shl 2,col);
              inc(imgpos,image.bpl);
            end;
    1,2,4 : begin
              col := col and ((1 shl image.bpp)-1);
              c   := 0;
              for y := 0 to (8 div image.bpp)-1 do c := c or col shl y*image.bpp;
              for y := 0 to image.sizey-1 do begin
                fillbyte(ptr48(image.data,imgpos),image.bpl,c);
                inc(imgpos,image.bpl);
              end;
            end;
  end;
end;

function convertimage(source : timage;var dest : timage;destbpp : word) : word;
var
  y           : longint;
  imgpos      : longint;
  err         : word;
  convertdata : tcnvproc;
  cnvtmp      : pcnvproc;
begin
  convertimage := errfalseformat;
  if source.flags and imrle <> 0 then exit;
  if source.bpp <= 8 then begin
    if source.flags and (impalette) <> 0 then begin
      cnvpal := gfxbufptr;
      case destbpp of
        32,24 : cnvpal := ptr48(source.data,source.palstart);
        16    : pal_32to16(ptr48(source.data,source.palstart),gfxbufptr,word(1) shl source.bpp);
        15    : pal_32to15(ptr48(source.data,source.palstart),gfxbufptr,word(1) shl source.bpp);
      end;
    end else begin
      convertimage := errnopal;
      exit;
    end;
  end;
  if (dest.id = idimage)and(dest.data <> 0) then closeimage(dest);
  openimage(dest,source.sizex,source.sizey,destbpp,1,imdefault);
  cnvtmp := getcnvproc(source.bpp,dest.bpp,cnvdefault);
  convertimage := errfalsebpp;
  if cnvtmp = nil then exit;
  convertdata := tcnvproc(cnvtmp);
  imgpos := dest.imagestart;
  for y := 0 to source.sizey-1 do begin
    convertdata(ptr48(source.data,source.imagestart),
                ptr48(dest.data,imgpos),source.bpl);
    inc(source.imagestart,source.bpl);
    inc(imgpos,dest.bpl);
  end;
  dest.spotx := source.spotx;
  dest.spoty := source.spoty;
  if source.flags and imsprite <> 0 then begin
    convertdata(farptr(@source.transcol),farptr(@dest.transcol),source.pixel);
    dest.flags := dest.flags or imsprite;
  end;
  convertimage := errnoerror;
end;

function duplicateimage(source : timage;var dest : timage) : word;
{ Fully duplicates an image into another. All values will get copied,
  the destination image does only use other memory                    }
begin
  duplicateimage := errnotopen;
  if (source.data = 0)or(source.id <> idimage) then exit;
  if (dest.data <> 0)and(dest.id = idimage) then closeimage(dest);
  dest      := source;
  dest.data := 0;
  if source.size > maxavail32 then begin
    duplicateimage := errnomem;
    fillbyte(farptr(@dest),sizeof(timage),0);
    exit;
  end;
  dest.flags := dest.flags and not imlocked;
  getmem32(dest.data,dest.size);
  dest.imagestart := 0;
  if source.flags and immulti <> 0 then
  move2(ptr48(source.data,0),ptr48(dest.data,0),dest.size)
  else
  move2(ptr48(source.data,source.imagestart),ptr48(dest.data,dest.imagestart),dest.size);
  duplicateimage := errnoerror;
end;

function flipimage(source : timage;var dest : timage) : word;
begin
  flipimage := errnotopen;
  if (source.id <> idimage)or(dest.data = 0) then exit;
  if (dest.id <> idimage)or(dest.data = 0) then
   openimage(dest,source.sizex,source.sizey,source.bpp,1,source.flags);
  flipimage := errwrongsize;
  if (source.sizex <> dest.sizex)or(source.sizey <> dest.sizey) then exit;
  if (source.size <> dest.size) then exit;
  flipimage := errfalsebpp;
  if (source.bpp <> dest.bpp) then exit;
  move2(ptr48(source.data,source.imagestart),ptr48(dest.data,dest.imagestart),
        source.size);
  flipimage := errnoerror;
end;

function imageopen(image : timage) : boolean;
begin
  imageopen := (image.id = idimage)and(image.data <> 0);
end;

function openimage(var image : timage;sx,sy,bipp,images : word;flags : longint) : word;
var
  err,i    : word;
  subimage : tsubimage;
  imgstart : longint;
begin
  if (image.id = idimage)and(image.data <> 0) then
  begin
    err := closeimage(image);
    openimage := err;
    if err <> errnoerror then exit;
  end;
  if bipp in [1,2,4,8,15,16,24,32] then else begin
    openimage := errfalsebpp;
    exit;
  end;
  fillbyte(farptr(@image),sizeof(timage),0);
  with image do begin
    id         := idimage;
    version    := $0100;
    sizex      := sx;
    sizey      := sy;
    bpp        := bipp;
    pixel      := (bpp+7) shr 3;
    if pixel = 0 then pixel := 1;
    bpl        := longint(sx)*pixel;
    if bpp < 8 then case bpp of
      1 : bpl := (bpl+7) shr 3;
      2 : bpl := (bpl+3) shr 2;
      4 : bpl := (bpl+1) shr 1;
    end;
    bpl := (bpl+7) and not 7;         { 64 bit alignment,   }
    size := longint(bpl)*sy;          { needed e.g. for MMX }
    size := (size+15) and not 7;
    if size > maxavail32 then
    begin
      fillbyte(farptr(@image),sizeof(timage),0);
      openimage := errnomem;
      exit;
    end;
    image.numofimages := 1;
  end;
  image.flags := image.flags or (flags and imsprite);
  if (image.bpp <= 8) then
   image.flags := image.flags or (flags and (imallpal or imgreyscale))
   else image.flags := image.flags or (flags and imswap);
  if image.bpp = 32 then
   image.flags := image.flags or (flags and imalpha);


  if images > 1 then begin

    if (image.bpp <= 8)and(flags and impalette <> 0)and
       (flags and imallpal = 0) then begin
      image.palstart := image.size+sizeof(tsubimage)+longint(images) shl 2;
      inc(image.size,word(4) shl image.bpp);
      image.flags := image.flags or impalette;
    end;

    image.flags := image.flags or immulti or imidentical;
    image.imagestart := sizeof(tsubimage)+longint(images) shl 2;

    subimage.sizex      := image.sizex;
    subimage.sizey      := image.sizey;
    subimage.bpp        := image.bpp;
    subimage.bpl        := image.bpl;
    subimage.pixel      := image.pixel;
    subimage.size       := image.size;
    subimage.imagestart := image.imagestart+sizeof(tsubimage);
    subimage.palstart   := image.palstart;
    subimage.flags      := image.flags and $FFFFFF;
    subimage.transcol   := image.transcol;

    image.size        := (image.size+sizeof(tsubimage)+4)*images;
    image.numofimages := images;

    if (image.bpp <= 8)and(flags and impalette <> 0)and
       (flags and imallpal <> 0) then begin
      image.palstart := image.size;
      subimage.palstart := image.palstart;
      inc(image.size,word(4) shl image.bpp);
      image.flags := image.flags or impalette or imallpal;
    end;

  end else begin
    if (image.bpp <= 8)and(flags and impalette <> 0) then begin
      image.palstart := image.size;
      inc(image.size,word(4) shl image.bpp);
      image.flags := image.flags or impalette;
    end;
  end;

  if image.size > maxavail32 then begin
    fillbyte(farptr(@image),sizeof(timage),0);
    openimage := errnomem;
    exit;
  end;
  getmem32(image.data,image.size);
  if image.data = 0 then begin
    fillbyte(farptr(@image),sizeof(timage),0);
    openimage := erralloc;
    exit;
  end;

  if images > 1 then begin
    imgstart := image.imagestart;
    for i := 0 to images-1 do begin
      writemem32l(ptr48(image.data,longint(i) shl 2),imgstart);
      move2(farptr(@subimage),ptr48(image.data,imgstart),sizeof(tsubimage));
      if (flags and impalette <> 0)and(flags and imallpal = 0) then
        inc(subimage.palstart,subimage.size+sizeof(tsubimage));
      inc(subimage.imagestart,subimage.size+sizeof(tsubimage));
      inc(imgstart,subimage.size+sizeof(tsubimage));
    end;
    setsubimage(image,0);
  end;

  openimage := errnoerror;
end;

function setsubimage(var image : timage;subimage : word) : word;
var
  oflags : longint;
  osize  : longint;
begin
  setsubimage := errgenerror;
  if (image.id <> idimage)or(image.data = 0) then exit;
  if (subimage >= image.numofimages) then exit;
  if (image.numofimages <= 1) then exit;

  oflags := image.flags and $FF000000;
  osize  := image.size;
  move2(ptr48(image.data,readmem32l(ptr48(image.data,longint(subimage) shl 2))),
        farptr(@image.sizex),
        sizeof(tsubimage));
  image.flags := image.flags and $FFFFFF or oflags;
  image.size  := osize;
  setsubimage := errnoerror;
end;

function closeimage(var image : timage) : word;
begin
  if (image.id = idimage)and(image.data <> 0) then begin
    if (image.flags and imlocked <> 0) then begin
      closeimage := errlocked;
      exit;
    end;
    freemem32(image.data);
    fillbyte(farptr(@image),sizeof(timage),0);
{  end else begin
    closeimage := ernoimage;
    exit;} { Shouldn't be neccessary, I think }
  end;
  closeimage := errnoerror;
end;

function pointertoimage(p : pointer;var image : timage) : word;
var
  err : word;
begin
  if (image.id = idimage)and(image.data <> 0) then
  err := closeimage(image) else err := errnoerror;
  pointertoimage := err;
  if err <> errnoerror then exit;
  move2(farptr(p),farptr(@image),sizeof(timage));
  if (image.id <> idimage) then begin
    pointertoimage := errnotopen;
    exit;
  end;
  image.flags := image.flags or imlocked;
  image.data  := seg(p^);
  inc(image.imagestart,longint(p) and $FFFF+sizeof(timage));
  pointertoimage := errnoerror;
end;

procedure setfailproc(proc : tfailproc);
begin
  check4fail := proc;
end;

function geterrorstring(code : word) : string;
begin
  code := lo(code);
  if code > errmaxerror then code := errgenerror;
  geterrorstring := errerrorstr[code];
end;

procedure check4fail_std(code : word);
var
  s : string;
begin
  if code <> 0 then begin
{    writeln('Error priority: ',code shr 12);}
    s := 'Importance: '#10#13;
    case code shr 12 of
      0 : s := s+'No reason to stop program'#10#13;
      1 : s := s+'Middle'#10#13;
      else s := s+'Fatal'#10#13;
    end;

    s := s+geterrorstring(code);
    writeln(gxerror,s);
  end;
end;

var
  i       : integer;
  oldexit : pointer;

procedure gx2_exit;far;
begin
  closefont(fnsystem);
  freemem32(gfxbufsel);
  if erroraddr <> nil then asm mov ax,3;int 10h end;
  exitproc := oldexit;
end;

procedure switchcpuext(flags : longint);far;
begin
  if flags and cpummx <> 0 then
  begin
    move2screen   := move2screen_mmx;
    movefromscreen:= movefromscreen_mmx;
    movemul2screen:= movemul2screen_mmx;
    xor2screen    := xor2screen_mmx;
    and2screen    := and2screen_mmx;
    or2screen     := or2screen_mmx;
    addfill_32    := addfill_32_mmx;
    subfill_32    := subfill_32_mmx;
    pattadd_32    := pattadd_32_mmx;
    pattsub_32    := pattsub_32_mmx;
    pattxor_32    := pattxor_32_mmx;
    fillxor_1516  := fillxor_1516_mmx;
    fillxor_32    := fillxor_32_mmx;
    fill16screen  := fillword_mmx;
    fill32screen  := filldword_mmx;
    fillword      := fillword_mmx;
    filldword     := filldword_mmx;
  end else begin
    move2screen   := move2screen_386;
    movemul2screen:= movemul2screen_386;
    movefromscreen:= movefromscreen_386;
    xor2screen    := xor2screen_386;
    and2screen    := and2screen_386;
    or2screen     := or2screen_386;
    addfill_32    := addfill_32_386;
    subfill_32    := subfill_32_386;
    pattadd_32    := pattadd_32_386;
    pattsub_32    := pattsub_32_386;
    pattxor_32    := pattxor_32_386;
    fillxor_1516  := fillxor_1516_386;
    fillxor_32    := fillxor_32_386;
    fill16screen  := fillword_386;
    fill32screen  := filldword_386;
    fillword      := fillword_386;
    filldword     := filldword_386;
  end;
end;

var
  drv : pdrvregistered;
begin
  {$IFDEF VERBOSE}
  writeln;
   writeln(gx_versionstr);
  {$ENDIF}
  cpuext := 0;
  if test3dnow then begin
    {$IFDEF VERBOSE}
    writeln('3DNow! extension detected');
    {$ENDIF}
    cpuext := cpuext or cpummx or cpu3dn;
  end else if testmmx then begin
    {$IFDEF VERBOSE}
    writeln('MMX extension detected');
    {$ENDIF}
    cpuext := cpuext or cpummx;
  end;

  registercpuswitch(@switchcpuext);
  switchcpuext(cpuext);
  setfailproc(check4fail_std);

{$IFNDEF NOSCREEN}

  {$IFDEF VERBOSE}
  writeln('Registered drivers: ',registeredgfxdrivers);
  writeln('Working drivers   : ',workinggfxdrivers);
  {$ENDIF}

  if workinggfxdrivers = 0 then
  begin
    writeln('*** WARNING ***');
    writeln('GX2 -- Error while initializing video drivers');
    writeln('No supported card detected. Please install a VESA 1.2+ driver to');
    writeln('work with GFX modes in GX2.');
    writeln('Press enter to continue...');
    readln;
  end;
  drv := lastdrv.next;
  while (drv <> nil) do begin
    if (drv^.detected > 0)and(actdrv <> nil) then begin
      if drv^.driver^.info.priority > actdrv^.info.priority then
      actdrv := drv^.driver;
    end else actdrv := drv^.driver;
    drv := drv^.next;
  end;
  actdrv^.proc.fillmodetable(restab);
  modetable_sort(@restab);
{$ENDIF}
  oldexit  := exitproc;
  exitproc := @gx2_exit;
end.

