;GrafX2 image manipulation effects
;(c) 1998-1999 by Stefan Goehler
;detailed copyright notices in grafx2.txt
;copy illegal without grafx2.txt

;!! = procedures or parts which are untested yet or/and have bugs or aren't
;finished yet

.model large,pascal
.386p
.data

;Image rotation
public rotate_8
public rotate_1516
public rotate_24
public rotate_32

public rotate_8_trans
public rotate_1516_trans
public rotate_24_trans
public rotate_32_trans

;Mosaic fading procedures
public block_8
public block_1516
public block_24
public block_32

;Brightness manipulating procedures
public fadeout_15
public fadeout_16
public fadeout_24_386
public fadeout_32_386
public fadeout_32_mmx

public fadewhite_15
public fadewhite_16
public fadewhite_24_386
public fadewhite_32_386
public fadewhite_32_mmx

public brightness_15_386
public brightness_16_386
public brightness_24_386
public brightness_32_386
public brightness_24_mmx
public brightness_32_mmx
public brightness_chn

public contrastdown_15_386
public contrastdown_16_386
public contrastdown_24_386
public contrastdown_32_386
public contrastup_15_386
public contrastup_16_386
public contrastup_24_386
public contrastup_32_386
public contrast_32_mmx

;Greyscale conversion
public rgb2bw_24
public rgb2bw_32

;Sharpness manipulation
public blur_24_386
public blur_32_386
public blur_32_mmx

;Experimental red blur outfading
public fadered_32

public scaleup_8
public scaleup_1516
public scaleup_24
public scaleup_32

;50% Dither mixing procedures
public dithmix_8
public dithmix_1516
public dithmix_32

public mirror_8
public mirror_16
public mirror_24
public mirror_32
ends

.code
include ctmmxn.inc

;!! untested
rotate_8 proc
arg source:pword,dest:pword,tables:pword,sizex:dword,ysin:dword,ycos:dword,transcol:dword
        mov   esi,sizex
        dec   esi
        jz    @end_r8
        les   edi,source
        lfs   edi,dest
        mov   ebx,ysin ;ysin
        mov   edx,ycos ;ycos
        push  ds
        lds   eax,tables
        jmp   @xlp2_r8
@xloop_r8:
          mov   al,byte ptr transcol
          mov   fs:[edi-1],al
          dec   esi
          js    @end_r8
@xlp2_r8:
          inc   edi
          mov   eax,ds:[esi*8]       ;xsin
          mov   ecx,ds:[esi*8+4]     ;xcos
          add   eax,edx              ;ycos
          sub   ecx,ebx              ;ysin
          sar   eax,1
          js    @xloop_r8
          sar   ecx,1
          js    @xloop_r8
          cmp   eax,ds:[131068]  ;destsy
          jnl   @xloop_r8
          cmp   ecx,ds:[131064]  ;destsx
          jnl   @xloop_r8

          mov   eax,ds:[eax*4+87386]
          mov   al,es:[eax+ecx]
          mov   fs:[edi-1],al
          dec   esi
          jns   @xlp2_r8
@end_r8:
        pop   ds
        ret
rotate_8 endp

;!! untested
rotate_8_trans proc
arg source:pword,dest:pword,tables:pword,sizex:dword,ysin:dword,ycos:dword,transcol:dword
        mov   esi,sizex
        dec   esi
        jz    @end_r8tr
        les   edi,source
        lfs   edi,dest
        mov   ebx,ysin ;ysin
        mov   edx,ycos ;ycos
        push  ds
        lds   eax,tables
        jmp   @xlp2_r8tr
@xloop_r8tr:
          dec   esi
          js    @end_r8tr
@xlp2_r8tr:
          inc   edi
          mov   eax,ds:[esi*8]       ;xsin
          mov   ecx,ds:[esi*8+4]     ;xcos
          add   eax,edx              ;ycos
          sub   ecx,ebx              ;ysin
          sar   eax,1
          js    @xloop_r8tr
          sar   ecx,1
          js    @xloop_r8tr
          cmp   eax,ds:[131068]  ;destsy
          jnl   @xloop_r8tr
          cmp   ecx,ds:[131064]  ;destsx
          jnl   @xloop_r8tr

          mov   eax,ds:[eax*4+87386]
          mov   al,es:[eax+ecx]
          mov   fs:[edi-1],al
          dec   esi
          jns   @xlp2_r8tr
@end_r8tr:
        pop   ds
        ret
rotate_8_trans endp

rotate_1516 proc
arg source:pword,dest:pword,tables:pword,sizex:dword,ysin:dword,ycos:dword,transcol:dword
        mov   esi,sizex
        dec   esi
        jz    @end_r16
        les   edi,source
        lfs   edi,dest
        mov   ebx,ysin ;ysin
        mov   edx,ycos ;ycos
        push  ds
        lds   eax,tables
        jmp   @xlp2_r16
@xloop_r16:
          mov   ax,word ptr transcol
          mov   fs:[edi-2],ax
          dec   esi
          js    @end_r16
@xlp2_r16:
          add   edi,2
          mov   eax,ds:[esi*8]       ;xsin
          mov   ecx,ds:[esi*8+4]     ;xcos
          add   eax,edx              ;ycos
          sub   ecx,ebx              ;ysin
          sar   eax,1
          js    @xloop_r16
          sar   ecx,1
          js    @xloop_r16
          cmp   eax,ds:[131068]  ;destsy
          jnl   @xloop_r16
          cmp   ecx,ds:[131064]  ;destsx
          jnl   @xloop_r16

          mov   eax,ds:[eax*4+87386]
          mov   ax,es:[eax+ecx*2]
          mov   fs:[edi-2],ax
          dec   esi
          jns   @xlp2_r16
@end_r16:
        pop   ds
        ret
rotate_1516 endp

rotate_1516_trans proc
arg source:pword,dest:pword,tables:pword,sizex:dword,ysin:dword,ycos:dword,transcol:dword
        mov   esi,sizex
        dec   esi
        jz    @end_r16tr
        les   edi,source
        lfs   edi,dest
        mov   ebx,ysin ;ysin
        mov   edx,ycos ;ycos
        push  ds
        lds   eax,tables
        jmp   @xlp2_r16tr
@xloop_r16tr:
          dec   esi
          js    @end_r16tr
@xlp2_r16tr:
          add   edi,2
          mov   eax,ds:[esi*8]       ;xsin
          mov   ecx,ds:[esi*8+4]     ;xcos
          add   eax,edx              ;ycos
          sub   ecx,ebx              ;ysin
          sar   eax,1
          js    @xloop_r16tr
          sar   ecx,1
          js    @xloop_r16tr
          cmp   eax,ds:[131068]  ;destsy
          jnl   @xloop_r16tr
          cmp   ecx,ds:[131064]  ;destsx
          jnl   @xloop_r16tr

          mov   eax,ds:[eax*4+87386]
          mov   ax,es:[eax+ecx*2]
          mov   fs:[edi-2],ax
          dec   esi
          jns   @xlp2_r16tr
@end_r16tr:
        pop   ds
        ret
rotate_1516_trans endp

rotate_24 proc
arg source:pword,dest:pword,tables:pword,sizex:dword,ysin:dword,ycos:dword,transcol:dword
        mov   esi,sizex
        dec   esi
        jz    @end_r24
        les   edi,source
        lfs   edi,dest
        mov   ebx,ysin ;ysin
        mov   edx,ycos ;ycos
        push  ds
        lds   eax,tables
        jmp   @xlp2_r24
@xloop_r24:
          mov   eax,transcol
          mov   fs:[edi-3],ax
          shr   eax,16
          mov   fs:[edi-1],al
          dec   esi
          js    @end_r24
@xlp2_r24:
          add   edi,3
          mov   eax,ds:[esi*8]       ;xsin
          mov   ecx,ds:[esi*8+4]     ;xcos
          add   eax,edx              ;ycos
          sub   ecx,ebx              ;ysin
          sar   eax,1
          js    @xloop_r24
          sar   ecx,1
          js    @xloop_r24
          cmp   eax,ds:[131068]  ;destsy
          jnl   @xloop_r24
          cmp   ecx,ds:[131064]  ;destsx
          jnl   @xloop_r24

          mov   eax,ds:[eax*4+87386]
          add   eax,ecx
          mov   eax,es:[eax+ecx*2]
          mov   fs:[edi-3],ax
          shr   eax,16
          mov   fs:[edi-1],al
          dec   esi
          jns   @xlp2_r24
@end_r24:
        pop   ds
        ret
rotate_24 endp

rotate_24_trans proc
arg source:pword,dest:pword,tables:pword,sizex:dword,ysin:dword,ycos:dword,transcol:dword
        mov   esi,sizex
        dec   esi
        jz    @end_r24tr
        les   edi,source
        lfs   edi,dest
        mov   ebx,ysin ;ysin
        mov   edx,ycos ;ycos
        push  ds
        lds   eax,tables
        jmp   @xlp2_r24tr
@xloop_r24tr:
          dec   esi
          js    @end_r24
@xlp2_r24tr:
          add   edi,3
          mov   eax,ds:[esi*8]       ;xsin
          mov   ecx,ds:[esi*8+4]     ;xcos
          add   eax,edx              ;ycos
          sub   ecx,ebx              ;ysin
          sar   eax,1
          js    @xloop_r24tr
          sar   ecx,1
          js    @xloop_r24tr
          cmp   eax,ds:[131068]  ;destsy
          jnl   @xloop_r24tr
          cmp   ecx,ds:[131064]  ;destsx
          jnl   @xloop_r24tr

          mov   eax,ds:[eax*4+87386]
          add   eax,ecx
          mov   eax,es:[eax+ecx*2]
          mov   fs:[edi-3],ax
          shr   eax,16
          mov   fs:[edi-1],al
          dec   esi
          jns   @xlp2_r24tr
@end_r24tr:
        pop   ds
        ret
rotate_24_trans endp

rotate_32 proc
arg source:pword,dest:pword,tables:pword,sizex:dword,ysin:dword,ycos:dword,transcol:dword
        mov   esi,sizex
        dec   esi
        jz    @end_r32
        les   edi,source
        lfs   edi,dest
        mov   ebx,ysin ;ysin
        mov   edx,ycos ;ycos
        push  ds
        lds   eax,tables
        jmp   @xlp2_r32
@xloop_r32:
          mov   eax,transcol
          mov   fs:[edi-4],eax
          dec   esi
          js    @end_r32
@xlp2_r32:
          add   edi,4
          mov   eax,ds:[esi*8]       ;xsin
          mov   ecx,ds:[esi*8+4]     ;xcos
          add   eax,edx              ;ycos
          sub   ecx,ebx              ;ysin
          sar   eax,1
          js    @xloop_r32
          sar   ecx,1
          js    @xloop_r32
          cmp   eax,ds:[131068]  ;destsy
          jnl   @xloop_r32
          cmp   ecx,ds:[131064]  ;destsx
          jnl   @xloop_r32

          mov   eax,ds:[eax*4+87386]
          mov   eax,es:[eax+ecx*4]
          mov   fs:[edi-4],eax
          dec   esi
          jns   @xlp2_r32
@end_r32:
        pop   ds
        ret
rotate_32 endp

rotate_32_trans proc
arg source:pword,dest:pword,tables:pword,sizex:dword,ysin:dword,ycos:dword,transcol:dword
        mov   esi,sizex
        dec   esi
        jz    @end_r32tr
        les   edi,source
        lfs   edi,dest
        mov   ebx,ysin ;ysin
        mov   edx,ycos ;ycos
        push  ds
        lds   eax,tables
        jmp   @xlp2_r32tr
@xloop_r32tr:
          dec   esi
          js    @end_r32tr
@xlp2_r32tr:
          add   edi,4
          mov   eax,ds:[esi*8]       ;xsin
          mov   ecx,ds:[esi*8+4]     ;xcos
          add   eax,edx              ;ycos
          sub   ecx,ebx              ;ysin
          sar   eax,1
          js    @xloop_r32tr
          sar   ecx,1
          js    @xloop_r32tr
          cmp   eax,ds:[131068]  ;destsy
          jnl   @xloop_r32tr
          cmp   ecx,ds:[131064]  ;destsx
          jnl   @xloop_r32tr

          mov   eax,ds:[eax*4+87386]
          mov   eax,es:[eax+ecx*4]
          mov   fs:[edi-4],eax
          dec   esi
          jns   @xlp2_r32tr
@end_r32tr:
        pop   ds
        ret
rotate_32_trans endp

;!! untested
block_8 proc
arg source:pword,dest:pword,count:dword,blocking:word
        mov   edx,count
        or    edx,edx
        jz    @end_b8
        xor   ebx,ebx
        mov   bx,blocking
        les   edi,dest
        push  ds
        lds   esi,source
        @lp_b8:
          mov   ax,ds:[esi]
          mov   ecx,ebx
          sub   edx,ebx
          jnc   @no_b8
            add   ecx,edx
            db 67h
            rep   stosb
            jmp   @stop_b8
          @no_b8:
          add   esi,ebx
          db 67h
          rep   stosb
          or    edx,edx
          jnz   @lp_b8
@stop_b8:
        pop   ds
@end_b8:
        ret
block_8 endp

block_1516 proc
arg source:pword,dest:pword,count:dword,blocking:word
        mov   edx,count
        or    edx,edx
        jz    @end_b16
        xor   ebx,ebx
        mov   bx,blocking
        les   edi,dest
        push  ds
        lds   esi,source
        push  ebp
        mov   ebp,ebx
        add   ebp,ebp
        @lp_b16:
          mov   ax,ds:[esi]
          mov   ecx,ebx
          sub   edx,ebx
          jnc   @no_b16
            add   ecx,edx
            db 67h
            rep   stosw
            jmp   @stop_b16
          @no_b16:
          add   esi,ebp
          db 67h
          rep   stosw
          or    edx,edx
          jnz   @lp_b16
@stop_b16:
        pop   ebp
        pop   ds
@end_b16:
        ret
block_1516 endp

;Warning: expects at least one byte after the last pixel
block_24 proc
arg source:pword,dest:pword,count:dword,blocking:word
        mov   edx,count
        or    edx,edx
        jz    @end_b24
        xor   ebx,ebx
        mov   bx,blocking
        les   edi,dest
        push  ds
        lds   esi,source
        push  ebp
        mov   ebp,ebx
        shl   ebp,1
        add   ebp,ebx
        @lp_b24:
          mov   eax,ds:[esi]
          mov   ecx,ebx
          sub   edx,ebx
          jnc   @no_b24
            add   ecx,edx
;            db 67h
;            rep   stosd
            @mv1_b24:
            mov   es:[edi],eax
            add   edi,3
            dec   ecx
            jnz   @mv1_b24
            jmp   @stop_b24
          @no_b24:
          add   esi,ebp
;          db 67h
;          rep   stosd
          @mv2_b24:
          mov   es:[edi],eax
          add   edi,3
          dec   ecx
          jnz   @mv2_b24
          or    edx,edx
          jnz   @lp_b24
@stop_b24:
        pop   ebp
        pop   ds
@end_b24:
        ret
block_24 endp

block_32 proc
arg source:pword,dest:pword,count:dword,blocking:word
        mov   edx,count
        or    edx,edx
        jz    @end_b32
        xor   ebx,ebx
        mov   bx,blocking
        les   edi,dest
        push  ds
        lds   esi,source
        push  ebp
        mov   ebp,ebx
        shl   ebp,2
        @lp_b32:
          mov   eax,ds:[esi]
          mov   ecx,ebx
          sub   edx,ebx
          jnc   @no_b32
            add   ecx,edx
            db 67h
            rep   stosd
            jmp   @stop_b32
          @no_b32:
          add   esi,ebp
          db 67h
          rep   stosd
          or    edx,edx
          jnz   @lp_b32
@stop_b32:
        pop   ebp
        pop   ds
@end_b32:
        ret
block_32 endp

fadeout_15 proc
arg data:pword,count:dword,strength:dword
        mov   esi,count
        shr   esi,1
        jz    @end_fo15
        les   edi,data
        mov   cl,byte ptr strength
        mov   ch,byte ptr strength[2]
        shr   cl,3
        shr   ch,1
        and   cx,111110000011111b
        mov   dl,byte ptr strength[1]
        and   dx,11111000b
        shl   dx,2
        @lp_fo15:
          mov   ax,es:[edi]
          mov   bx,ax

          and   ax,111110000011111b
          sub   al,cl                ;B
          jnc   @nextb_fo15
            xor   al,al
          @nextb_fo15:

          sub   ah,ch                ;R
          jnc   @nextr_fo15
            xor   ah,ah
          @nextr_fo15:

          and   bx,1111100000b
          sub   bx,dx                ;G
          jc   @nextg_fo15
            or   ax,bx
          @nextg_fo15:

          mov   es:[edi],ax
          add   edi,2
        dec   esi
        jnz   @lp_fo15
@end_fo15:
        ret
fadeout_15 endp

fadeout_16 proc
arg data:pword,count:dword,strength:dword
        mov   esi,count
        shr   esi,1
        jz    @end_fo16
        les   edi,data
        mov   cl,byte ptr strength
        mov   ch,byte ptr strength[2]
        shr   cl,3
        and   cx,1111100000011111b
        mov   dl,byte ptr strength[1]
        and   dx,11111100b
        shl   dx,3
        @lp_fo16:
          mov   ax,es:[edi]
          mov   bx,ax

          and   ax,1111100000011111b
          and   bx,11111100000b
          sub   al,cl                ;B
          jnc   @nextb_fo16
            xor   al,al
          @nextb_fo16:

          sub   ah,ch                ;R
          jnc   @nextr_fo16
            xor   ah,ah
          @nextr_fo16:

          sub   bx,dx                ;G
          jc   @nextg_fo16
            or   ax,bx
          @nextg_fo16:

          mov   es:[edi],ax
          add   edi,2
        dec   esi
        jnz   @lp_fo16
@end_fo16:
        ret
fadeout_16 endp

fadeout_24_386 proc
arg data:pword,count:dword,strength:dword
        mov   ecx,3
        mov   eax,count
        cdq
        div   ecx
        mov   ecx,eax
        or    eax,eax
        jz    @end_fo24
        les   edi,data
        mov   bx,word ptr strength
        mov   dl,byte ptr strength[2]
        @lp_fo24:
          mov   eax,es:[edi]

          sub   al,bl         ;B
          jnc   @nextb_fo24
            xor  al,al
          @nextb_fo24:

          sub   ah,bh         ;G
          jnc   @nextg_fo24
            xor   ah,ah
          @nextg_fo24:
          mov   es:[edi],ax

          shr   eax,16
          sub   al,dl         ;R
          jnc   @nextr_fo24
            xor   al,al
          @nextr_fo24:

          mov   es:[edi+2],al
          add   edi,3
        dec   ecx
        jnz   @lp_fo24
@end_fo24:
        ret
fadeout_24_386 endp

fadeout_32_386 proc
arg data:pword,count:dword,strength:dword
        mov   ecx,count
        shr   ecx,2
        jz    @end_fo32
        les   edi,data
        mov   bx,word ptr strength
        mov   dl,byte ptr strength[2]
        @lp_fo32:
          mov   eax,es:[edi]

          sub   al,bl         ;B
          jnc   @nextb_fo32
            xor  al,al
          @nextb_fo32:

          sub   ah,bh         ;G
          jnc   @nextg_fo32
            xor   ah,ah
          @nextg_fo32:
          mov   es:[edi],ax

          shr   eax,16
          sub   al,dl         ;R
          jnc   @nextr_fo32
            xor   al,al
          @nextr_fo32:

          mov   es:[edi+2],al
          add   edi,4
        dec   ecx
        jnz   @lp_fo32
@end_fo32:
        ret
fadeout_32_386 endp

fadeout_32_mmx proc
arg data:pword,count:dword,strength:dword
        les   edi,pword ptr data
        mov   ecx,count
        mov   ebx,ecx
        shr   ecx,3
        jz    @end_fo32mx
        movd  mm1,strength
        movq  mm0,mm1
        psllq mm1,32
        por   mm1,mm0
          @lp_fo32mx:
          movq mm0,es:[edi],2
          psubusb mm0,mm1
          movq es:[edi],mm0,2
          add   edi,8
          dec   ecx
          jnz   @lp_fo32mx
        test  ebx,4
        jz    @even_fo32mx
          movd mm0,es:[edi],2
          psubusb mm0,mm1
          movd es:[edi],mm0,2
@even_fo32mx:
        emms                          ;reset to FPU mode
@end_fo32mx:
        ret
fadeout_32_mmx endp

fadewhite_15 proc
arg data:pword,count:dword,strength:dword
        mov   esi,count
        shr   esi,1
        jz    @end_fw15
        les   edi,data
        mov   cl,byte ptr strength
        mov   ch,byte ptr strength[2]
        shr   cl,3
        shr   ch,1
        and   cx,111110000011111b
        mov   dl,byte ptr strength[1]
        and   dx,11111000b
        shl   dx,2
        @lp_fw15:
          mov   ax,es:[edi]
          mov   bx,ax

          and   ax,111110000011111b
          and   bx,1111100000b
          add   al,cl                ;B
          cmp   al,31
          jna   @nextb_fw15
            mov   al,31
          @nextb_fw15:

          add   bx,dx                ;G
          cmp   bx,992
          jna   @nextg_fw15
            mov   bx,992
          @nextg_fw15:

          add   ah,ch                ;R
          cmp   ah,124
          jna   @nextr_fw15
            mov   ah,124
          @nextr_fw15:

          or    ax,bx

          mov   es:[edi],ax
          add   edi,2
        dec   esi
        jnz   @lp_fw15
@end_fw15:
        ret
fadewhite_15 endp

fadewhite_16 proc
arg data:pword,count:dword,strength:dword
        mov   esi,count
        shr   esi,1
        jz    @end_fw16
        les   edi,data
        mov   cl,byte ptr strength
        mov   ch,byte ptr strength[2]
        shr   cl,3
        and   cx,1111100000011111b
        mov   dl,byte ptr strength[1]
        and   dx,11111100b
        shl   dx,3
        @lp_fw16:
          mov   ax,es:[edi]
          mov   bx,ax

          and   ax,1111100000011111b
          add   al,cl                ;B
          cmp   al,31
          jna   @nextb_fw16
            mov   al,31
          @nextb_fw16:

          and   bx,11111100000b
          add   bx,dx                ;G
          cmp   bx,2015
          jna   @nextg_fw16
            mov   bx,2015
          @nextg_fw16:

          add   ah,ch                ;R
          jnc   @nextr_fw16
            mov   ah,248
          @nextr_fw16:

          or    ax,bx

          mov   es:[edi],ax
          add   edi,2
        dec   esi
        jnz   @lp_fw16
@end_fw16:
        ret
fadewhite_16 endp

fadewhite_24_386 proc
arg data:pword,count:dword,strength:dword
        mov   ecx,3
        mov   eax,count
        cdq
        div   ecx
        mov   ecx,eax
        or    eax,eax
        jz    @end_fw24
        les   edi,data
        mov   bx,word ptr strength
        mov   dl,byte ptr strength[2]
        @lp_fw24:
          mov   eax,es:[edi]

          add   al,bl         ;B
          jnc   @nextb_fw24
            mov  al,0FFh
          @nextb_fw24:

          add   ah,bh         ;G
          jnc   @nextg_fw24
            mov   ah,0FFh
          @nextg_fw24:
          mov   es:[edi],ax

          shr   eax,16
          add   al,dl         ;R
          jnc   @nextr_fw24
            mov   al,0FFh
          @nextr_fw24:

          mov   es:[edi+2],al
          add   edi,3
        dec   ecx
        jnz   @lp_fw24
@end_fw24:
        ret
fadewhite_24_386 endp

fadewhite_32_386 proc
arg data:pword,count:dword,strength:dword
        mov   ecx,count
        shr   ecx,2
        jz    @end_fw32
        les   edi,data
        mov   bx,word ptr strength
        mov   dl,byte ptr strength[2]
        @lp_fw32:
          mov   eax,es:[edi]

          add   al,bl         ;B
          jnc   @nextb_fw32
            mov  al,0FFh
          @nextb_fw32:

          add   ah,bh         ;G
          jnc   @nextg_fw32
            mov   ah,0FFh
          @nextg_fw32:
          mov   es:[edi],ax

          shr   eax,16
          add   al,dl         ;R
          jnc   @nextr_fw32
            mov   al,0FFh
          @nextr_fw32:

          mov   es:[edi+2],al
          add   edi,4
        dec   ecx
        jnz   @lp_fw32
@end_fw32:
        ret
fadewhite_32_386 endp

fadewhite_32_mmx proc
arg data:pword,count:dword,strength:dword
        les   edi,pword ptr data
        mov   ecx,count
        mov   ebx,ecx
        shr   ecx,3
        jz    @end_fw32mx
        movd  mm1,strength
        movq  mm0,mm1
        psllq mm1,32
        por   mm1,mm0
          @lp_fw32mx:
          movq mm0,es:[edi],2
          paddusb mm0,mm1
          movq es:[edi],mm0,2
          add   edi,8
          dec   ecx
          jnz   @lp_fw32mx
        test  ebx,4
        jz    @even_fw32mx
          movd mm0,es:[edi],2
          paddusb mm0,mm1
          movd es:[edi],mm0,2
@even_fw32mx:
        emms                          ;reset to FPU mode
@end_fw32mx:
        ret
fadewhite_32_mmx endp

brightness_15_386 proc
arg source:pword,dest:pword,count:dword,bright:byte
        shr   count,1
        jz    @end_bn15
        les   edi,dest
        xor   ecx,ecx
        mov   cl,bright
        push  ds
        lds   esi,source
        push  ebp
        mov   ebp,count
        @lp_bn15:
          xor   eax,eax
          mov   bx,ds:[esi]
          mov   al,bh
          mov   dx,bx
          shl   edx,16
          or    eax,edx
          and   eax,1F007Ch
          mul   ecx
          and   eax,1F007C00h
          mov   edx,eax
          shr   edx,24
          mov   dh,ah

          mov   ax,bx
          shr   ax,5
          and   ax,11111b
          mul   cl
          shr   ax,3
          and   ax,1111100000b
          or    dx,ax

          mov   es:[edi],dx
          add   esi,2
          add   edi,2
          dec   ebp
          jnz   @lp_bn15
        pop   ebp
        pop   ds
@end_bn15:
        ret
brightness_15_386 endp

brightness_16_386 proc
arg source:pword,dest:pword,count:dword,bright:byte
        shr   count,1
        jz    @end_bn16
        les   edi,dest
        xor   ecx,ecx
        mov   cl,bright
        push  ds
        lds   esi,source
        push  ebp
        mov   ebp,count
        @lp_bn16:
          xor   eax,eax
          mov   bx,ds:[esi]
          mov   al,bh
          mov   dx,bx
          shl   edx,16
          or    eax,edx
          and   eax,1F00F8h
          mul   ecx
          and   eax,1F00F800h
          mov   edx,eax
          shr   edx,24
          mov   dh,ah

          mov   ax,bx
          shr   ax,5
          and   ax,111111b
          mul   cl
          shr   ax,3
          and   ax,11111100000b
          or    dx,ax

          mov   es:[edi],dx
          add   esi,2
          add   edi,2
          dec   ebp
          jnz   @lp_bn16
        pop   ebp
        pop   ds
@end_bn16:
        ret
brightness_16_386 endp

brightness_24_386 proc
arg source:pword,dest:pword,count:dword,bright:byte
        mov   ecx,3
        mov   eax,count
        cdq
        div   ecx
        or    eax,eax
        jz    @end_bn24
        mov   edx,eax
        les   edi,dest
        xor   ecx,ecx
        mov   cl,bright
        push  ds
        lds   esi,source
        @lp_bn24:
          mov   ebx,ds:[esi]

          mov   al,bh
          and   ebx,0FF00FFh

          imul  ebx,ecx
          shr   ebx,8
          mul   cl
          mov   bh,ah

          mov   es:[edi],bx
          shr   ebx,16
          mov   es:[edi+2],bl

          add   esi,3
          add   edi,3
          dec   edx
          jnz   @lp_bn24
        pop   ds
@end_bn24:
        ret
brightness_24_386 endp

brightness_32_386 proc
arg source:pword,dest:pword,count:dword,bright:byte
        mov   edx,count
        shr   edx,2
        jz    @end_bn32
        les   edi,dest
        xor   ecx,ecx
        mov   cl,bright
        push  ds
        lds   esi,source
        @lp_bn32:
          mov   ebx,ds:[esi]

          mov   al,bh
          and   ebx,0FF00FFh

          imul  ebx,ecx
          shr   ebx,8
          mul   cl
          mov   bh,ah

          mov   es:[edi],ebx
          add   esi,4
          add   edi,4
          dec   edx
          jnz   @lp_bn32
        pop   ds
@end_bn32:
        ret
brightness_32_386 endp

brightness_24_mmx proc
arg source:pword,dest:pword,count:dword,bright:byte
        mov   ecx,count
        mov   edx,ecx
        shr   ecx,3
        jz    @once_bn24mx
        movzx eax,bright
        mov   ebx,eax
        shl   eax,16
        or    eax,ebx
        movd  mm1,eax
        pxor  mm2,mm2
        punpcklwd mm1,mm1
        punpckldq mm1,mm1
        les   edi,dest
        lgs   esi,source
        @lp_bn24mx:
          movq       mm0,gs:[esi],2
          movq       mm3,mm0
          punpcklbw  mm0,mm2
          psrlq      mm3,32
          pmullw     mm0,mm1
          punpcklbw  mm3,mm2
          pmullw     mm3,mm1
          psrlw      mm0,8
          psrlw      mm3,8
          packuswb   mm0,mm3

          movq       es:[edi],mm0,2
          add        edi,8
          add        esi,8

          dec   ecx
          jnz   @lp_bn24mx
@once_bn24mx:
          test       edx,4
          jz         @end_bn24mx
          movd       mm0,gs:[esi],2
          punpcklbw  mm0,mm2
          pmullw     mm0,mm1
          psrlw      mm0,8
          packuswb   mm0,mm2
          movd       es:[edi],mm0,2

@end_bn24mx:
        emms
        ret
brightness_24_mmx endp

brightness_32_mmx proc
arg source:pword,dest:pword,count:dword,bright:byte
        mov   ecx,count
        mov   edx,ecx
        shr   ecx,3
        jz    @end_bn32mx
        movzx eax,bright
        mov   ebx,eax
        shl   eax,16
        or    eax,ebx
        movd  mm1,eax
        and   eax,000000FFh
        or    eax,01000000h
        movd  mm0,eax
        psllq mm0,32
        por   mm1,mm0
        pxor  mm2,mm2
        les   edi,dest
        lgs   esi,source
        @lp_bn32mx:
          movq       mm0,gs:[esi],2
          movq       mm3,mm0
          punpcklbw  mm0,mm2
          psrlq      mm3,32
          pmullw     mm0,mm1
          punpcklbw  mm3,mm2
          pmullw     mm3,mm1
          psrlw      mm0,8
          psrlw      mm3,8
          packuswb   mm0,mm3

          movq       es:[edi],mm0,2

          add   edi,8
          add   esi,8
          dec   ecx
          jnz   @lp_bn32mx
@once_bn32mx:
          test       edx,4
          jz         @end_bn32mx
          movd       mm0,gs:[esi],2
          punpcklbw  mm0,mm2
          pmullw     mm0,mm1
          psrlw      mm0,8
          packuswb   mm0,mm2
          movd       es:[edi],mm0,2

@end_bn32mx:
        emms
        ret
brightness_32_mmx endp

brightness_chn proc
arg data:pword,count:dword,bright:byte
        mov   ecx,count
        or    ecx,ecx
        jz    @end_bnc
        mov   bl,bright
        les   edi,data
        @lp_bnc:
          mov   al,es:[edi+3]
          mul   bl
          mov   es:[edi+3],ah
          add   edi,4
          dec   ecx
          jnz   @lp_bnc
@end_bnc:
        ret
brightness_chn endp

contrastdown_15_386 proc
arg source:pword,dest:pword,count:dword,bright:byte
        mov   edx,count
        shr   edx,1
        jz    @end_cd15
        les   edi,dest
        xor   ecx,ecx
        mov   cl,bright
        mov   ch,cl
        mov   ch,0FFh
        sub   ch,cl
        shr   ch,1
        push  ds
        lds   esi,source
        @lp_cd15:
          mov   bx,ds:[esi]

          mov   al,bl
          shl   al,3
          mul   cl
          add   ah,ch
          and   bl,0E0h
          shr   ah,3
          or    bl,ah

          mov   ax,bx
          shr   ax,2
          and   ax,0F8h
          mul   cl
          add   ah,ch
          and   ax,0F800h
          shr   ax,6
          and   bx,07C1Fh
          or    bx,ax

          mov   al,bh
          shl   al,1
          and   al,0F8h
          mul   cl
          add   ah,ch
          and   ah,0F8h
          shr   ah,1
          and   bh,3h
          or    bh,ah
          mov   es:[edi],bx
          add   esi,2
          add   edi,2
          dec   edx
          jnz   @lp_cd15
        pop   ds
@end_cd15:
        ret
contrastdown_15_386 endp

contrastdown_16_386 proc
arg source:pword,dest:pword,count:dword,bright:byte
        mov   edx,count
        shr   edx,1
        jz    @end_cd16
        les   edi,dest
        xor   ecx,ecx
        mov   cl,bright
        mov   ch,cl
        mov   ch,0FFh
        sub   ch,cl
        shr   ch,1
        push  ds
        lds   esi,source
        @lp_cd16:
          mov   bx,ds:[esi]

          mov   al,bl
          shl   al,3
          mul   cl
          add   ah,ch
          and   bl,0E0h
          shr   ah,3
          or    bl,ah

          mov   ax,bx
          shr   ax,3
          and   ax,0FCh
          mul   cl
          add   ah,ch
          and   ax,0FC00h
          shr   ax,5
          and   bx,0F81Fh
          or    bx,ax

          mov   al,bh
          and   al,0F8h
          mul   cl
          add   ah,ch
          and   ah,0F8h
          and   bh,7h
          or    bh,ah
          mov   es:[edi],bx
          add   esi,2
          add   edi,2
          dec   edx
          jnz   @lp_cd16
        pop   ds
@end_cd16:
        ret
contrastdown_16_386 endp

contrastdown_24_386 proc
arg source:pword,dest:pword,count:dword,bright:byte
        mov   ecx,3
        mov   eax,count
        cdq
        div   ecx
        mov   edx,eax
        or    eax,eax
        jz    @end_cd24
        les   edi,dest
        xor   ecx,ecx
        mov   cl,bright
        mov   ch,cl
        mov   ch,0FFh
        sub   ch,cl
        shr   ch,1
        push  ds
        lds   esi,source
        @lp_cd24:
          mov   ebx,ds:[esi]

          mov   al,bl
          mul   cl
          add   ah,ch
          mov   bl,ah

          mov   al,bh
          mul   cl
          add   ah,ch
          mov   bh,ah

          mov   es:[edi],bx

          shr   ebx,16

          mov   al,bl
          mul   cl
          add   ah,ch
          mov   bl,ah
          mov   es:[edi+2],bl
          add   esi,3
          add   edi,3
          dec   edx
          jnz   @lp_cd24
        pop   ds
@end_cd24:
        ret
contrastdown_24_386 endp

contrastdown_32_386 proc
arg source:pword,dest:pword,count:dword,bright:byte
        mov   edx,count
        shr   edx,2
        jz    @end_cd32
        les   edi,dest
        xor   ecx,ecx
        mov   cl,bright
        mov   ch,cl
        mov   ch,0FFh
        sub   ch,cl
        shr   ch,1
        push  ds
        lds   esi,source
        @lp_cd32:
          mov   ebx,ds:[esi]

          mov   al,bl
          mul   cl
          add   ah,ch
          mov   bl,ah

          mov   al,bh
          mul   cl
          add   ah,ch
          mov   bh,ah

          mov   es:[edi],bx

          shr   ebx,16

          mov   al,bl
          mul   cl
          add   ah,ch
          mov   bl,ah
          mov   es:[edi+2],bx
          add   esi,4
          add   edi,4
          dec   edx
          jnz   @lp_cd32
        pop   ds
@end_cd32:
        ret
contrastdown_32_386 endp

contrastup_15_386 proc
arg source:pword,dest:pword,count:dword,bright:byte
        mov   edx,count
        shr   edx,1
        jz    @end_cu15
        mov   count,edx
        les   edi,dest
        xor   ecx,ecx
        xor   edx,edx
        sub   cl,bright
        lgs   esi,source
        @lp_cu15:
          mov   bx,gs:[esi]

          xor   ax,ax
          mov   al,bl
          and   ax,1Fh
          shl   ax,11
          sub   ax,8000h
          cwd
          idiv  cx
          add   ax,80h
          jns   @nsblue_cu15
          mov   ax,0
          jmp   @nablue_cu15
          @nsblue_cu15:
          cmp   ax,255
          jng   @nablue_cu15
          mov   ax,255
          @nablue_cu15:
          shr   al,3
          and   bl,0E0h
          or    bl,al

          mov   ax,bx
          and   ax,3E0h
          shl   ax,6
          sub   ax,8000h
          cwd
          idiv  cx
          add   ax,80h
          jns   @nsgreen_cu15
          mov   ax,0
          jmp   @nagreen_cu15
          @nsgreen_cu15:
          cmp   ax,255
          jng   @nagreen_cu15
          mov   ax,255
          @nagreen_cu15:

          shl   ax,2
          and   ax,3E0h
          and   bx,07C1Fh
          or    bx,ax

          mov   ax,bx
          and   ax,07C00h
          shl   ax,1
          sub   ax,8000h
          cwd
          idiv  cx
          add   ax,80h
          jns   @nsred_cu15
          mov   ax,0
          jmp   @nared_cu15
          @nsred_cu15:
          cmp   ax,255
          jng   @nared_cu15
          mov   ax,255
          @nared_cu15:
          shr   al,1
          and   al,07Ch
          and   bh,3h
          or    bh,al

          mov   es:[edi],bx
          add   esi,2
          add   edi,2
          dec   count
          jnz   @lp_cu15
@end_cu15:
        ret
contrastup_15_386 endp

contrastup_16_386 proc
arg source:pword,dest:pword,count:dword,bright:byte
        mov   edx,count
        shr   edx,1
        jz    @end_cu16
        mov   count,edx
        les   edi,dest
        xor   ecx,ecx
        xor   edx,edx
        sub   cl,bright
        lgs   esi,source
        @lp_cu16:
          mov   bx,gs:[esi]

          xor   ax,ax
          mov   al,bl
          and   ax,1Fh
          shl   ax,11
          sub   ax,8000h
          cwd
          idiv  cx
          add   ax,80h
          jns   @nsblue_cu16
          mov   ax,0
          jmp   @nablue_cu16
          @nsblue_cu16:
          cmp   ax,255
          jng   @nablue_cu16
          mov   ax,255
          @nablue_cu16:
          shr   al,3
          and   bl,0E0h
          or    bl,al

          mov   ax,bx
          and   ax,7E0h
          shl   ax,5
          sub   ax,8000h
          cwd
          idiv  cx
          add   ax,80h
          jns   @nsgreen_cu16
          mov   ax,0
          jmp   @nagreen_cu16
          @nsgreen_cu16:
          cmp   ax,255
          jng   @nagreen_cu16
          mov   ax,255
          @nagreen_cu16:

          shl   ax,3
          and   ax,7E0h
          and   bx,0F81Fh
          or    bx,ax

          mov   ax,bx
          and   ax,0F800h
          sub   ax,8000h
          cwd
          idiv  cx
          add   ax,80h
          jns   @nsred_cu16
          mov   ax,0
          jmp   @nared_cu16
          @nsred_cu16:
          cmp   ax,255
          jng   @nared_cu16
          mov   ax,255
          @nared_cu16:
          and   al,0F8h
          and   bh,7h
          or    bh,al

          mov   es:[edi],bx
          add   esi,2
          add   edi,2
          dec   count
          jnz   @lp_cu16
@end_cu16:
        ret
contrastup_16_386 endp

contrastup_24_386 proc
arg source:pword,dest:pword,count:dword,bright:byte
        mov   ecx,3
        mov   eax,count
        cdq
        div   ecx
        mov   edx,eax
        or    eax,eax
        jz    @end_cu24

        mov   count,edx
        les   edi,dest
        xor   ecx,ecx
        xor   edx,edx
        sub   cl,bright
        lgs   esi,source
        @lp_cu24:
          mov   ebx,gs:[esi]

          xor   ax,ax
          mov   al,bl
          shl   ax,8
          sub   ax,8000h
          cwd
          idiv  cx
          add   ax,80h
          jns   @nsblue_cu24
          mov   ax,0
          jmp   @nablue_cu24
          @nsblue_cu24:
          cmp   ax,255
          jng   @nablue_cu24
          mov   ax,255
          @nablue_cu24:
          mov   bl,al

          mov   al,bh
          shl   ax,8
          sub   ax,8000h
          cwd
          idiv  cx
          add   ax,80h
          jns   @nsgreen_cu24
          mov   ax,0
          jmp   @nagreen_cu24
          @nsgreen_cu24:
          cmp   ax,255
          jng   @nagreen_cu24
          mov   ax,255
          @nagreen_cu24:
          mov   bh,al

          mov   es:[edi],bx

          shr   ebx,16

          mov   al,bl
          shl   ax,8
          sub   ax,8000h
          cwd
          idiv  cx
          add   ax,80h
          jns   @nsred_cu24
          mov   ax,0
          jmp   @nared_cu24
          @nsred_cu24:
          cmp   ax,255
          jng   @nared_cu24
          mov   ax,255
          @nared_cu24:
          mov   bl,al

          mov   es:[edi+2],bl
          add   esi,3
          add   edi,3
          dec   count
          jnz   @lp_cu24
@end_cu24:
        ret
contrastup_24_386 endp

contrastup_32_386 proc
arg source:pword,dest:pword,count:dword,bright:byte
        mov   edx,count
        shr   edx,2
        jz    @end_cu32
        mov   count,edx
        les   edi,dest
        xor   ecx,ecx
        xor   edx,edx
        sub   cl,bright
        lgs   esi,source
        @lp_cu32:
          mov   ebx,gs:[esi]

          xor   ax,ax
          mov   al,bl
          shl   ax,8
          sub   ax,8000h
          cwd
          idiv  cx
          add   ax,80h
          jns   @nsblue_cu32
          mov   ax,0
          jmp   @nablue_cu32
          @nsblue_cu32:
          cmp   ax,255
          jng   @nablue_cu32
          mov   ax,255
          @nablue_cu32:
          mov   bl,al

          mov   al,bh
          shl   ax,8
          sub   ax,8000h
          cwd
          idiv  cx
          add   ax,80h
          jns   @nsgreen_cu32
          mov   ax,0
          jmp   @nagreen_cu32
          @nsgreen_cu32:
          cmp   ax,255
          jng   @nagreen_cu32
          mov   ax,255
          @nagreen_cu32:
          mov   bh,al

          mov   es:[edi],bx

          shr   ebx,16

          mov   al,bl
          shl   ax,8
          sub   ax,8000h
          cwd
          idiv  cx
          add   ax,80h
          jns   @nsred_cu32
          mov   ax,0
          jmp   @nared_cu32
          @nsred_cu32:
          cmp   ax,255
          jng   @nared_cu32
          mov   ax,255
          @nared_cu32:
          mov   bl,al

          mov   es:[edi+2],bx
          add   esi,4
          add   edi,4
          dec   count
          jnz   @lp_cu32
@end_cu32:
        ret
contrastup_32_386 endp

contrast_32_mmx proc
arg source:pword,dest:pword,count:dword,bright:byte
        mov   ecx,count
;        mov   edx,ecx
        shr   ecx,2
        jz    @end_cn32mx
        movzx eax,bright
        shl   eax,16
        mov   al,bright
        movd  mm1,eax
        movd  mm0,eax
        psllq mm0,32
        por   mm1,mm0
;        pxor  mm2,mm2
        les   edi,dest
        lgs   esi,source
        @lp_cn32mx:
          movd       mm0,gs:[esi],2
          punpcklbw  mm2,mm0




          movd       es:[edi],mm0,2

          add   edi,4
          add   esi,4
          dec   ecx
          jnz   @lp_cn32mx

@end_cn32mx:
        emms
        ret
contrast_32_mmx endp

rgb2bw_24 proc
arg source:pword,dest:pword,count:dword
           mov   ecx,3
           mov   eax,count
           div   ecx
           jz    @end_bw24
           les   edi,dest
           push  ds
           lds   esi,source
           push  ebp
           mov   ebp,eax
           xor   eax,eax
@lp_bw24:
             mov   cl,29
             mov   ebx,ds:[esi]
             mov   al,bl
             mul   cl
             mov   cl,150
             mov   edx,eax
             mov   al,bh
             mul   cl
             mov   cl,76
             shr   ebx,16
             add   edx,eax
             mov   al,bl
             mul   cl
             add   edx,eax
             mov   es:[edi],dh
             add   esi,3
             inc   edi
             dec   ebp
           jnz   @lp_bw24
           pop   ebp
           pop   ds
@end_bw24:
           ret
rgb2bw_24 endp

rgb2bw_32 proc
arg source:pword,dest:pword,count:dword
           mov   ecx,count
           shr   ecx,2
           jz    @end_bw32
           les   edi,dest
           push  ds
           lds   esi,source
           push  ebp
           mov   ebp,ecx
           xor   eax,eax
@lp_bw32:
             mov   cl,29
             mov   ebx,ds:[esi]
             mov   al,bl
             mul   cl
             mov   cl,150
             mov   edx,eax
             mov   al,bh
             mul   cl
             mov   cl,76
             shr   ebx,16
             add   edx,eax
             xor   ah,ah
             mov   al,bl
             mul   cl
             add   edx,eax
             mov   es:[edi],dh
             add   esi,4
             inc   edi
             dec   ebp
           jnz   @lp_bw32
           pop   ebp
           pop   ds
@end_bw32:
           ret
rgb2bw_32 endp

blur_24_386 proc
arg data : pword,bpl : dword
           mov   ecx,3
           mov   eax,bpl
           cdq
           div   ecx
           or    eax,eax
           jz    @end_bl24
           mov   esi,eax
           sub   esi,2
           jc    @end_bl24
           jz    @end_bl24
           mov   edx,bpl
           les   edi,data

           push  esi
           mov   ebx,es:[edi]
           mov   esi,es:[edi+3]
           and   ebx,0FF00FFh
           and   esi,0FF00FFh
           add   ebx,ebx
           mov   ecx,es:[edi+edx]
           add   esi,ebx
           and   ecx,0FF00FFh

           add   esi,ecx
           xor   ax,ax
           xor   bx,bx
           mov   al,es:[edi+4]
           mov   bl,es:[edi+1]
           add   bx,bx
           mov   cl,es:[edi+edx+1]
           add   ax,bx
           xor   bx,bx
           shr   esi,2
           add   ax,cx
           and   esi,0FF00FFh
           shl   ax,6
           and   eax,0FF00h

           or    eax,esi
           mov   es:[edi],ax
           shr   eax,16
           mov   es:[edi+2],al
           xor   eax,eax

           pop   esi
           add   edi,3
@lp_bl24:
           mov   eax,es:[edi-3]
           mov   ecx,es:[edi+3]
           and   eax,0FF00FFh
           and   ecx,0FF00FFh
           mov   ebx,es:[edi]
           add   eax,ecx
           and   ebx,0FF00FFh
           mov   ecx,es:[edi+edx]
           add   eax,ebx
           and   ecx,0FF00FFh
           add   eax,ecx
           shr   eax,2
           mov   es:[edi],al
           shr   eax,16
           mov   es:[edi+2],al

           mov   al,es:[edi-2]
           mov   cl,es:[edi+4]
           mov   bl,es:[edi+1]
           add   ax,cx
           mov   cl,es:[edi+edx+1]
           add   ax,bx
           add   ax,cx
           shr   ax,2
           mov   es:[edi+1],al

           add   edi,3
           dec   esi
           jnz   @lp_bl24

           mov   ebx,es:[edi]
           mov   esi,es:[edi-3]
           and   ebx,0FF00FFh
           and   esi,0FF00FFh
           add   ebx,ebx
           mov   ecx,es:[edi+edx]
           add   esi,ebx
           and   ecx,0FF00FFh

           add   esi,ecx
           xor   ax,ax
           xor   bx,bx
           mov   al,es:[edi-2]
           mov   bl,es:[edi+1]
           add   bx,bx
           mov   cl,es:[edi+edx+1]
           add   ax,bx
           xor   bx,bx
           shr   esi,2
           add   ax,cx
           and   esi,0FF00FFh
           shl   ax,6
           and   eax,0FF00h

           or    eax,esi
           mov   es:[edi],ax
           shr   eax,16
           mov   es:[edi+2],al
@end_bl24:
           ret
blur_24_386 endp

blur_32_386 proc
arg data : pword,bpl : dword
           mov   esi,bpl
           shr   esi,2
           jz    @end_bl32
           sub   esi,2
           jc    @end_bl32
           jz    @end_bl32
           mov   edx,bpl
           les   edi,data
           push  ebp
           mov   ebp,esi
           xor   eax,eax

           mov   ebx,es:[edi]
           mov   esi,es:[edi+4]
           and   ebx,0FF00FFh
           and   esi,0FF00FFh
           add   ebx,ebx
           mov   ecx,es:[edi+edx]
           add   esi,ebx
           and   ecx,0FF00FFh

           add   esi,ecx
           mov   al,es:[edi+5]
           mov   bl,es:[edi+1]
           add   bx,bx
           mov   cl,es:[edi+edx+1]
           add   ax,bx
           xor   bx,bx
           shr   esi,2
           add   ax,cx
           and   esi,0FF00FFh
           shl   ax,6
           and   eax,0FF00h
           or    esi,eax
           xor   eax,eax
           mov   es:[edi],esi

           add   edi,4
@lp_bl32:
           mov   esi,es:[edi-4]
           mov   ecx,es:[edi+4]
           and   esi,0FF00FFh
           and   ecx,0FF00FFh
           mov   ebx,es:[edi]
           add   esi,ecx
           and   ebx,0FF00FFh
           mov   ecx,es:[edi+edx]
           add   esi,ebx
           and   ecx,0FF00FFh

           mov   al,es:[edi-3]
           add   esi,ecx
           mov   cl,es:[edi+5]
           mov   bl,es:[edi+1]
           add   ax,cx
           mov   cl,es:[edi+edx+1]
           add   ax,bx
           shr   esi,2
           add   ax,cx
           and   esi,0FF00FFh
           shl   ax,6
           and   eax,0FF00h
           or    esi,eax
           xor   eax,eax
           mov   es:[edi],esi

           add   edi,4
           dec   ebp
           jnz   @lp_bl32
           pop   ebp

           mov   ebx,es:[edi]
           mov   esi,es:[edi-4]
           and   ebx,0FF00FFh
           and   esi,0FF00FFh
           add   ebx,ebx
           mov   ecx,es:[edi+edx]
           add   esi,ebx
           and   ecx,0FF00FFh

           add   esi,ecx
           mov   al,es:[edi-3]
           mov   bl,es:[edi-4]
           add   bx,bx
           mov   cl,es:[edi+edx+1]
           add   ax,bx
           xor   bx,bx
           shr   esi,2
           add   ax,cx
           and   esi,0FF00FFh
           shl   ax,6
           and   eax,0FF00h
           or    esi,eax
           xor   eax,eax
           mov   es:[edi],esi
@end_bl32:
           ret
blur_32_386 endp

blur_32_mmx proc
arg data : pword,bpl : dword
           mov   ecx,bpl
           shr   ecx,2
           jz    @end_bl32mx
           sub   ecx,2
           jc    @end_bl32mx
           jz    @end_bl32mx
           mov   edx,bpl
           les   edi,data
           pxor  mm4,mm4

           movd       mm1,es:[edi+4],2
           movd       mm0,es:[edi],2
           punpcklbw  mm1,mm4
           punpcklbw  mm0,mm4
           psllw      mm0,1
           paddusw    mm0,mm1
           movd       mm3,es:[edi+edx],2
           punpcklbw  mm3,mm4
           paddusw    mm0,mm3

           psrlw      mm0,2
           packuswb   mm0,mm4
           movd       es:[edi],mm0,2

           add        edi,4
@lp_bl32mx:
           movd       mm0,es:[edi-4],2
           movd       mm1,es:[edi+4],2
           punpcklbw  mm0,mm4
           punpcklbw  mm1,mm4
           movd       mm2,es:[edi],2
           paddusw    mm0,mm1
           punpcklbw  mm2,mm4
           movd       mm3,es:[edi+edx],2
           paddusw    mm0,mm2
           punpcklbw  mm3,mm4
           paddusw    mm0,mm3

           psrlw      mm0,2
           packuswb   mm0,mm4
           movd       es:[edi],mm0,2

           add   edi,4
           dec   ecx
           jnz   @lp_bl32mx

           movd       mm1,es:[edi-4],2
           movd       mm0,es:[edi],2
           punpcklbw  mm1,mm4
           punpcklbw  mm0,mm4
           psllw      mm0,1
           paddusw    mm0,mm1
           movd       mm3,es:[edi+edx],2
           punpcklbw  mm3,mm4
           paddusw    mm0,mm3

           psrlw      mm0,2
           packuswb   mm0,mm4
           movd       es:[edi],mm0,2

@end_bl32mx:
           emms
           ret
blur_32_mmx endp

fadered_32 proc
arg source:pword,dest:pword,count:dword,cover:byte
        les   edi,dest
        shr   count,2
        mov   edx,count
        jz    @end_cf32
        push  ds
        lds   esi,source
        xor   ah,ah
        mov   ch,cover
        mov   cl,ch
        neg   cl
        @lp_cf32:

          xor   eax,eax
          mov   bx,ax
          mul   cl
          mov   bl,ah
          mov   al,ds:[esi]
          mul   ch
          add   bl,ah

          mov   al,bh
          mul   cl
          mov   bh,ah
          mov   al,ds:[esi+1]
          mul   ch
          add   bh,ah
;          mov   es:[edi],bx
          ror   ebx,8

          mov   al,bh
          mul   cl
          mov   bh,ah
          mov   al,ds:[esi+2]
          mul   ch
          add   bh,ah
          rol   ebx,8
          mov   es:[edi],ebx

          add   esi,4
          add   edi,4
          dec   edx
        jnz   @lp_cf32
        pop   ds
@end_cf32:
        ret
fadered_32 endp

scaleup_8 proc
arg source:pword,dest:pword,tables:pword,count:dword,yval : dword
        mov   ecx,count
        or    ecx,ecx
        jz    @end_su8
        lfs   edx,source
        add   edx,yval
        push  ds
        lds   esi,tables
        les   edi,dest
        lp_su8:
          db 67h
          lodsd
          mov   al,fs:[eax+edx]
          db 67h
          stosb
          dec   ecx
        jnz   lp_su8
        pop   ds
@end_su8:
        ret
scaleup_8 endp

scaleup_1516 proc
arg source:pword,dest:pword,tables:pword,count:dword,yval : dword
        mov   ecx,count
        shr   ecx,1
        jz    @end_su16
        lfs   edx,source
        add   edx,yval
        push  ds
        lds   esi,tables
        les   edi,dest
        lp_su16:
          db 67h
          lodsd
          mov   ax,fs:[eax*2+edx]
          db 67h
          stosw
          dec   ecx
        jnz   lp_su16
        pop   ds
@end_su16:
        ret
scaleup_1516 endp

scaleup_24 proc
arg source:pword,dest:pword,tables:pword,count:dword,yval : dword
        mov   ecx,3
        mov   eax,count
        cdq
        div   ecx
        or    eax,eax
        jz    @end_su24
        mov   ecx,eax
        lfs   edx,source
        add   edx,yval
        push  ds
        lds   esi,tables
        les   edi,dest
        lp_su24:
          db 67h
          lodsd
          lea   eax,[eax*2+eax]
          mov   eax,fs:[eax+edx]
          mov   es:[edi],ax
          shr   eax,16
          mov   es:[edi+2],al
          add   edi,3
          dec   ecx
        jnz   lp_su24
        pop   ds
@end_su24:
        ret
scaleup_24 endp

scaleup_32 proc
arg source:pword,dest:pword,tables:pword,count:dword,yval : dword
        mov   ecx,count
        shr   ecx,2
        jz    @end_su32
        lfs   edx,source
        add   edx,yval
        push  ds
        lds   esi,tables
        les   edi,dest
        lp_su32:
          db 67h
          lodsd
          mov   eax,fs:[eax*4+edx]
          db 67h
          stosd
          dec   ecx
        jnz   lp_su32
        pop   ds
@end_su32:
        ret
scaleup_32 endp

dithmix_8 proc
arg source1:pword,source2:pword,dest:pword,sizex:dword,y : dword
        mov   ecx,sizex
        shr   ecx,1
        jz    @end_dm8
        les   edi,dest
        lfs   edx,source2
        push  ds
        lds   esi,source1
        test  y,1
        jz    @lp2_dm8
@lp1_dm8:
        mov   ah,fs:[edx+1]
        add   edx,2
        mov   al,ds:[esi]
        db 67h
        stosw
        add   esi,2
        dec   ecx
        jnz   @lp1_dm8
        pop   ds
        jmp   @end_dm8
@lp2_dm8:
        mov   ah,ds:[esi+1]
        add   esi,2
        mov   al,fs:[edx]
        db 67h
        stosw
        add   edx,2
        dec   ecx
        jnz   @lp2_dm8
        pop   ds
@end_dm8:
        ret
dithmix_8 endp

dithmix_1516 proc
arg source1:pword,source2:pword,dest:pword,sizex:dword,y : dword
        mov   ecx,sizex
        shr   ecx,1
        jz    @end_dm16
        les   edi,dest
        lfs   edx,source2
        push  ds
        lds   esi,source1
        test  y,1
        jz    @lp2_dm16
@lp1_dm16:
        mov   ax,fs:[edx+2]
        add   edx,4
        shl   eax,16
        mov   ax,ds:[esi]
        db 67h
        stosd
        add   esi,4
        dec   ecx
        jnz   @lp1_dm16
        pop   ds
        jmp   @end_dm16
@lp2_dm16:
        mov   ax,ds:[esi+2]
        add   esi,4
        shl   eax,16
        mov   ax,fs:[edx]
        db 67h
        stosd
        add   edx,4
        dec   ecx
        jnz   @lp2_dm16
        pop   ds
@end_dm16:
        ret
dithmix_1516 endp

dithmix_32 proc
arg source1:pword,source2:pword,dest:pword,sizex:dword,y : dword
        mov   ecx,sizex
        shr   ecx,1
        jz    @end_dm32
        les   edi,dest
        lfs   edx,source2
        push  ds
        lds   esi,source1
        test  y,1
        jz    @lp2_dm32
@lp1_dm32:
        mov   eax,ds:[esi]
        db 67h
        stosd
        mov   eax,fs:[edx+4]
        db 67h
        stosd
        add   esi,8
        add   edx,8
        dec   ecx
        jnz   @lp1_dm32
        pop   ds
        jmp   @end_dm32
@lp2_dm32:
        mov   eax,fs:[edx]
        db 67h
        stosd
        mov   eax,ds:[esi+4]
        db 67h
        stosd
        add   esi,8
        add   edx,8
        dec   ecx
        jnz   @lp2_dm32
        pop   ds
@end_dm32:
        ret
dithmix_32 endp

mirror_8 proc
arg source:pword,sizex:dword
        les   edi,source
        mov   ecx,sizex
        or    ecx,ecx
        jz    @end_mr8
        mov   esi,edi
        lea   edi,[edi+ecx-1]
        shr   ecx,1
        adc   ecx,0
@lp_mr8:
        mov   ax,es:[esi]
        mov   bx,es:[edi]
        mov   es:[edi],ax
        mov   es:[esi],bx
        inc   esi
        dec   edi
        dec   ecx
        jnz   @lp_mr8
@end_mr8:
        ret
mirror_8 endp

mirror_16 proc
arg source:pword,sizex:dword
        les   edi,source
        mov   ecx,sizex
        or    ecx,ecx
        jz    @end_mr16
        mov   esi,edi
        lea   edi,[edi+ecx*2-2]
        shr   ecx,1
        adc   ecx,0
@lp_mr16:
        mov   ax,es:[esi]
        mov   bx,es:[edi]
        mov   es:[edi],ax
        mov   es:[esi],bx
        add   esi,2
        sub   edi,2
        dec   ecx
        jnz   @lp_mr16
@end_mr16:
        ret
mirror_16 endp

mirror_24 proc
arg source:pword,sizex:dword
        les   edi,source
        mov   ecx,sizex
        or    ecx,ecx
        jz    @end_mr24
        mov   esi,edi
        add   edi,ecx
        shl   ecx,1
        add   edi,ecx
        sub   edi,3
        shr   ecx,2
        adc   ecx,0
@lp_mr24:
        mov   ax,es:[esi]
        mov   bx,es:[edi]
        mov   es:[edi],ax
        mov   es:[esi],bx
        mov   al,es:[esi+2]
        mov   bl,es:[edi+2]
        mov   es:[edi+2],al
        mov   es:[esi+2],bl
        add   esi,3
        sub   edi,3
        dec   ecx
        jnz   @lp_mr24
@end_mr24:
        ret
mirror_24 endp

mirror_32 proc
arg source:pword,sizex:dword
        les   edi,source
        mov   ecx,sizex
        or    ecx,ecx
        jz    @end_mr32
        mov   esi,edi
        lea   edi,[edi+ecx*4-4]
        shr   ecx,1
        adc   ecx,0
@lp_mr32:
        mov   eax,es:[esi]
        mov   ebx,es:[edi]
        mov   es:[edi],eax
        mov   es:[esi],ebx
        add   esi,4
        sub   edi,4
        dec   ecx
        jnz   @lp_mr32
@end_mr32:
        ret
mirror_32 endp

ends
end
